const wchar_t * const simp_to_trad[][2] = {
    { L"〇余", L"〇餘" },
    { L"〇只", L"〇隻" },
    { L"一个准", L"一個準" },
    { L"一争两丑", L"一爭兩醜" },
    { L"一伙", L"一夥" },
    { L"一余", L"一餘" },
    { L"一冲", L"一衝" },
    { L"一准", L"一準" },
    { L"一出子", L"一齣子" },
    { L"一划", L"一劃" },
    { L"一别头", L"一彆頭" },
    { L"一发千钧", L"一髮千鈞" },
    { L"一只", L"一隻" },
    { L"一吊", L"一弔" },
    { L"一哄而散", L"一鬨而散" },
    { L"一地里", L"一地裡" },
    { L"一天钟", L"一天鐘" },
    { L"一干二净", L"一乾二淨" },
    { L"一并", L"一併" },
    { L"一扎", L"一紮" },
    { L"一树百获", L"一樹百穫" },
    { L"一物克一物", L"一物剋一物" },
    { L"一锅面", L"一鍋麵" },
    { L"七余", L"七餘" },
    { L"七划", L"七劃" },
    { L"七只", L"七隻" },
    { L"七情六欲", L"七情六慾" },
    { L"七扎", L"七紮" },
    { L"万", L"萬" },
    { L"万余", L"萬餘" },
    { L"万俟", L"万俟" },
    { L"万历", L"萬曆" },
    { L"万只", L"萬隻" },
    { L"万年历表", L"萬年曆錶" },
    { L"万扎", L"萬紮" },
    { L"万旗", L"万旗" },
    { L"万签插架", L"萬籤插架" },
    { L"三余", L"三餘" },
    { L"三准", L"三準" },
    { L"三只", L"三隻" },
    { L"三复", L"三複" },
    { L"三征七辟", L"三徵七辟" },
    { L"三扎", L"三紮" },
    { L"三统历", L"三統曆" },
    { L"上梁", L"上樑" },
    { L"上签", L"上籤" },
    { L"上药", L"上藥" },
    { L"上课钟", L"上課鐘" },
    { L"下仑路", L"下崙路" },
    { L"下梁", L"下樑" },
    { L"下签", L"下籤" },
    { L"下药", L"下藥" },
    { L"下课钟", L"下課鐘" },
    { L"不丑", L"不醜" },
    { L"不克制", L"不剋制" },
    { L"不准", L"不準" },
    { L"不占", L"不佔" },
    { L"不吊", L"不弔" },
    { L"不寒而栗", L"不寒而慄" },
    { L"不干", L"不幹" },
    { L"不干不净", L"不乾不淨" },
    { L"不托", L"不託" },
    { L"不斗", L"不鬥" },
    { L"不药而愈", L"不藥而癒" },
    { L"不谷", L"不穀" },
    { L"不通吊庆", L"不通弔慶" },
    { L"不采", L"不採" },
    { L"不锈钢", L"不鏽鋼" },
    { L"不食干腊", L"不食乾腊" },
    { L"与", L"與" },
    { L"与克制", L"與剋制" },
    { L"丑丑", L"醜醜" },
    { L"丑丫头", L"醜丫頭" },
    { L"丑事", L"醜事" },
    { L"丑于", L"醜於" },
    { L"丑人", L"醜人" },
    { L"丑侪", L"醜儕" },
    { L"丑八怪", L"醜八怪" },
    { L"丑剌剌", L"醜剌剌" },
    { L"丑剧", L"醜劇" },
    { L"丑化", L"醜化" },
    { L"丑史", L"醜史" },
    { L"丑名", L"醜名" },
    { L"丑咤", L"醜吒" },
    { L"丑地", L"醜地" },
    { L"丑声", L"醜聲" },
    { L"丑头怪脸", L"醜頭怪臉" },
    { L"丑夷", L"醜夷" },
    { L"丑女", L"醜女" },
    { L"丑奴儿", L"醜奴兒" },
    { L"丑妇", L"醜婦" },
    { L"丑媳", L"醜媳" },
    { L"丑小鸭", L"醜小鴨" },
    { L"丑巴怪", L"醜巴怪" },
    { L"丑徒", L"醜徒" },
    { L"丑态", L"醜態" },
    { L"丑恶", L"醜惡" },
    { L"丑末", L"醜末" },
    { L"丑杂", L"醜雜" },
    { L"丑样", L"醜樣" },
    { L"丑死", L"醜死" },
    { L"丑比", L"醜比" },
    { L"丑毙了", L"醜斃了" },
    { L"丑沮", L"醜沮" },
    { L"丑男", L"醜男" },
    { L"丑类", L"醜類" },
    { L"丑脸", L"醜臉" },
    { L"丑虏", L"醜虜" },
    { L"丑行", L"醜行" },
    { L"丑言", L"醜言" },
    { L"丑诋", L"醜詆" },
    { L"丑话", L"醜話" },
    { L"丑语", L"醜語" },
    { L"丑贼生", L"醜賊生" },
    { L"丑辞", L"醜辭" },
    { L"丑辱", L"醜辱" },
    { L"丑逆", L"醜逆" },
    { L"丑闻", L"醜聞" },
    { L"丑陋", L"醜陋" },
    { L"专", L"專" },
    { L"专注", L"專註" },
    { L"专辑里", L"專輯裡" },
    { L"世界杯", L"世界盃" },
    { L"世界里", L"世界裡" },
    { L"世纪钟", L"世紀鐘" },
    { L"业", L"業" },
    { L"业余", L"業餘" },
    { L"丛", L"叢" },
    { L"东", L"東" },
    { L"东冲西突", L"東衝西突" },
    { L"东周钟", L"東周鐘" },
    { L"东岳", L"東嶽" },
    { L"东游", L"東遊" },
    { L"丝", L"絲" },
    { L"丝发", L"絲髮" },
    { L"丝恩发怨", L"絲恩髮怨" },
    { L"丢", L"丟" },
    { L"丢丑", L"丟醜" },
    { L"两", L"兩" },
    { L"两余", L"兩餘" },
    { L"两只", L"兩隻" },
    { L"两天晒网", L"兩天晒網" },
    { L"两扎", L"兩紮" },
    { L"两虎共斗", L"兩虎共鬥" },
    { L"两鼠斗穴", L"兩鼠鬥穴" },
    { L"严", L"嚴" },
    { L"丧", L"喪" },
    { L"丧钟", L"喪鐘" },
    { L"个", L"個" },
    { L"个中原因", L"箇中原因" },
    { L"个中奥妙", L"箇中奧妙" },
    { L"个中奥秘", L"箇中奧秘" },
    { L"个中好手", L"箇中好手" },
    { L"个中强手", L"箇中強手" },
    { L"个中消息", L"箇中消息" },
    { L"个中滋味", L"箇中滋味" },
    { L"个中玄机", L"箇中玄機" },
    { L"个中理由", L"箇中理由" },
    { L"个中讯息", L"箇中訊息" },
    { L"个中资讯", L"箇中資訊" },
    { L"个中高手", L"箇中高手" },
    { L"个旧", L"箇舊" },
    { L"个里", L"個裡" },
    { L"个钟", L"個鐘" },
    { L"个钟表", L"個鐘錶" },
    { L"中仑", L"中崙" },
    { L"中型钟", L"中型鐘" },
    { L"中岳", L"中嶽" },
    { L"中文里", L"中文裡" },
    { L"中签", L"中籤" },
    { L"中药", L"中藥" },
    { L"丰", L"豐" },
    { L"丰仪", L"丰儀" },
    { L"丰儀", L"丰儀" },
    { L"丰南", L"丰南" },
    { L"丰台", L"丰台" },
    { L"丰姿", L"丰姿" },
    { L"丰容", L"丰容" },
    { L"丰度", L"丰度" },
    { L"丰情", L"丰情" },
    { L"丰标", L"丰標" },
    { L"丰標不凡", L"丰標不凡" },
    { L"丰神", L"丰神" },
    { L"丰茸", L"丰茸" },
    { L"丰采", L"丰采" },
    { L"丰韵", L"丰韻" },
    { L"丰韻", L"丰韻" },
    { L"临", L"臨" },
    { L"临潼斗宝", L"臨潼鬥寶" },
    { L"丸药", L"丸藥" },
    { L"丹药", L"丹藥" },
    { L"为", L"為" },
    { L"为准", L"為準" },
    { L"为着", L"為著" },
    { L"主仆", L"主僕" },
    { L"主干", L"主幹" },
    { L"主钟曲线", L"主鐘曲線" },
    { L"丽", L"麗" },
    { L"举", L"舉" },
    { L"么么小丑", L"么麼小丑" },
    { L"义", L"義" },
    { L"义仆", L"義僕" },
    { L"义占", L"義佔" },
    { L"义庄", L"義莊" },
    { L"之余", L"之餘" },
    { L"之征", L"之徵" },
    { L"之托", L"之託" },
    { L"之钟", L"之鐘" },
    { L"乌", L"烏" },
    { L"乌发", L"烏髮" },
    { L"乌龙面", L"烏龍麵" },
    { L"乐", L"樂" },
    { L"乐器钟", L"樂器鐘" },
    { L"乔", L"喬" },
    { L"乔岳", L"喬嶽" },
    { L"九世之仇", L"九世之讎" },
    { L"九余", L"九餘" },
    { L"九划", L"九劃" },
    { L"九只", L"九隻" },
    { L"九扎", L"九紮" },
    { L"九谷", L"九穀" },
    { L"也克制", L"也剋制" },
    { L"习", L"習" },
    { L"乡", L"鄉" },
    { L"乡愿", L"鄉愿" },
    { L"书", L"書" },
    { L"书签", L"書籤" },
    { L"买", L"買" },
    { L"买凶", L"買兇" },
    { L"乱", L"亂" },
    { L"乱发", L"亂髮" },
    { L"乱哄", L"亂鬨" },
    { L"乾象历", L"乾象曆" },
    { L"了克制", L"了剋制" },
    { L"了望", L"瞭望" },
    { L"了然", L"瞭然" },
    { L"了若指掌", L"瞭若指掌" },
    { L"争", L"爭" },
    { L"争奇斗妍", L"爭奇鬥妍" },
    { L"争奇斗异", L"爭奇鬥異" },
    { L"争妍斗奇", L"爭妍鬥奇" },
    { L"争斗", L"爭鬥" },
    { L"争红斗紫", L"爭紅鬥紫" },
    { L"事迹", L"事迹" },
    { L"二仑", L"二崙" },
    { L"二余", L"二餘" },
    { L"二划", L"二劃" },
    { L"二只", L"二隻" },
    { L"二缶钟惑", L"二缶鐘惑" },
    { L"于", L"於" },
    { L"于丑", L"於醜" },
    { L"于丹", L"于丹" },
    { L"于于", L"于于" },
    { L"于仁泰", L"于仁泰" },
    { L"于从濂", L"于從濂" },
    { L"于会泳", L"于會泳" },
    { L"于伟国", L"于偉國" },
    { L"于余曲折", L"于餘曲折" },
    { L"于佳卉", L"于佳卉" },
    { L"于偉國", L"于偉國" },
    { L"于光远", L"于光遠" },
    { L"于光遠", L"于光遠" },
    { L"于克制", L"於剋制" },
    { L"于克勒", L"于克勒" },
    { L"于冕", L"于冕" },
    { L"于军", L"于軍" },
    { L"于凌奎", L"于凌奎" },
    { L"于凤桐", L"于鳳桐" },
    { L"于凤至", L"于鳳至" },
    { L"于勒", L"于勒" },
    { L"于化虎", L"于化虎" },
    { L"于占元", L"于占元" },
    { L"于双戈", L"于雙戈" },
    { L"于台烟", L"于台煙" },
    { L"于台煙", L"于台煙" },
    { L"于右任", L"于右任" },
    { L"于吉", L"于吉" },
    { L"于品海", L"于品海" },
    { L"于国桢", L"于國楨" },
    { L"于國楨", L"于國楨" },
    { L"于坏", L"於坏" },
    { L"于坚", L"于堅" },
    { L"于堅", L"于堅" },
    { L"于大宝", L"于大寶" },
    { L"于大寶", L"于大寶" },
    { L"于天仁", L"于天仁" },
    { L"于奇库杜克", L"于奇庫杜克" },
    { L"于奇庫杜克", L"于奇庫杜克" },
    { L"于姓", L"于姓" },
    { L"于娜", L"于娜" },
    { L"于娟", L"于娟" },
    { L"于子千", L"于子千" },
    { L"于孔兼", L"于孔兼" },
    { L"于学忠", L"于學忠" },
    { L"于學忠", L"于學忠" },
    { L"于家堡", L"于家堡" },
    { L"于寘", L"于寘" },
    { L"于小伟", L"于小偉" },
    { L"于小偉", L"于小偉" },
    { L"于小彤", L"于小彤" },
    { L"于尔岑", L"于爾岑" },
    { L"于尔根", L"于爾根" },
    { L"于尔里克", L"于爾里克" },
    { L"于山", L"于山" },
    { L"于帅", L"于帥" },
    { L"于帥", L"于帥" },
    { L"于幼军", L"于幼軍" },
    { L"于幼軍", L"于幼軍" },
    { L"于广洲", L"于廣洲" },
    { L"于康震", L"于康震" },
    { L"于廣洲", L"于廣洲" },
    { L"于式枚", L"于式枚" },
    { L"于归", L"于歸" },
    { L"于征", L"於徵" },
    { L"于從濂", L"于從濂" },
    { L"于德海", L"于德海" },
    { L"于志宁", L"于志寧" },
    { L"于志寧", L"于志寧" },
    { L"于思", L"于思" },
    { L"于慎行", L"于慎行" },
    { L"于慧", L"于慧" },
    { L"于成龍", L"于成龍" },
    { L"于成龙", L"于成龍" },
    { L"于振", L"于振" },
    { L"于敏", L"于敏" },
    { L"于斌", L"于斌" },
    { L"于斯塔德", L"于斯塔德" },
    { L"于斯达尔", L"于斯達爾" },
    { L"于斯達爾", L"于斯達爾" },
    { L"于明涛", L"于明濤" },
    { L"于明濤", L"于明濤" },
    { L"于是之", L"于是之" },
    { L"于晨楠", L"于晨楠" },
    { L"于晴", L"于晴" },
    { L"于會泳", L"于會泳" },
    { L"于树洁", L"于樹潔" },
    { L"于根伟", L"于根偉" },
    { L"于根偉", L"于根偉" },
    { L"于格", L"于格" },
    { L"于樂", L"于樂" },
    { L"于樹潔", L"于樹潔" },
    { L"于欣源", L"于欣源" },
    { L"于正升", L"于正昇" },
    { L"于正昇", L"于正昇" },
    { L"于正昌", L"于正昌" },
    { L"于永波", L"于永波" },
    { L"于汉超", L"于漢超" },
    { L"于江震", L"于江震" },
    { L"于波", L"于波" },
    { L"于泽尔", L"于澤爾" },
    { L"于洪区", L"于洪區" },
    { L"于洪區", L"于洪區" },
    { L"于浩威", L"于浩威" },
    { L"于海洋", L"于海洋" },
    { L"于涛", L"于濤" },
    { L"于湘兰", L"于湘蘭" },
    { L"于湘蘭", L"于湘蘭" },
    { L"于漢超", L"于漢超" },
    { L"于澤爾", L"于澤爾" },
    { L"于濤", L"于濤" },
    { L"于爾岑", L"于爾岑" },
    { L"于爾根", L"于爾根" },
    { L"于爾里克", L"于爾里克" },
    { L"于特森", L"于特森" },
    { L"于玉立", L"于玉立" },
    { L"于田", L"于田" },
    { L"于禁", L"于禁" },
    { L"于秀敏", L"于秀敏" },
    { L"于素秋", L"于素秋" },
    { L"于美人", L"于美人" },
    { L"于若木", L"于若木" },
    { L"于荫霖", L"于蔭霖" },
    { L"于蔭霖", L"于蔭霖" },
    { L"于衡", L"于衡" },
    { L"于西翰", L"于西翰" },
    { L"于謙", L"于謙" },
    { L"于谦", L"于謙" },
    { L"于貝爾", L"于貝爾" },
    { L"于贈", L"于贈" },
    { L"于贝尔", L"于貝爾" },
    { L"于赠", L"于贈" },
    { L"于越", L"于越" },
    { L"于軍", L"于軍" },
    { L"于远伟", L"于遠偉" },
    { L"于道泉", L"于道泉" },
    { L"于遠偉", L"于遠偉" },
    { L"于都县", L"于都縣" },
    { L"于都縣", L"于都縣" },
    { L"于里察", L"于里察" },
    { L"于阗", L"于闐" },
    { L"于雙戈", L"于雙戈" },
    { L"于震寰", L"于震寰" },
    { L"于震环", L"于震環" },
    { L"于震環", L"于震環" },
    { L"于靖", L"于靖" },
    { L"于非闇", L"于非闇" },
    { L"于韋斯屈萊", L"于韋斯屈萊" },
    { L"于韦斯屈莱", L"于韋斯屈萊" },
    { L"于風政", L"于風政" },
    { L"于风政", L"于風政" },
    { L"于飞", L"于飛" },
    { L"于鳳桐", L"于鳳桐" },
    { L"于鳳至", L"于鳳至" },
    { L"于默奥", L"于默奧" },
    { L"于默奧", L"于默奧" },
    { L"亏", L"虧" },
    { L"云", L"雲" },
    { L"云为", L"云為" },
    { L"云乎", L"云乎" },
    { L"云云", L"云云" },
    { L"云何", L"云何" },
    { L"云南白药", L"雲南白藥" },
    { L"云尔", L"云爾" },
    { L"云游", L"雲遊" },
    { L"云為", L"云為" },
    { L"云然", L"云然" },
    { L"云笈七签", L"雲笈七籤" },
    { L"云须", L"雲鬚" },
    { L"五余", L"五餘" },
    { L"五出", L"五齣" },
    { L"五划", L"五劃" },
    { L"五只", L"五隻" },
    { L"五岳", L"五嶽" },
    { L"五扎", L"五紮" },
    { L"五行生克", L"五行生剋" },
    { L"五谷", L"五穀" },
    { L"井干摧败", L"井榦摧敗" },
    { L"井里", L"井裡" },
    { L"亚", L"亞" },
    { L"亚美尼亚历", L"亞美尼亞曆" },
    { L"交哄", L"交鬨" },
    { L"交托", L"交託" },
    { L"交游", L"交遊" },
    { L"亦云", L"亦云" },
    { L"亦庄亦谐", L"亦莊亦諧" },
    { L"产", L"產" },
    { L"亩", L"畝" },
    { L"亮丑", L"亮醜" },
    { L"亮钟", L"亮鐘" },
    { L"亲", L"親" },
    { L"亵", L"褻" },
    { L"人云", L"人云" },
    { L"人参", L"人蔘" },
    { L"人欲", L"人慾" },
    { L"人物志", L"人物誌" },
    { L"亿", L"億" },
    { L"亿余", L"億餘" },
    { L"亿只", L"億隻" },
    { L"什么", L"什麼" },
    { L"什锦面", L"什錦麵" },
    { L"仅", L"僅" },
    { L"仆人", L"僕人" },
    { L"仆仆", L"僕僕" },
    { L"仆从", L"僕從" },
    { L"仆使", L"僕使" },
    { L"仆僮", L"僕僮" },
    { L"仆吏", L"僕吏" },
    { L"仆固怀恩", L"僕固懷恩" },
    { L"仆夫", L"僕夫" },
    { L"仆妇", L"僕婦" },
    { L"仆姑", L"僕姑" },
    { L"仆婢", L"僕婢" },
    { L"仆射", L"僕射" },
    { L"仆少", L"僕少" },
    { L"仆役", L"僕役" },
    { L"仆憎", L"僕憎" },
    { L"仆欧", L"僕歐" },
    { L"仆程", L"僕程" },
    { L"仆虽罢驽", L"僕雖罷駑" },
    { L"仇仇", L"仇讎" },
    { L"仇問", L"讎問" },
    { L"仇夷", L"讎夷" },
    { L"仇校", L"讎校" },
    { L"仇正", L"讎正" },
    { L"仇隙", L"讎隙" },
    { L"从", L"從" },
    { L"从里到外", L"從裡到外" },
    { L"从里向外", L"從裡向外" },
    { L"仑", L"侖" },
    { L"仑背", L"崙背" },
    { L"仓", L"倉" },
    { L"他克制", L"他剋制" },
    { L"他钟", L"他鐘" },
    { L"付托", L"付託" },
    { L"仙后", L"仙后" },
    { L"仙药", L"仙藥" },
    { L"仪", L"儀" },
    { L"仪范", L"儀範" },
    { L"仪表", L"儀錶" },
    { L"们", L"們" },
    { L"们克制", L"們剋制" },
    { L"仰药", L"仰藥" },
    { L"件钟", L"件鐘" },
    { L"价", L"價" },
    { L"任何表", L"任何錶" },
    { L"任何钟", L"任何鐘" },
    { L"仿佛", L"彷彿" },
    { L"仿制", L"仿製" },
    { L"企划", L"企劃" },
    { L"伊于湖底", L"伊于湖底" },
    { L"伊府面", L"伊府麵" },
    { L"伊斯兰历", L"伊斯蘭曆" },
    { L"伊斯兰教历", L"伊斯蘭教曆" },
    { L"伊郁", L"伊鬱" },
    { L"伏几", L"伏几" },
    { L"休征", L"休徵" },
    { L"众", L"眾" },
    { L"优", L"優" },
    { L"优游", L"優遊" },
    { L"伙众", L"夥眾" },
    { L"伙伴", L"夥伴" },
    { L"伙友", L"夥友" },
    { L"伙同", L"夥同" },
    { L"伙计", L"夥計" },
    { L"会", L"會" },
    { L"会占", L"會佔" },
    { L"会吊", L"會弔" },
    { L"会干", L"會幹" },
    { L"会里", L"會裡" },
    { L"伛", L"傴" },
    { L"伞", L"傘" },
    { L"伟", L"偉" },
    { L"传", L"傳" },
    { L"传位于四太子", L"傳位于四太子" },
    { L"伤", L"傷" },
    { L"伤痕累累", L"傷痕纍纍" },
    { L"伥", L"倀" },
    { L"伦", L"倫" },
    { L"伧", L"傖" },
    { L"伪", L"偽" },
    { L"伪药", L"偽藥" },
    { L"伫", L"佇" },
    { L"伴游", L"伴遊" },
    { L"但云", L"但云" },
    { L"位准", L"位準" },
    { L"低洼", L"低洼" },
    { L"住扎", L"住紮" },
    { L"体", L"體" },
    { L"体范", L"體範" },
    { L"余〇", L"餘〇" },
    { L"余一", L"餘一" },
    { L"余七", L"餘七" },
    { L"余三", L"餘三" },
    { L"余下", L"餘下" },
    { L"余业", L"餘業" },
    { L"余九", L"餘九" },
    { L"余事", L"餘事" },
    { L"余二", L"餘二" },
    { L"余五", L"餘五" },
    { L"余人", L"餘人" },
    { L"余众", L"餘眾" },
    { L"余俗", L"餘俗" },
    { L"余倍", L"餘倍" },
    { L"余僇", L"餘僇" },
    { L"余光", L"餘光" },
    { L"余党", L"餘黨" },
    { L"余八", L"餘八" },
    { L"余六", L"餘六" },
    { L"余兴", L"餘興" },
    { L"余刃", L"餘刃" },
    { L"余切", L"餘切" },
    { L"余利", L"餘利" },
    { L"余割", L"餘割" },
    { L"余力", L"餘力" },
    { L"余勇", L"餘勇" },
    { L"余十", L"餘十" },
    { L"余味", L"餘味" },
    { L"余响", L"餘響" },
    { L"余喘", L"餘喘" },
    { L"余四", L"餘四" },
    { L"余地", L"餘地" },
    { L"余墨", L"餘墨" },
    { L"余声", L"餘聲" },
    { L"余外", L"餘外" },
    { L"余妙", L"餘妙" },
    { L"余姚", L"餘姚" },
    { L"余威", L"餘威" },
    { L"余子", L"餘子" },
    { L"余存", L"餘存" },
    { L"余孽", L"餘孽" },
    { L"余庆", L"餘慶" },
    { L"余弦", L"餘弦" },
    { L"余思", L"餘思" },
    { L"余悸", L"餘悸" },
    { L"余数", L"餘數" },
    { L"余明", L"餘明" },
    { L"余映", L"餘映" },
    { L"余晖", L"餘暉" },
    { L"余暇", L"餘暇" },
    { L"余杭", L"餘杭" },
    { L"余杯", L"餘杯" },
    { L"余桃", L"餘桃" },
    { L"余桶", L"餘桶" },
    { L"余款", L"餘款" },
    { L"余步", L"餘步" },
    { L"余殃", L"餘殃" },
    { L"余毒", L"餘毒" },
    { L"余气", L"餘氣" },
    { L"余沥", L"餘瀝" },
    { L"余波", L"餘波" },
    { L"余波荡漾", L"餘波盪漾" },
    { L"余泽", L"餘澤" },
    { L"余温", L"餘溫" },
    { L"余烈", L"餘烈" },
    { L"余烬", L"餘燼" },
    { L"余热", L"餘熱" },
    { L"余珍", L"餘珍" },
    { L"余生", L"餘生" },
    { L"余窍", L"餘竅" },
    { L"余粮", L"餘糧" },
    { L"余绪", L"餘緒" },
    { L"余缺", L"餘缺" },
    { L"余罪", L"餘罪" },
    { L"余羡", L"餘羨" },
    { L"余膏", L"餘膏" },
    { L"余荫", L"餘蔭" },
    { L"余蓄", L"餘蓄" },
    { L"余裕", L"餘裕" },
    { L"余角", L"餘角" },
    { L"余论", L"餘論" },
    { L"余貾", L"餘貾" },
    { L"余责", L"餘責" },
    { L"余辉", L"餘輝" },
    { L"余辜", L"餘辜" },
    { L"余酲", L"餘酲" },
    { L"余闰", L"餘閏" },
    { L"余闲", L"餘閒" },
    { L"余零", L"餘零" },
    { L"余震", L"餘震" },
    { L"余霞", L"餘霞" },
    { L"余音", L"餘音" },
    { L"余音绕梁", L"餘音繞梁" },
    { L"余韵", L"餘韻" },
    { L"余额", L"餘額" },
    { L"余风", L"餘風" },
    { L"余食", L"餘食" },
    { L"佛罗棱萨", L"佛羅稜薩" },
    { L"佛钟", L"佛鐘" },
    { L"作准", L"作準" },
    { L"作品里", L"作品裡" },
    { L"作奸犯科", L"作姦犯科" },
    { L"作庄", L"作莊" },
    { L"你克制", L"你剋制" },
    { L"你才子发昏", L"你纔子發昏" },
    { L"佣中佼佼", L"傭中佼佼" },
    { L"佣书", L"傭書" },
    { L"佣人", L"傭人" },
    { L"佣仆", L"傭僕" },
    { L"佣兵", L"傭兵" },
    { L"佣工", L"傭工" },
    { L"佣懒", L"傭懶" },
    { L"佣金", L"傭金" },
    { L"佥", L"僉" },
    { L"佳肴", L"佳肴" },
    { L"使其斗", L"使其鬥" },
    { L"侍仆", L"侍僕" },
    { L"供制", L"供製" },
    { L"依依不舍", L"依依不捨" },
    { L"依托", L"依託" },
    { L"侠", L"俠" },
    { L"侣", L"侶" },
    { L"侥", L"僥" },
    { L"侥幸", L"僥倖" },
    { L"侦", L"偵" },
    { L"侧", L"側" },
    { L"侨", L"僑" },
    { L"侩", L"儈" },
    { L"侪", L"儕" },
    { L"侬", L"儂" },
    { L"侵占", L"侵佔" },
    { L"侵并", L"侵併" },
    { L"便药", L"便藥" },
    { L"俄占", L"俄佔" },
    { L"保险柜", L"保險柜" },
    { L"信托", L"信託" },
    { L"俣", L"俁" },
    { L"俦", L"儔" },
    { L"俨", L"儼" },
    { L"俩", L"倆" },
    { L"俪", L"儷" },
    { L"俭", L"儉" },
    { L"俭仆", L"儉僕" },
    { L"俭朴", L"儉樸" },
    { L"俭确之教", L"儉确之教" },
    { L"修杰楷", L"修杰楷" },
    { L"修炼", L"修鍊" },
    { L"修胡刀", L"修鬍刀" },
    { L"俯冲", L"俯衝" },
    { L"倒绷孩儿", L"倒繃孩兒" },
    { L"倛丑", L"倛醜" },
    { L"借以", L"藉以" },
    { L"借助", L"藉助" },
    { L"借寇兵", L"藉寇兵" },
    { L"借手", L"藉手" },
    { L"借机", L"藉機" },
    { L"借此", L"藉此" },
    { L"借由", L"藉由" },
    { L"借着", L"藉著" },
    { L"借箸代筹", L"藉箸代籌" },
    { L"借资", L"藉資" },
    { L"倦游", L"倦遊" },
    { L"债", L"債" },
    { L"倾", L"傾" },
    { L"倾复", L"傾複" },
    { L"假发", L"假髮" },
    { L"假托", L"假託" },
    { L"假药", L"假藥" },
    { L"偎干", L"偎乾" },
    { L"做庄", L"做莊" },
    { L"停制", L"停製" },
    { L"停征", L"停徵" },
    { L"偬", L"傯" },
    { L"偷鸡不着", L"偷雞不著" },
    { L"偻", L"僂" },
    { L"偾", L"僨" },
    { L"偿", L"償" },
    { L"傥", L"儻" },
    { L"傧", L"儐" },
    { L"储", L"儲" },
    { L"傩", L"儺" },
    { L"催并", L"催併" },
    { L"傲霜斗雪", L"傲霜鬥雪" },
    { L"傻里傻气", L"傻裡傻氣" },
    { L"僮仆", L"僮僕" },
    { L"僵尸", L"殭屍" },
    { L"儒略历", L"儒略曆" },
    { L"儒略改革历", L"儒略改革曆" },
    { L"儿", L"兒" },
    { L"兀术", L"兀朮" },
    { L"元凶", L"元兇" },
    { L"充饥", L"充饑" },
    { L"兆余", L"兆餘" },
    { L"先占", L"先佔" },
    { L"先采", L"先採" },
    { L"光致致", L"光緻緻" },
    { L"克制不了", L"剋制不了" },
    { L"克制不住", L"剋制不住" },
    { L"克复", L"克複" },
    { L"克扣", L"剋扣" },
    { L"克星", L"剋星" },
    { L"克期", L"剋期" },
    { L"克死", L"剋死" },
    { L"克药", L"克藥" },
    { L"克薄", L"剋薄" },
    { L"免征", L"免徵" },
    { L"兑", L"兌" },
    { L"兖", L"兗" },
    { L"党", L"黨" },
    { L"党参", L"党參" },
    { L"党太尉", L"党太尉" },
    { L"党怀英", L"党懷英" },
    { L"党进", L"党進" },
    { L"党項", L"党項" },
    { L"党项", L"党項" },
    { L"全干", L"全乾" },
    { L"八余", L"八餘" },
    { L"八只", L"八隻" },
    { L"八字胡", L"八字鬍" },
    { L"八扎", L"八紮" },
    { L"八蜡", L"八蜡" },
    { L"公仆", L"公僕" },
    { L"公仔面", L"公仔麵" },
    { L"公余", L"公餘" },
    { L"公历", L"公曆" },
    { L"公厘", L"公釐" },
    { L"公干", L"公幹" },
    { L"六余", L"六餘" },
    { L"六冲", L"六衝" },
    { L"六出", L"六齣" },
    { L"六划", L"六劃" },
    { L"六只", L"六隻" },
    { L"六扎", L"六紮" },
    { L"六谷", L"六穀" },
    { L"兰", L"蘭" },
    { L"共和历", L"共和曆" },
    { L"关", L"關" },
    { L"关弓与我确", L"關弓與我确" },
    { L"关系", L"關係" },
    { L"关系着", L"關係著" },
    { L"兴", L"興" },
    { L"兴致", L"興緻" },
    { L"其余", L"其餘" },
    { L"典范", L"典範" },
    { L"兹", L"茲" },
    { L"养", L"養" },
    { L"兼并", L"兼并" },
    { L"兽", L"獸" },
    { L"兽欲", L"獸慾" },
    { L"冁", L"囅" },
    { L"内", L"內" },
    { L"内制", L"內製" },
    { L"内哄", L"內鬨" },
    { L"内斗", L"內鬥" },
    { L"冈", L"岡" },
    { L"册", L"冊" },
    { L"冗余", L"冗餘" },
    { L"写", L"寫" },
    { L"写字台", L"寫字檯" },
    { L"军", L"軍" },
    { L"军队克制", L"軍隊剋制" },
    { L"农", L"農" },
    { L"农历", L"農曆" },
    { L"农庄", L"農莊" },
    { L"农民历", L"農民曆" },
    { L"农药", L"農藥" },
    { L"冤仇", L"冤讎" },
    { L"冥蒙", L"冥濛" },
    { L"冬冬鼓", L"鼕鼕鼓" },
    { L"冬天里", L"冬天裡" },
    { L"冬日里", L"冬日裡" },
    { L"冬游", L"冬遊" },
    { L"冯", L"馮" },
    { L"冲", L"沖" },
    { L"冲上", L"衝上" },
    { L"冲下", L"衝下" },
    { L"冲倒", L"衝倒" },
    { L"冲克", L"衝剋" },
    { L"冲冠", L"衝冠" },
    { L"冲冠发怒", L"沖冠髮怒" },
    { L"冲决", L"衝決" },
    { L"冲出", L"衝出" },
    { L"冲击", L"衝擊" },
    { L"冲到", L"衝到" },
    { L"冲刺", L"衝刺" },
    { L"冲力", L"衝力" },
    { L"冲动", L"衝動" },
    { L"冲劲", L"衝勁" },
    { L"冲压", L"衝壓" },
    { L"冲去", L"衝去" },
    { L"冲口", L"衝口" },
    { L"冲坚陷阵", L"衝堅陷陣" },
    { L"冲垮", L"衝垮" },
    { L"冲堂", L"衝堂" },
    { L"冲天", L"衝天" },
    { L"冲头阵", L"衝頭陣" },
    { L"冲州撞府", L"衝州撞府" },
    { L"冲心", L"衝心" },
    { L"冲掉", L"衝掉" },
    { L"冲撞", L"衝撞" },
    { L"冲散", L"衝散" },
    { L"冲杀", L"衝殺" },
    { L"冲来", L"衝來" },
    { L"冲波", L"衝波" },
    { L"冲浪", L"衝浪" },
    { L"冲激", L"衝激" },
    { L"冲然", L"衝然" },
    { L"冲盹", L"衝盹" },
    { L"冲着", L"衝著" },
    { L"冲破", L"衝破" },
    { L"冲程", L"衝程" },
    { L"冲突", L"衝突" },
    { L"冲线", L"衝線" },
    { L"冲要", L"衝要" },
    { L"冲起", L"衝起" },
    { L"冲车", L"衝車" },
    { L"冲过", L"衝過" },
    { L"冲进", L"衝進" },
    { L"冲量", L"衝量" },
    { L"冲锋", L"衝鋒" },
    { L"冲陷", L"衝陷" },
    { L"冲风", L"衝風" },
    { L"决", L"決" },
    { L"决斗", L"決鬥" },
    { L"况", L"況" },
    { L"冶游", L"冶遊" },
    { L"冷面", L"冷麵" },
    { L"冻", L"凍" },
    { L"净", L"凈" },
    { L"净余", L"淨餘" },
    { L"净发", L"淨髮" },
    { L"准三后", L"准三后" },
    { L"准不准", L"準不準" },
    { L"准会", L"準會" },
    { L"准例", L"準例" },
    { L"准保", L"準保" },
    { L"准儿", L"準兒" },
    { L"准决赛", L"準決賽" },
    { L"准分子", L"準分子" },
    { L"准则", L"準則" },
    { L"准噶尔", L"準噶爾" },
    { L"准备", L"準備" },
    { L"准头", L"準頭" },
    { L"准定", L"準定" },
    { L"准平原", L"準平原" },
    { L"准度", L"準度" },
    { L"准式", L"準式" },
    { L"准拟", L"準擬" },
    { L"准拿督", L"準拿督" },
    { L"准据", L"準據" },
    { L"准新娘", L"準新娘" },
    { L"准新郎", L"準新郎" },
    { L"准时", L"準時" },
    { L"准星", L"準星" },
    { L"准是", L"準是" },
    { L"准点", L"準點" },
    { L"准的", L"準的" },
    { L"准确", L"準確" },
    { L"准线", L"準線" },
    { L"准绳", L"準繩" },
    { L"准话", L"準話" },
    { L"准谱", L"準譜" },
    { L"准货币", L"準貨幣" },
    { L"凉", L"涼" },
    { L"凉面", L"涼麵" },
    { L"凌蒙初", L"凌濛初" },
    { L"减", L"減" },
    { L"减肥药", L"減肥藥" },
    { L"凑", L"湊" },
    { L"凛", L"凜" },
    { L"凝炼", L"凝鍊" },
    { L"几", L"幾" },
    { L"几上", L"几上" },
    { L"几丝", L"几絲" },
    { L"几净窗明", L"几淨窗明" },
    { L"几几", L"几几" },
    { L"几凳", L"几凳" },
    { L"几出", L"幾齣" },
    { L"几划", L"幾劃" },
    { L"几只", L"幾隻" },
    { L"几子", L"几子" },
    { L"几旁", L"几旁" },
    { L"几杖", L"几杖" },
    { L"几案", L"几案" },
    { L"几椅", L"几椅" },
    { L"几榻", L"几榻" },
    { L"几筵", L"几筵" },
    { L"几面上", L"几面上" },
    { L"凤", L"鳳" },
    { L"凫", L"鳧" },
    { L"凭", L"憑" },
    { L"凭借", L"憑藉" },
    { L"凭借着", L"憑藉著" },
    { L"凭准", L"憑準" },
    { L"凭几", L"憑几" },
    { L"凭吊", L"憑弔" },
    { L"凭折", L"憑摺" },
    { L"凯", L"凱" },
    { L"凶刀", L"兇刀" },
    { L"凶器", L"兇器" },
    { L"凶嫌", L"兇嫌" },
    { L"凶巴巴", L"兇巴巴" },
    { L"凶徒", L"兇徒" },
    { L"凶恶", L"兇惡" },
    { L"凶悍", L"兇悍" },
    { L"凶手", L"兇手" },
    { L"凶杀", L"兇殺" },
    { L"凶枪", L"兇槍" },
    { L"凶案", L"兇案" },
    { L"凶横", L"兇橫" },
    { L"凶残", L"兇殘" },
    { L"凶殘", L"兇殘" },
    { L"凶殺", L"兇殺" },
    { L"凶犯", L"兇犯" },
    { L"凶狠", L"兇狠" },
    { L"凶猛", L"兇猛" },
    { L"凶疑", L"兇疑" },
    { L"凶相", L"兇相" },
    { L"凶险", L"兇險" },
    { L"凹洞里", L"凹洞裡" },
    { L"出丑", L"出醜" },
    { L"出儿", L"齣兒" },
    { L"出剧", L"齣劇" },
    { L"出动画", L"齣動畫" },
    { L"出卡通", L"齣卡通" },
    { L"出戏", L"齣戲" },
    { L"出游", L"出遊" },
    { L"出电影", L"齣電影" },
    { L"出电视", L"齣電視" },
    { L"出节目", L"齣節目" },
    { L"出谋划策", L"出謀劃策" },
    { L"出锤", L"出鎚" },
    { L"击", L"擊" },
    { L"击扑", L"擊扑" },
    { L"击钟", L"擊鐘" },
    { L"凿", L"鑿" },
    { L"分别致", L"分别致" },
    { L"分半钟", L"分半鐘" },
    { L"分占", L"分佔" },
    { L"分多钟", L"分多鐘" },
    { L"分子钟", L"分子鐘" },
    { L"分钟", L"分鐘" },
    { L"刍", L"芻" },
    { L"刑余", L"刑餘" },
    { L"划一", L"劃一" },
    { L"划上", L"劃上" },
    { L"划下", L"劃下" },
    { L"划为", L"劃為" },
    { L"划了", L"劃了" },
    { L"划入", L"劃入" },
    { L"划出", L"劃出" },
    { L"划分", L"劃分" },
    { L"划划", L"劃劃" },
    { L"划到", L"劃到" },
    { L"划去", L"劃去" },
    { L"划在", L"劃在" },
    { L"划地", L"劃地" },
    { L"划定", L"劃定" },
    { L"划开", L"劃開" },
    { L"划归", L"劃歸" },
    { L"划得", L"劃得" },
    { L"划成", L"劃成" },
    { L"划拨", L"劃撥" },
    { L"划掉", L"劃掉" },
    { L"划时代", L"劃時代" },
    { L"划款", L"劃款" },
    { L"划法", L"劃法" },
    { L"划清", L"劃清" },
    { L"划界", L"劃界" },
    { L"划着", L"划著" },
    { L"划破", L"劃破" },
    { L"划线", L"劃線" },
    { L"划足", L"劃足" },
    { L"划过", L"劃過" },
    { L"刘", L"劉" },
    { L"刘克庄", L"劉克莊" },
    { L"则", L"則" },
    { L"刚", L"剛" },
    { L"刚干", L"剛乾" },
    { L"刚才一载", L"剛纔一載" },
    { L"刚雇", L"剛僱" },
    { L"创", L"創" },
    { L"创制", L"創製" },
    { L"创获", L"創穫" },
    { L"删", L"刪" },
    { L"利欲", L"利慾" },
    { L"别", L"別" },
    { L"别口气", L"彆口氣" },
    { L"别庄", L"別莊" },
    { L"别强", L"彆強" },
    { L"别扭", L"彆扭" },
    { L"别拗", L"彆拗" },
    { L"别气", L"彆氣" },
    { L"别着", L"別著" },
    { L"别致", L"別緻" },
    { L"别辟", L"別闢" },
    { L"刭", L"剄" },
    { L"刮了", L"颳了" },
    { L"刮倒", L"颳倒" },
    { L"刮去", L"颳去" },
    { L"刮得", L"颳得" },
    { L"刮着", L"刮著" },
    { L"刮胡", L"刮鬍" },
    { L"刮走", L"颳走" },
    { L"刮起", L"颳起" },
    { L"刮雪", L"颳雪" },
    { L"刮风", L"颳風" },
    { L"制为", L"製為" },
    { L"制件", L"製件" },
    { L"制作", L"製作" },
    { L"制做", L"製做" },
    { L"制冰", L"製冰" },
    { L"制冷", L"製冷" },
    { L"制剂", L"製劑" },
    { L"制取", L"製取" },
    { L"制品", L"製品" },
    { L"制图", L"製圖" },
    { L"制备", L"製備" },
    { L"制得", L"製得" },
    { L"制成", L"製成" },
    { L"制法", L"製法" },
    { L"制浆", L"製漿" },
    { L"制片", L"製片" },
    { L"制版", L"製版" },
    { L"制盐", L"製鹽" },
    { L"制程", L"製程" },
    { L"制签", L"制籤" },
    { L"制糖", L"製糖" },
    { L"制纸", L"製紙" },
    { L"制药", L"製藥" },
    { L"制表", L"製表" },
    { L"制造", L"製造" },
    { L"制钟", L"制鐘" },
    { L"制革", L"製革" },
    { L"制鞋", L"製鞋" },
    { L"刹", L"剎" },
    { L"刺绣", L"刺繡" },
    { L"刻划", L"刻劃" },
    { L"刻半钟", L"刻半鐘" },
    { L"刻多钟", L"刻多鐘" },
    { L"刻钟", L"刻鐘" },
    { L"刽", L"劊" },
    { L"刿", L"劌" },
    { L"剀", L"剴" },
    { L"剂", L"劑" },
    { L"剃发", L"剃髮" },
    { L"剃胡", L"剃鬍" },
    { L"剃须", L"剃鬚" },
    { L"削发", L"削髮" },
    { L"削面", L"削麵" },
    { L"剐", L"剮" },
    { L"剑", L"劍" },
    { L"剔庄货", L"剔莊貨" },
    { L"剥", L"剝" },
    { L"剥制", L"剝製" },
    { L"剧", L"劇" },
    { L"剧药", L"劇藥" },
    { L"剩余", L"剩餘" },
    { L"剪其发", L"剪其髮" },
    { L"剪发", L"剪髮" },
    { L"剪彩", L"剪綵" },
    { L"割舍", L"割捨" },
    { L"力争上游", L"力爭上遊" },
    { L"力克制", L"力剋制" },
    { L"力拼", L"力拚" },
    { L"力求克制", L"力求剋制" },
    { L"劝", L"勸" },
    { L"办", L"辦" },
    { L"办公台", L"辦公檯" },
    { L"功致", L"功緻" },
    { L"加注", L"加註" },
    { L"加药", L"加藥" },
    { L"务", L"務" },
    { L"劢", L"勱" },
    { L"动", L"動" },
    { L"动荡", L"動蕩" },
    { L"劫余", L"劫餘" },
    { L"励", L"勵" },
    { L"劲", L"勁" },
    { L"劳", L"勞" },
    { L"劳力士表", L"勞力士錶" },
    { L"势", L"勢" },
    { L"勃郁", L"勃鬱" },
    { L"勋", L"勛" },
    { L"勋章", L"勳章" },
    { L"勤仆", L"勤僕" },
    { L"勤朴", L"勤樸" },
    { L"勺药", L"勺藥" },
    { L"勾干", L"勾幹" },
    { L"勾心斗角", L"勾心鬥角" },
    { L"勾魂荡魄", L"勾魂蕩魄" },
    { L"匀", L"勻" },
    { L"包准", L"包準" },
    { L"包庄", L"包莊" },
    { L"包扎", L"包紮" },
    { L"包谷", L"包穀" },
    { L"匏系", L"匏繫" },
    { L"北回线", L"北迴線" },
    { L"北回铁路", L"北迴鐵路" },
    { L"北岳", L"北嶽" },
    { L"匡复", L"匡複" },
    { L"匦", L"匭" },
    { L"匪干", L"匪幹" },
    { L"匮", L"匱" },
    { L"区", L"區" },
    { L"区划", L"區劃" },
    { L"医", L"醫" },
    { L"医药", L"醫藥" },
    { L"医院里", L"醫院裡" },
    { L"十余", L"十餘" },
    { L"十出", L"十齣" },
    { L"十划", L"十劃" },
    { L"十只", L"十隻" },
    { L"十扎", L"十紮" },
    { L"千余", L"千餘" },
    { L"千只", L"千隻" },
    { L"千回百折", L"千迴百折" },
    { L"千回百转", L"千迴百轉" },
    { L"千扎", L"千紮" },
    { L"千钧一发", L"千鈞一髮" },
    { L"升官", L"陞官" },
    { L"升平", L"昇平" },
    { L"升阳", L"昇陽" },
    { L"半只", L"半隻" },
    { L"华", L"華" },
    { L"华严钟", L"華嚴鐘" },
    { L"华发", L"華髮" },
    { L"协", L"協" },
    { L"单", L"單" },
    { L"单于", L"單于" },
    { L"单只", L"單隻" },
    { L"单干", L"單幹" },
    { L"单打独斗", L"單打獨鬥" },
    { L"卖", L"賣" },
    { L"卖呆", L"賣獃" },
    { L"南京钟", L"南京鐘" },
    { L"南回线", L"南迴線" },
    { L"南回铁路", L"南迴鐵路" },
    { L"南宫适", L"南宮适" },
    { L"南岳", L"南嶽" },
    { L"南游", L"南遊" },
    { L"南筑", L"南筑" },
    { L"博汇", L"博彙" },
    { L"博采", L"博採" },
    { L"卞庄", L"卞莊" },
    { L"占〇", L"佔〇" },
    { L"占一", L"佔一" },
    { L"占七", L"佔七" },
    { L"占万", L"佔万" },
    { L"占三", L"佔三" },
    { L"占上风", L"佔上風" },
    { L"占下", L"佔下" },
    { L"占不占", L"佔不佔" },
    { L"占不足", L"佔不足" },
    { L"占世界", L"佔世界" },
    { L"占东", L"佔東" },
    { L"占两", L"佔兩" },
    { L"占个", L"佔個" },
    { L"占中", L"佔中" },
    { L"占为", L"佔為" },
    { L"占主", L"佔主" },
    { L"占九", L"佔九" },
    { L"占了", L"佔了" },
    { L"占二", L"佔二" },
    { L"占五", L"佔五" },
    { L"占人便宜", L"佔人便宜" },
    { L"占亿", L"佔億" },
    { L"占优", L"佔優" },
    { L"占位", L"佔位" },
    { L"占住", L"佔住" },
    { L"占便宜", L"佔便宜" },
    { L"占便宜的是呆", L"占便宜的是獃" },
    { L"占俄", L"佔俄" },
    { L"占停车", L"佔停車" },
    { L"占先", L"佔先" },
    { L"占光", L"佔光" },
    { L"占全", L"佔全" },
    { L"占八", L"佔八" },
    { L"占六", L"佔六" },
    { L"占分", L"佔分" },
    { L"占到", L"佔到" },
    { L"占加", L"佔加" },
    { L"占劣", L"佔劣" },
    { L"占北", L"佔北" },
    { L"占十", L"佔十" },
    { L"占千", L"佔千" },
    { L"占半", L"佔半" },
    { L"占南", L"佔南" },
    { L"占占", L"佔佔" },
    { L"占印", L"佔印" },
    { L"占压", L"佔壓" },
    { L"占去", L"佔去" },
    { L"占取", L"佔取" },
    { L"占台", L"佔台" },
    { L"占后", L"佔後" },
    { L"占哺乳", L"佔哺乳" },
    { L"占嗫", L"佔囁" },
    { L"占四", L"佔四" },
    { L"占国内", L"佔國內" },
    { L"占在", L"佔在" },
    { L"占地", L"佔地" },
    { L"占场", L"佔場" },
    { L"占多", L"佔多" },
    { L"占大", L"佔大" },
    { L"占头", L"佔頭" },
    { L"占好", L"佔好" },
    { L"占小", L"佔小" },
    { L"占少", L"佔少" },
    { L"占尽", L"佔盡" },
    { L"占局部", L"佔局部" },
    { L"占屋", L"佔屋" },
    { L"占山", L"佔山" },
    { L"占市场", L"佔市場" },
    { L"占平均", L"佔平均" },
    { L"占床", L"佔床" },
    { L"占座", L"佔座" },
    { L"占得", L"佔得" },
    { L"占德", L"佔德" },
    { L"占总", L"佔總" },
    { L"占据", L"佔據" },
    { L"占掉", L"佔掉" },
    { L"占整体", L"佔整體" },
    { L"占新", L"佔新" },
    { L"占有", L"佔有" },
    { L"占有欲", L"佔有慾" },
    { L"占查", L"佔查" },
    { L"占次", L"佔次" },
    { L"占比", L"佔比" },
    { L"占毕", L"佔畢" },
    { L"占法", L"佔法" },
    { L"占满", L"佔滿" },
    { L"占澳", L"佔澳" },
    { L"占率", L"佔率" },
    { L"占用", L"佔用" },
    { L"占百", L"佔百" },
    { L"占着", L"佔著" },
    { L"占稳", L"佔穩" },
    { L"占线", L"佔線" },
    { L"占缺", L"佔缺" },
    { L"占网", L"佔網" },
    { L"占美", L"佔美" },
    { L"占耕", L"佔耕" },
    { L"占至多", L"佔至多" },
    { L"占至少", L"佔至少" },
    { L"占苏", L"佔蘇" },
    { L"占英", L"佔英" },
    { L"占葡", L"佔葡" },
    { L"占西", L"佔西" },
    { L"占资源", L"佔資源" },
    { L"占起", L"佔起" },
    { L"占超过", L"佔超過" },
    { L"占过", L"佔過" },
    { L"占道", L"佔道" },
    { L"占零", L"佔零" },
    { L"占領", L"佔領" },
    { L"占领", L"佔領" },
    { L"占饭", L"佔飯" },
    { L"占香", L"佔香" },
    { L"占马", L"佔馬" },
    { L"占高枝儿", L"佔高枝兒" },
    { L"卢", L"盧" },
    { L"卢棱伽", L"盧稜伽" },
    { L"卤", L"鹵" },
    { L"卤制", L"滷製" },
    { L"卤味", L"滷味" },
    { L"卤水", L"滷水" },
    { L"卤汁", L"滷汁" },
    { L"卤湖", L"滷湖" },
    { L"卤肉", L"滷肉" },
    { L"卤菜", L"滷菜" },
    { L"卤蛋", L"滷蛋" },
    { L"卤面", L"滷麵" },
    { L"卤鸡", L"滷雞" },
    { L"卧游", L"臥遊" },
    { L"卫", L"衛" },
    { L"卫星钟", L"衛星鐘" },
    { L"印制", L"印製" },
    { L"印累绶若", L"印纍綬若" },
    { L"却", L"卻" },
    { L"卵与石斗", L"卵與石鬥" },
    { L"卷云", L"捲雲" },
    { L"卷住", L"捲住" },
    { L"卷儿", L"捲兒" },
    { L"卷入", L"捲入" },
    { L"卷动", L"捲動" },
    { L"卷去", L"捲去" },
    { L"卷发", L"捲髮" },
    { L"卷图", L"捲圖" },
    { L"卷土重来", L"捲土重來" },
    { L"卷尺", L"捲尺" },
    { L"卷帘", L"捲簾" },
    { L"卷心菜", L"捲心菜" },
    { L"卷成", L"捲成" },
    { L"卷曲", L"捲曲" },
    { L"卷来", L"捲來" },
    { L"卷款", L"捲款" },
    { L"卷毛", L"捲毛" },
    { L"卷烟", L"捲煙" },
    { L"卷筒", L"捲筒" },
    { L"卷纸", L"捲紙" },
    { L"卷缩", L"捲縮" },
    { L"卷舌", L"捲舌" },
    { L"卷舖盖", L"捲舖蓋" },
    { L"卷菸", L"捲菸" },
    { L"卷袖", L"捲袖" },
    { L"卷走", L"捲走" },
    { L"卷起", L"捲起" },
    { L"卷轴", L"捲軸" },
    { L"卷逃", L"捲逃" },
    { L"卷铺盖", L"捲鋪蓋" },
    { L"卷须", L"卷鬚" },
    { L"卷风", L"捲風" },
    { L"卺", L"巹" },
    { L"厂", L"廠" },
    { L"厂部", L"厂部" },
    { L"厅", L"廳" },
    { L"历", L"歷" },
    { L"历书", L"曆書" },
    { L"历元", L"曆元" },
    { L"历史里", L"歷史裡" },
    { L"历命", L"曆命" },
    { L"历始", L"曆始" },
    { L"历室", L"曆室" },
    { L"历尾", L"曆尾" },
    { L"历数", L"曆數" },
    { L"历日", L"曆日" },
    { L"历本", L"曆本" },
    { L"历法", L"曆法" },
    { L"历物之意", L"厤物之意" },
    { L"历狱", L"曆獄" },
    { L"历纪", L"曆紀" },
    { L"历象", L"曆象" },
    { L"厉", L"厲" },
    { L"压", L"壓" },
    { L"厌", L"厭" },
    { L"厍", L"厙" },
    { L"厕", L"廁" },
    { L"厘出", L"釐出" },
    { L"厘升", L"釐升" },
    { L"厘定", L"釐定" },
    { L"厘正", L"釐正" },
    { L"厘清", L"釐清" },
    { L"厘订", L"釐訂" },
    { L"原子钟", L"原子鐘" },
    { L"原钟", L"原鐘" },
    { L"厢", L"廂" },
    { L"厣", L"厴" },
    { L"厦", L"廈" },
    { L"厨", L"廚" },
    { L"厨余", L"廚餘" },
    { L"厩", L"廄" },
    { L"厮", L"廝" },
    { L"厮斗", L"廝鬥" },
    { L"县", L"縣" },
    { L"县志", L"縣誌" },
    { L"县里", L"縣裡" },
    { L"参", L"參" },
    { L"参绥", L"蔘綏" },
    { L"双", L"雙" },
    { L"双折", L"雙摺" },
    { L"双胜类", L"雙胜類" },
    { L"双雕", L"雙鵰" },
    { L"反冲", L"反衝" },
    { L"反复", L"反覆" },
    { L"反复制", L"反複製" },
    { L"反朴", L"反樸" },
    { L"发", L"發" },
    { L"发上冲冠", L"髮上沖冠" },
    { L"发上指冠", L"髮上指冠" },
    { L"发丝", L"髮絲" },
    { L"发为血之本", L"髮為血之本" },
    { L"发乳", L"髮乳" },
    { L"发光可鉴", L"髮光可鑑" },
    { L"发匪", L"髮匪" },
    { L"发卷", L"髮捲" },
    { L"发呆", L"發獃" },
    { L"发型", L"髮型" },
    { L"发夹", L"髮夾" },
    { L"发妻", L"髮妻" },
    { L"发姐", L"髮姐" },
    { L"发屋", L"髮屋" },
    { L"发已霜白", L"髮已霜白" },
    { L"发带", L"髮帶" },
    { L"发干", L"發乾" },
    { L"发庄", L"發莊" },
    { L"发廊", L"髮廊" },
    { L"发式", L"髮式" },
    { L"发引千钧", L"髮引千鈞" },
    { L"发指", L"髮指" },
    { L"发松", L"發鬆" },
    { L"发根", L"髮根" },
    { L"发汗药", L"發汗藥" },
    { L"发油", L"髮油" },
    { L"发漂", L"髮漂" },
    { L"发状", L"髮狀" },
    { L"发癣", L"髮癬" },
    { L"发着", L"發著" },
    { L"发短心长", L"髮短心長" },
    { L"发禁", L"髮禁" },
    { L"发笺", L"髮箋" },
    { L"发签", L"發籤" },
    { L"发纱", L"髮紗" },
    { L"发结", L"髮結" },
    { L"发网", L"髮網" },
    { L"发肤", L"髮膚" },
    { L"发胶", L"髮膠" },
    { L"发脚", L"髮腳" },
    { L"发菜", L"髮菜" },
    { L"发蒙", L"發矇" },
    { L"发蜡", L"髮蠟" },
    { L"发踊冲冠", L"髮踊沖冠" },
    { L"发辫", L"髮辮" },
    { L"发针", L"髮針" },
    { L"发钗", L"髮釵" },
    { L"发长", L"髮長" },
    { L"发际", L"髮際" },
    { L"发雕", L"髮雕" },
    { L"发霜", L"髮霜" },
    { L"发面", L"發麵" },
    { L"发饰", L"髮飾" },
    { L"发髻", L"髮髻" },
    { L"发鬓", L"髮鬢" },
    { L"取舍", L"取捨" },
    { L"受托", L"受託" },
    { L"变", L"變" },
    { L"变丑", L"變醜" },
    { L"变征", L"變徵" },
    { L"变脏", L"變髒" },
    { L"叙", L"敘" },
    { L"叠", L"疊" },
    { L"口干", L"口乾" },
    { L"口腹之欲", L"口腹之慾" },
    { L"口里", L"口裡" },
    { L"口钟", L"口鐘" },
    { L"古书云", L"古書云" },
    { L"古書云", L"古書云" },
    { L"古朴", L"古樸" },
    { L"古柯咸", L"古柯鹹" },
    { L"古語云", L"古語云" },
    { L"古迹", L"古迹" },
    { L"古钟", L"古鐘" },
    { L"古钟表", L"古鐘錶" },
    { L"另辟", L"另闢" },
    { L"叩钟", L"叩鐘" },
    { L"只冲", L"只衝" },
    { L"只占", L"只佔" },
    { L"只字", L"隻字" },
    { L"只影", L"隻影" },
    { L"只手遮天", L"隻手遮天" },
    { L"只眼", L"隻眼" },
    { L"只言片语", L"隻言片語" },
    { L"只身", L"隻身" },
    { L"只采", L"只採" },
    { L"叮叮当当", L"叮叮噹噹" },
    { L"叮当", L"叮噹" },
    { L"可以克制", L"可以剋制" },
    { L"可紧可松", L"可緊可鬆" },
    { L"台子", L"檯子" },
    { L"台布", L"檯布" },
    { L"台灯", L"檯燈" },
    { L"台球", L"檯球" },
    { L"台钟", L"台鐘" },
    { L"台面", L"檯面" },
    { L"台风", L"颱風" },
    { L"叱咤乐坛", L"叱咤樂壇" },
    { L"叱咤叱叱咤", L"叱咤叱叱咤" },
    { L"叱咤咤", L"叱咤咤" },
    { L"叱咤樂壇", L"叱咤樂壇" },
    { L"叶", L"葉" },
    { L"叶恭弘", L"叶恭弘" },
    { L"叶音", L"叶音" },
    { L"叶韵", L"叶韻" },
    { L"号", L"號" },
    { L"号志", L"號誌" },
    { L"叹", L"嘆" },
    { L"叽", L"嘰" },
    { L"吁天", L"籲天" },
    { L"吁求", L"籲求" },
    { L"吁请", L"籲請" },
    { L"吃姜", L"吃薑" },
    { L"吃板刀面", L"吃板刀麵" },
    { L"吃着不尽", L"吃著不盡" },
    { L"吃药", L"吃藥" },
    { L"吃辣面", L"吃辣麵" },
    { L"吃里扒外", L"吃裡扒外" },
    { L"吃里爬外", L"吃裡爬外" },
    { L"吃错药", L"吃錯藥" },
    { L"各类钟", L"各類鐘" },
    { L"各辟", L"各闢" },
    { L"合伙", L"合夥" },
    { L"合准", L"合準" },
    { L"合历", L"合曆" },
    { L"合并", L"合併" },
    { L"合府", L"閤府" },
    { L"合着", L"合著" },
    { L"合采", L"合採" },
    { L"吊丧", L"弔喪" },
    { L"吊书", L"弔書" },
    { L"吊儿郎当", L"弔兒郎當" },
    { L"吊卷", L"弔卷" },
    { L"吊取", L"弔取" },
    { L"吊古", L"弔古" },
    { L"吊唁", L"弔唁" },
    { L"吊喉", L"弔喉" },
    { L"吊喭", L"弔喭" },
    { L"吊场", L"弔場" },
    { L"吊头", L"弔頭" },
    { L"吊奠", L"弔奠" },
    { L"吊孝", L"弔孝" },
    { L"吊客", L"弔客" },
    { L"吊宴", L"弔宴" },
    { L"吊带", L"弔帶" },
    { L"吊影", L"弔影" },
    { L"吊慰", L"弔慰" },
    { L"吊扣", L"弔扣" },
    { L"吊拷", L"弔拷" },
    { L"吊拷绷扒", L"弔拷繃扒" },
    { L"吊挂", L"弔掛" },
    { L"吊挂着", L"吊掛著" },
    { L"吊撒", L"弔撒" },
    { L"吊文", L"弔文" },
    { L"吊旗", L"弔旗" },
    { L"吊杆", L"吊杆" },
    { L"吊桥", L"弔橋" },
    { L"吊死", L"弔死" },
    { L"吊民", L"弔民" },
    { L"吊着", L"吊著" },
    { L"吊祭", L"弔祭" },
    { L"吊纸", L"弔紙" },
    { L"吊者大悦", L"弔者大悅" },
    { L"吊脚儿事", L"弔腳兒事" },
    { L"吊腰撒跨", L"弔腰撒跨" },
    { L"吊膀子", L"弔膀子" },
    { L"吊词", L"弔詞" },
    { L"吊诡", L"弔詭" },
    { L"吊谎", L"弔謊" },
    { L"吊贺迎送", L"弔賀迎送" },
    { L"吊钟", L"吊鐘" },
    { L"吊问", L"弔問" },
    { L"吊颈", L"弔頸" },
    { L"吊鹤", L"弔鶴" },
    { L"同伙", L"同夥" },
    { L"同余", L"同餘" },
    { L"后", L"後" },
    { L"后丰", L"后豐" },
    { L"后冠", L"后冠" },
    { L"后北街", L"后北街" },
    { L"后发座", L"后髮座" },
    { L"后土", L"后土" },
    { L"后妃", L"后妃" },
    { L"后安路", L"后安路" },
    { L"后平路", L"后平路" },
    { L"后座", L"后座" },
    { L"后海湾", L"后海灣" },
    { L"后海灣", L"后海灣" },
    { L"后稷", L"后稷" },
    { L"后羿", L"后羿" },
    { L"后街", L"后街" },
    { L"后角", L"后角" },
    { L"后豐", L"后豐" },
    { L"后里", L"后里" },
    { L"后髮座", L"后髮座" },
    { L"向导", L"嚮導" },
    { L"向应", L"嚮應" },
    { L"向往", L"嚮往" },
    { L"向着", L"向著" },
    { L"向迩", L"嚮邇" },
    { L"吓", L"嚇" },
    { L"吕", L"呂" },
    { L"吕后", L"呂后" },
    { L"吗", L"嗎" },
    { L"吞并", L"吞併" },
    { L"吟游", L"吟遊" },
    { L"吣", L"唚" },
    { L"吨", L"噸" },
    { L"含齿戴发", L"含齒戴髮" },
    { L"听", L"聽" },
    { L"启", L"啟" },
    { L"吴", L"吳" },
    { L"吹发", L"吹髮" },
    { L"吹干", L"吹乾" },
    { L"吹胡", L"吹鬍" },
    { L"呂后", L"呂后" },
    { L"呆串了皮", L"獃串了皮" },
    { L"呆事", L"獃事" },
    { L"呆人", L"獃人" },
    { L"呆呆", L"獃獃" },
    { L"呆头", L"獃頭" },
    { L"呆子", L"獃子" },
    { L"呆性", L"獃性" },
    { L"呆想", L"獃想" },
    { L"呆憨呆", L"獃憨獃" },
    { L"呆根", L"獃根" },
    { L"呆气", L"獃氣" },
    { L"呆滞", L"獃滯" },
    { L"呆痴", L"獃痴" },
    { L"呆着", L"獃著" },
    { L"呆磕", L"獃磕" },
    { L"呆等", L"獃等" },
    { L"呆脑", L"獃腦" },
    { L"呆致致", L"呆緻緻" },
    { L"呆话", L"獃話" },
    { L"呆里呆气", L"呆裡呆氣" },
    { L"呐", L"吶" },
    { L"呒", L"嘸" },
    { L"呓", L"囈" },
    { L"呕", L"嘔" },
    { L"呖", L"嚦" },
    { L"呗", L"唄" },
    { L"呗赞", L"唄讚" },
    { L"员", L"員" },
    { L"呙", L"咼" },
    { L"呛", L"嗆" },
    { L"呜", L"嗚" },
    { L"周历", L"周曆" },
    { L"周庄王", L"周莊王" },
    { L"周杰倫", L"周杰倫" },
    { L"周游", L"周遊" },
    { L"周游世界", L"週遊世界" },
    { L"呼吁", L"呼籲" },
    { L"和克制", L"和剋制" },
    { L"和奸", L"和姦" },
    { L"咎征", L"咎徵" },
    { L"咏", L"詠" },
    { L"咕咕钟", L"咕咕鐘" },
    { L"咙", L"嚨" },
    { L"咛", L"嚀" },
    { L"咤", L"吒" },
    { L"咨询", L"諮詢" },
    { L"咬姜呷醋", L"咬薑呷醋" },
    { L"咯当", L"咯噹" },
    { L"咳嗽药", L"咳嗽藥" },
    { L"咸卤", L"鹹鹵" },
    { L"咸味", L"鹹味" },
    { L"咸咸", L"鹹鹹" },
    { L"咸嘴淡舌", L"鹹嘴淡舌" },
    { L"咸土", L"鹹土" },
    { L"咸度", L"鹹度" },
    { L"咸得", L"鹹得" },
    { L"咸批", L"鹹批" },
    { L"咸水", L"鹹水" },
    { L"咸汤", L"鹹湯" },
    { L"咸派", L"鹹派" },
    { L"咸海", L"鹹海" },
    { L"咸淡", L"鹹淡" },
    { L"咸湖", L"鹹湖" },
    { L"咸潟", L"鹹潟" },
    { L"咸猪肉", L"鹹豬肉" },
    { L"咸的", L"鹹的" },
    { L"咸类", L"鹹類" },
    { L"咸粥", L"鹹粥" },
    { L"咸肉", L"鹹肉" },
    { L"咸菜", L"鹹菜" },
    { L"咸菜干", L"鹹菜乾" },
    { L"咸蛋", L"鹹蛋" },
    { L"咸食", L"鹹食" },
    { L"咸鱼", L"鹹魚" },
    { L"咸鸭蛋", L"鹹鴨蛋" },
    { L"哀吊", L"哀弔" },
    { L"哀挽", L"哀輓" },
    { L"品汇", L"品彙" },
    { L"哄动", L"鬨動" },
    { L"哄堂", L"鬨堂" },
    { L"哄笑", L"鬨笑" },
    { L"响", L"響" },
    { L"响钟", L"響鐘" },
    { L"哑", L"啞" },
    { L"哒", L"噠" },
    { L"哓", L"嘵" },
    { L"哔", L"嗶" },
    { L"哕", L"噦" },
    { L"哗", L"嘩" },
    { L"哙", L"噲" },
    { L"哜", L"嚌" },
    { L"哝", L"噥" },
    { L"哟", L"喲" },
    { L"哪里", L"哪裡" },
    { L"哭脏", L"哭髒" },
    { L"唁吊", L"唁弔" },
    { L"唇干", L"唇乾" },
    { L"唛", L"嘜" },
    { L"唠", L"嘮" },
    { L"唢", L"嗩" },
    { L"唤", L"喚" },
    { L"唱游", L"唱遊" },
    { L"唾余", L"唾餘" },
    { L"唾面自干", L"唾面自乾" },
    { L"商历", L"商曆" },
    { L"啧", L"嘖" },
    { L"啬", L"嗇" },
    { L"啭", L"囀" },
    { L"啮", L"嚙" },
    { L"啷当", L"啷噹" },
    { L"啸", L"嘯" },
    { L"喂乳", L"餵乳" },
    { L"喂了", L"餵了" },
    { L"喂养", L"餵養" },
    { L"喂奶", L"餵奶" },
    { L"喂猪", L"餵豬" },
    { L"喂给", L"餵給" },
    { L"喂羊", L"餵羊" },
    { L"喂过", L"餵過" },
    { L"喂食", L"餵食" },
    { L"喂饱", L"餵飽" },
    { L"喂驴", L"餵驢" },
    { L"喂鱼", L"餵魚" },
    { L"喂鸡", L"餵雞" },
    { L"喂鸭", L"餵鴨" },
    { L"喂鹅", L"餵鵝" },
    { L"喜欢表", L"喜歡錶" },
    { L"喜欢钟", L"喜歡鐘" },
    { L"喝干", L"喝乾" },
    { L"喧哄", L"喧鬨" },
    { L"喷", L"噴" },
    { L"喷洒", L"噴洒" },
    { L"喽", L"嘍" },
    { L"喾", L"嚳" },
    { L"嗑药", L"嗑藥" },
    { L"嗫", L"囁" },
    { L"嗳", L"噯" },
    { L"嘀嗒的表", L"嘀嗒的錶" },
    { L"嘉肴", L"嘉肴" },
    { L"嘉谷", L"嘉穀" },
    { L"嘘", L"噓" },
    { L"嘤", L"嚶" },
    { L"嘱", L"囑" },
    { L"嘱托", L"囑託" },
    { L"嘴里", L"嘴裡" },
    { L"噙齿戴发", L"噙齒戴髮" },
    { L"噜", L"嚕" },
    { L"噜苏", L"嚕囌" },
    { L"嚣", L"囂" },
    { L"嚼谷", L"嚼穀" },
    { L"囉囉苏苏", L"囉囉囌囌" },
    { L"囉苏", L"囉囌" },
    { L"四余", L"四餘" },
    { L"四出", L"四齣" },
    { L"四出征收", L"四出徵收" },
    { L"四分历", L"四分曆" },
    { L"四只", L"四隻" },
    { L"四扎", L"四紮" },
    { L"四舍五入", L"四捨五入" },
    { L"四舍六入", L"四捨六入" },
    { L"四面钟", L"四面鐘" },
    { L"回光返照", L"迴光返照" },
    { L"回历", L"回曆" },
    { L"回向", L"迴向" },
    { L"回响", L"迴響" },
    { L"回圈", L"迴圈" },
    { L"回廊", L"迴廊" },
    { L"回形夹", L"迴形夾" },
    { L"回文", L"迴文" },
    { L"回旋", L"迴旋" },
    { L"回流", L"迴流" },
    { L"回游", L"回遊" },
    { L"回环", L"迴環" },
    { L"回着", L"回著" },
    { L"回纹针", L"迴紋針" },
    { L"回绕", L"迴繞" },
    { L"回翔", L"迴翔" },
    { L"回肠", L"迴腸" },
    { L"回荡", L"回蕩" },
    { L"回诵", L"迴誦" },
    { L"回路", L"迴路" },
    { L"回转", L"迴轉" },
    { L"回递性", L"迴遞性" },
    { L"回避", L"迴避" },
    { L"回采", L"回採" },
    { L"回銮", L"迴鑾" },
    { L"回阳荡气", L"回陽蕩氣" },
    { L"回音", L"迴音" },
    { L"回风", L"迴風" },
    { L"团", L"團" },
    { L"团子", L"糰子" },
    { L"园", L"園" },
    { L"园游会", L"園遊會" },
    { L"园里", L"園裡" },
    { L"困乏", L"睏乏" },
    { L"困倦", L"睏倦" },
    { L"困兽之斗", L"困獸之鬥" },
    { L"困兽犹斗", L"困獸猶鬥" },
    { L"困斗", L"困鬥" },
    { L"困觉", L"睏覺" },
    { L"囱", L"囪" },
    { L"围", L"圍" },
    { L"囵", L"圇" },
    { L"固征", L"固徵" },
    { L"国", L"國" },
    { L"国之桢干", L"國之楨榦" },
    { L"国仇", L"國讎" },
    { L"国历", L"國曆" },
    { L"图", L"圖" },
    { L"图里", L"圖裡" },
    { L"图鉴", L"圖鑑" },
    { L"圆", L"圓" },
    { L"圈占", L"圈佔" },
    { L"圈子里", L"圈子裡" },
    { L"圈梁", L"圈樑" },
    { L"圈里", L"圈裡" },
    { L"土制", L"土製" },
    { L"土里", L"土裡" },
    { L"圣", L"聖" },
    { L"在克制", L"在剋制" },
    { L"地丑德齐", L"地醜德齊" },
    { L"地克制", L"地剋制" },
    { L"地占", L"地佔" },
    { L"地志", L"地誌" },
    { L"圹", L"壙" },
    { L"场", L"場" },
    { L"坏", L"壞" },
    { L"坏于", L"坏於" },
    { L"坐如钟", L"坐如鐘" },
    { L"坐庄", L"坐莊" },
    { L"坐钟", L"坐鐘" },
    { L"坑里", L"坑裡" },
    { L"块", L"塊" },
    { L"坚", L"堅" },
    { L"坚致", L"堅緻" },
    { L"坛", L"壇" },
    { L"坛坛罐罐", L"罈罈罐罐" },
    { L"坛子", L"罈子" },
    { L"坛騞", L"罈騞" },
    { L"坜", L"壢" },
    { L"坝", L"壩" },
    { L"坞", L"塢" },
    { L"坟", L"墳" },
    { L"坠", L"墜" },
    { L"坤范", L"坤範" },
    { L"坦荡", L"坦蕩" },
    { L"坦荡荡", L"坦蕩蕩" },
    { L"坱郁", L"坱鬱" },
    { L"垂发", L"垂髮" },
    { L"垂范", L"垂範" },
    { L"垄", L"壟" },
    { L"垆", L"壚" },
    { L"型范", L"型範" },
    { L"垒", L"壘" },
    { L"垦", L"墾" },
    { L"垦复", L"墾複" },
    { L"垦辟", L"墾闢" },
    { L"垩", L"堊" },
    { L"垫", L"墊" },
    { L"垭", L"埡" },
    { L"垲", L"塏" },
    { L"埃及历", L"埃及曆" },
    { L"埃及艳后", L"埃及豔后" },
    { L"埃荣冲", L"埃榮衝" },
    { L"埋头寻表", L"埋頭尋錶" },
    { L"埋头寻钟", L"埋頭尋鐘" },
    { L"城里", L"城裡" },
    { L"埔裡社撫墾局", L"埔裏社撫墾局" },
    { L"埔里社抚垦局", L"埔裏社撫墾局" },
    { L"埘", L"塒" },
    { L"埙", L"塤" },
    { L"埚", L"堝" },
    { L"埯", L"垵" },
    { L"基准", L"基準" },
    { L"基干", L"基幹" },
    { L"堑", L"塹" },
    { L"堕", L"墮" },
    { L"堕胎药", L"墮胎藥" },
    { L"堙淀", L"堙澱" },
    { L"塞药", L"塞藥" },
    { L"墓志", L"墓誌" },
    { L"墙", L"牆" },
    { L"墙里", L"牆裡" },
    { L"增辟", L"增闢" },
    { L"墨沈未干", L"墨瀋未乾" },
    { L"壮", L"壯" },
    { L"壮游", L"壯遊" },
    { L"壮面", L"壯麵" },
    { L"声", L"聲" },
    { L"壳", L"殼" },
    { L"壳里", L"殼裡" },
    { L"壶", L"壺" },
    { L"壶里", L"壺裡" },
    { L"壹郁", L"壹鬱" },
    { L"处", L"處" },
    { L"备", L"備" },
    { L"备注", L"備註" },
    { L"复", L"復" },
    { L"复习", L"複習" },
    { L"复亩珍", L"複畝珍" },
    { L"复仞年如", L"複仞年如" },
    { L"复以百万", L"複以百萬" },
    { L"复位", L"複位" },
    { L"复信", L"複信" },
    { L"复元音", L"複元音" },
    { L"复写", L"複寫" },
    { L"复决", L"複決" },
    { L"复函数", L"複函數" },
    { L"复分数", L"複分數" },
    { L"复分析", L"複分析" },
    { L"复分解", L"複分解" },
    { L"复列", L"複列" },
    { L"复利", L"複利" },
    { L"复制", L"複製" },
    { L"复印", L"複印" },
    { L"复发", L"複發" },
    { L"复变函数", L"複變函數" },
    { L"复句", L"複句" },
    { L"复叶", L"複葉" },
    { L"复合", L"複合" },
    { L"复名", L"複名" },
    { L"复员", L"複員" },
    { L"复壁", L"複壁" },
    { L"复壮", L"複壯" },
    { L"复复", L"複復" },
    { L"复姓", L"複姓" },
    { L"复字键", L"複字鍵" },
    { L"复审", L"複審" },
    { L"复对数", L"複對數" },
    { L"复平面", L"複平面" },
    { L"复式", L"複式" },
    { L"复数", L"複數" },
    { L"复本", L"複本" },
    { L"复杂", L"複雜" },
    { L"复查", L"複查" },
    { L"复核", L"複核" },
    { L"复检", L"複檢" },
    { L"复次", L"複次" },
    { L"复比", L"複比" },
    { L"复流", L"複流" },
    { L"复测", L"複測" },
    { L"复电", L"複電" },
    { L"复目", L"複目" },
    { L"复眼", L"複眼" },
    { L"复种", L"複種" },
    { L"复线", L"複線" },
    { L"复色", L"複色" },
    { L"复议", L"複議" },
    { L"复评", L"複評" },
    { L"复诊", L"複診" },
    { L"复词", L"複詞" },
    { L"复试", L"複試" },
    { L"复课", L"複課" },
    { L"复赛", L"複賽" },
    { L"复辅音", L"複輔音" },
    { L"复述", L"複述" },
    { L"复选", L"複選" },
    { L"复钱", L"複錢" },
    { L"复阅", L"複閱" },
    { L"复音", L"複音" },
    { L"复韵", L"複韻" },
    { L"夏于乔", L"夏于喬" },
    { L"夏于喬", L"夏于喬" },
    { L"夏历", L"夏曆" },
    { L"夏天里", L"夏天裡" },
    { L"夏日里", L"夏日裡" },
    { L"夏游", L"夏遊" },
    { L"外制", L"外製" },
    { L"外强中干", L"外強中乾" },
    { L"多丑", L"多醜" },
    { L"多么", L"多麼" },
    { L"多余", L"多餘" },
    { L"多冲", L"多衝" },
    { L"多划", L"多劃" },
    { L"多占", L"多佔" },
    { L"多只", L"多隻" },
    { L"夜光表", L"夜光錶" },
    { L"夜游", L"夜遊" },
    { L"夜里", L"夜裡" },
    { L"够", L"夠" },
    { L"够克制", L"夠剋制" },
    { L"大伙", L"大夥" },
    { L"大历", L"大曆" },
    { L"大只", L"大隻" },
    { L"大呆", L"大獃" },
    { L"大周后", L"大周后" },
    { L"大周折", L"大週摺" },
    { L"大型钟", L"大型鐘" },
    { L"大干", L"大幹" },
    { L"大批涌到", L"大批湧到" },
    { L"大折儿", L"大摺兒" },
    { L"大明历", L"大明曆" },
    { L"大曲", L"大麴" },
    { L"大本钟", L"大本鐘" },
    { L"大病初愈", L"大病初癒" },
    { L"大目干连", L"大目乾連" },
    { L"大笨钟", L"大笨鐘" },
    { L"大蜡", L"大蜡" },
    { L"大衍历", L"大衍曆" },
    { L"大言非夸", L"大言非夸" },
    { L"大赞", L"大讚" },
    { L"大钟", L"大鐘" },
    { L"大锤", L"大鎚" },
    { L"天克地冲", L"天克地衝" },
    { L"天历", L"天曆" },
    { L"天后", L"天后" },
    { L"天地为范", L"天地為範" },
    { L"天干物燥", L"天乾物燥" },
    { L"天文学钟", L"天文學鐘" },
    { L"天文钟", L"天文鐘" },
    { L"太仆", L"太僕" },
    { L"太初历", L"太初曆" },
    { L"太后", L"太后" },
    { L"夯干", L"夯幹" },
    { L"头", L"頭" },
    { L"头发", L"頭髮" },
    { L"头巾吊在水里", L"頭巾弔在水裡" },
    { L"头里", L"頭裡" },
    { L"夸", L"誇" },
    { L"夸丽", L"夸麗" },
    { L"夸人", L"夸人" },
    { L"夸克", L"夸克" },
    { L"夸多斗靡", L"誇多鬥靡" },
    { L"夸夸其谈", L"夸夸其談" },
    { L"夸姣", L"夸姣" },
    { L"夸容", L"夸容" },
    { L"夸毗", L"夸毗" },
    { L"夸父", L"夸父" },
    { L"夸特", L"夸特" },
    { L"夸脱", L"夸脫" },
    { L"夸诞", L"夸誕" },
    { L"夸赞", L"誇讚" },
    { L"夹", L"夾" },
    { L"夺", L"奪" },
    { L"夺斗", L"奪鬥" },
    { L"奁", L"奩" },
    { L"奂", L"奐" },
    { L"奇丑", L"奇醜" },
    { L"奇迹", L"奇迹" },
    { L"奋", L"奮" },
    { L"奋斗", L"奮鬥" },
    { L"奏折", L"奏摺" },
    { L"奖", L"獎" },
    { L"奖杯", L"獎盃" },
    { L"奥", L"奧" },
    { L"奥占", L"奧佔" },
    { L"女仆", L"女僕" },
    { L"女佣", L"女傭" },
    { L"奴仆", L"奴僕" },
    { L"奸夫", L"姦夫" },
    { L"奸妇", L"姦婦" },
    { L"奸宄", L"姦宄" },
    { L"奸情", L"姦情" },
    { L"奸杀", L"姦殺" },
    { L"奸污", L"姦汙" },
    { L"奸淫", L"姦淫" },
    { L"奸猾", L"姦猾" },
    { L"奸细", L"姦細" },
    { L"奸邪", L"姦邪" },
    { L"她克制", L"她剋制" },
    { L"好丑", L"好醜" },
    { L"好呆", L"好獃" },
    { L"好困", L"好睏" },
    { L"好家伙", L"好傢夥" },
    { L"好干", L"好乾" },
    { L"好斗", L"好鬥" },
    { L"好签", L"好籤" },
    { L"如果干", L"如果幹" },
    { L"如饥似渴", L"如饑似渴" },
    { L"妆", L"妝" },
    { L"妇", L"婦" },
    { L"妈", L"媽" },
    { L"妖后", L"妖后" },
    { L"妙药", L"妙藥" },
    { L"妩", L"嫵" },
    { L"妪", L"嫗" },
    { L"妫", L"媯" },
    { L"委托", L"委託" },
    { L"姗", L"姍" },
    { L"姜丝", L"薑絲" },
    { L"姜文杰", L"姜文杰" },
    { L"姜是老的辣", L"薑是老的辣" },
    { L"姜末", L"薑末" },
    { L"姜桂", L"薑桂" },
    { L"姜母", L"薑母" },
    { L"姜汁", L"薑汁" },
    { L"姜汤", L"薑湯" },
    { L"姜片", L"薑片" },
    { L"姜糖", L"薑糖" },
    { L"姜老辣", L"薑老辣" },
    { L"姜茶", L"薑茶" },
    { L"姜蓉", L"薑蓉" },
    { L"姜饼", L"薑餅" },
    { L"姜黄", L"薑黃" },
    { L"姹", L"奼" },
    { L"威棱", L"威稜" },
    { L"娄", L"婁" },
    { L"娅", L"婭" },
    { L"娆", L"嬈" },
    { L"娇", L"嬌" },
    { L"娈", L"孌" },
    { L"娱", L"娛" },
    { L"娲", L"媧" },
    { L"娲杆", L"媧杆" },
    { L"娴", L"嫻" },
    { L"婢仆", L"婢僕" },
    { L"婴", L"嬰" },
    { L"婵", L"嬋" },
    { L"婶", L"嬸" },
    { L"媪", L"媼" },
    { L"嫌凶", L"嫌兇" },
    { L"嫌好道丑", L"嫌好道醜" },
    { L"嫒", L"嬡" },
    { L"嫔", L"嬪" },
    { L"嫱", L"嬙" },
    { L"嬉游", L"嬉遊" },
    { L"嬖幸", L"嬖倖" },
    { L"嬴余", L"嬴餘" },
    { L"嬷", L"嬤" },
    { L"子之丰兮", L"子之丰兮" },
    { L"子云", L"子云" },
    { L"字汇", L"字彙" },
    { L"字里行间", L"字裡行間" },
    { L"存折", L"存摺" },
    { L"孙", L"孫" },
    { L"学", L"學" },
    { L"学里", L"學裡" },
    { L"孪", L"孿" },
    { L"宁", L"寧" },
    { L"宇宙志", L"宇宙誌" },
    { L"安沈铁路", L"安瀋鐵路" },
    { L"安眠药", L"安眠藥" },
    { L"安胎药", L"安胎藥" },
    { L"宗周钟", L"宗周鐘" },
    { L"官历", L"官曆" },
    { L"官地为采", L"官地為寀" },
    { L"官庄", L"官莊" },
    { L"定准", L"定準" },
    { L"定制", L"定製" },
    { L"宜云", L"宜云" },
    { L"宝", L"寶" },
    { L"宝历", L"寶曆" },
    { L"宝庄", L"寶莊" },
    { L"宝里宝气", L"寶裡寶氣" },
    { L"实", L"實" },
    { L"实干", L"實幹" },
    { L"宠", L"寵" },
    { L"审", L"審" },
    { L"宣泄", L"宣洩" },
    { L"宦游", L"宦遊" },
    { L"宪", L"憲" },
    { L"宫", L"宮" },
    { L"宫里", L"宮裡" },
    { L"宴游", L"宴遊" },
    { L"家丑", L"家醜" },
    { L"家仆", L"家僕" },
    { L"家伙", L"傢伙" },
    { L"家俱", L"傢俱" },
    { L"家具", L"傢具" },
    { L"家庄", L"家莊" },
    { L"家里", L"家裡" },
    { L"容范", L"容範" },
    { L"宽", L"寬" },
    { L"宽余", L"寬餘" },
    { L"宽宽松松", L"寬寬鬆鬆" },
    { L"宽松", L"寬鬆" },
    { L"宾", L"賓" },
    { L"寄托", L"寄託" },
    { L"密致", L"密緻" },
    { L"寇仇", L"寇讎" },
    { L"寇准", L"寇準" },
    { L"富余", L"富餘" },
    { L"寒假里", L"寒假裡" },
    { L"寒栗", L"寒慄" },
    { L"寝", L"寢" },
    { L"寡占", L"寡佔" },
    { L"寡欲", L"寡慾" },
    { L"寮采", L"寮寀" },
    { L"寸发千金", L"寸髮千金" },
    { L"对", L"對" },
    { L"对准", L"對準" },
    { L"对准表", L"對準錶" },
    { L"对准钟", L"對準鐘" },
    { L"对折", L"對摺" },
    { L"对表", L"對錶" },
    { L"寺钟", L"寺鐘" },
    { L"寻", L"尋" },
    { L"导", L"導" },
    { L"导游", L"導遊" },
    { L"寿", L"壽" },
    { L"寿面", L"壽麵" },
    { L"封后", L"封后" },
    { L"封面里", L"封面裡" },
    { L"射雕", L"射鵰" },
    { L"将", L"將" },
    { L"将占", L"將佔" },
    { L"小仆", L"小僕" },
    { L"小价", L"小价" },
    { L"小伙子", L"小夥子" },
    { L"小几", L"小几" },
    { L"小只", L"小隻" },
    { L"小周后", L"小周后" },
    { L"小型钟", L"小型鐘" },
    { L"小米面", L"小米麵" },
    { L"少占", L"少佔" },
    { L"少采", L"少採" },
    { L"尔", L"爾" },
    { L"尔冬升", L"爾冬陞" },
    { L"尘", L"塵" },
    { L"尝", L"嘗" },
    { L"尧", L"堯" },
    { L"就克制", L"就剋制" },
    { L"就范", L"就範" },
    { L"就里", L"就裡" },
    { L"尴", L"尷" },
    { L"尸", L"屍" },
    { L"尸位素餐", L"尸位素餐" },
    { L"尸利", L"尸利" },
    { L"尸居余气", L"尸居餘氣" },
    { L"尸祝", L"尸祝" },
    { L"尸禄", L"尸祿" },
    { L"尸臣", L"尸臣" },
    { L"尸谏", L"尸諫" },
    { L"尸魂界", L"尸魂界" },
    { L"尸鸠", L"尸鳩" },
    { L"尽", L"盡" },
    { L"尽先", L"儘先" },
    { L"尽其所有", L"儘其所有" },
    { L"尽力", L"儘力" },
    { L"尽可能", L"儘可能" },
    { L"尽尽", L"儘儘" },
    { L"尽快", L"儘快" },
    { L"尽早", L"儘早" },
    { L"尽是", L"儘是" },
    { L"尽管", L"儘管" },
    { L"尽速", L"儘速" },
    { L"尽量克制", L"盡量剋制" },
    { L"局里", L"局裡" },
    { L"屁股大吊了心", L"屁股大弔了心" },
    { L"层", L"層" },
    { L"屉", L"屜" },
    { L"届", L"屆" },
    { L"屋子里", L"屋子裡" },
    { L"屋梁", L"屋樑" },
    { L"屋里", L"屋裡" },
    { L"属", L"屬" },
    { L"属托", L"屬託" },
    { L"屡", L"屢" },
    { L"屡顾尔仆", L"屢顧爾僕" },
    { L"屦", L"屨" },
    { L"屯扎", L"屯紮" },
    { L"屯里", L"屯裡" },
    { L"山岳", L"山嶽" },
    { L"山崩钟应", L"山崩鐘應" },
    { L"山庄", L"山莊" },
    { L"山梁", L"山樑" },
    { L"山棱", L"山稜" },
    { L"山洞里", L"山洞裡" },
    { L"山羊胡", L"山羊鬍" },
    { L"山药", L"山藥" },
    { L"山里", L"山裡" },
    { L"山重水复", L"山重水複" },
    { L"屿", L"嶼" },
    { L"岁", L"歲" },
    { L"岁聿云暮", L"歲聿云暮" },
    { L"岂", L"豈" },
    { L"岖", L"嶇" },
    { L"岗", L"崗" },
    { L"岘", L"峴" },
    { L"岙", L"嶴" },
    { L"岚", L"嵐" },
    { L"岛", L"島" },
    { L"岭", L"嶺" },
    { L"岱岳", L"岱嶽" },
    { L"岳岳", L"嶽嶽" },
    { L"岳麓", L"嶽麓" },
    { L"岿", L"巋" },
    { L"峄", L"嶧" },
    { L"峡", L"峽" },
    { L"峤", L"嶠" },
    { L"峥", L"崢" },
    { L"峦", L"巒" },
    { L"峰回", L"峰迴" },
    { L"峻岭", L"峻岭" },
    { L"崂", L"嶗" },
    { L"崃", L"崍" },
    { L"崖广", L"崖广" },
    { L"崭", L"嶄" },
    { L"嵘", L"嶸" },
    { L"嵝", L"嶁" },
    { L"嶒棱", L"嶒稜" },
    { L"巅", L"巔" },
    { L"川谷", L"川穀" },
    { L"巡回", L"巡迴" },
    { L"巡游", L"巡遊" },
    { L"工致", L"工緻" },
    { L"左冲右突", L"左衝右突" },
    { L"巧历", L"巧曆" },
    { L"巧干", L"巧幹" },
    { L"巩", L"鞏" },
    { L"巯", L"巰" },
    { L"已占", L"已佔" },
    { L"巴尔干", L"巴爾幹" },
    { L"巷里", L"巷裡" },
    { L"币", L"幣" },
    { L"市占", L"市佔" },
    { L"市里", L"市裡" },
    { L"布于", L"佈於" },
    { L"布庄", L"布莊" },
    { L"布谷", L"布穀" },
    { L"布谷鸟钟", L"布穀鳥鐘" },
    { L"布道", L"佈道" },
    { L"布雷封锁", L"佈雷封鎖" },
    { L"布雷的", L"佈雷的" },
    { L"布雷舰", L"佈雷艦" },
    { L"布雷艇", L"佈雷艇" },
    { L"布雷速度", L"佈雷速度" },
    { L"帅", L"帥" },
    { L"师", L"師" },
    { L"师范", L"師範" },
    { L"希伯来历", L"希伯來曆" },
    { L"帏", L"幃" },
    { L"帐", L"帳" },
    { L"帘", L"簾" },
    { L"帘子", L"帘子" },
    { L"帘布", L"帘布" },
    { L"帜", L"幟" },
    { L"带", L"帶" },
    { L"带发修行", L"帶髮修行" },
    { L"带征", L"帶徵" },
    { L"帧", L"幀" },
    { L"席卷", L"席捲" },
    { L"帮", L"幫" },
    { L"帮佣", L"幫傭" },
    { L"帱", L"幬" },
    { L"帻", L"幘" },
    { L"帼", L"幗" },
    { L"幂", L"冪" },
    { L"幞", L"襆" },
    { L"干上", L"幹上" },
    { L"干下去", L"幹下去" },
    { L"干不了", L"幹不了" },
    { L"干不成", L"幹不成" },
    { L"干丝", L"乾絲" },
    { L"干个", L"幹個" },
    { L"干个够", L"乾個夠" },
    { L"干么", L"幹麼" },
    { L"干乔", L"乾喬" },
    { L"干了", L"幹了" },
    { L"干事", L"幹事" },
    { L"干井", L"乾井" },
    { L"干些", L"幹些" },
    { L"干产", L"乾產" },
    { L"干亲", L"乾親" },
    { L"干人", L"幹人" },
    { L"干什么", L"幹什麼" },
    { L"干儿", L"乾兒" },
    { L"干冰", L"乾冰" },
    { L"干冷", L"乾冷" },
    { L"干净", L"乾淨" },
    { L"干凉", L"乾涼" },
    { L"干刍", L"乾芻" },
    { L"干刻版", L"乾刻版" },
    { L"干剥剥", L"乾剝剝" },
    { L"干办", L"幹辦" },
    { L"干劲", L"幹勁" },
    { L"干劲冲天", L"幹勁沖天" },
    { L"干卦", L"乾卦" },
    { L"干台", L"乾颱" },
    { L"干号", L"乾號" },
    { L"干吊着下巴", L"乾吊著下巴" },
    { L"干吏", L"幹吏" },
    { L"干吗", L"幹嗎" },
    { L"干呕", L"乾嘔" },
    { L"干员", L"幹員" },
    { L"干和", L"乾和" },
    { L"干咳", L"乾咳" },
    { L"干咽", L"乾咽" },
    { L"干哕", L"乾噦" },
    { L"干哥", L"乾哥" },
    { L"干哭", L"乾哭" },
    { L"干唱", L"乾唱" },
    { L"干啥", L"幹啥" },
    { L"干啼", L"乾啼" },
    { L"干嘛", L"幹嘛" },
    { L"干嚎", L"乾嚎" },
    { L"干回付", L"乾回付" },
    { L"干圆洁净", L"乾圓潔淨" },
    { L"干地", L"乾地" },
    { L"干坏事", L"幹壞事" },
    { L"干坞", L"乾塢" },
    { L"干坤", L"乾坤" },
    { L"干头", L"幹頭" },
    { L"干女", L"乾女" },
    { L"干奴才", L"乾奴才" },
    { L"干妈", L"乾媽" },
    { L"干妹", L"乾妹" },
    { L"干姊", L"乾姊" },
    { L"干姜", L"乾薑" },
    { L"干娘", L"乾娘" },
    { L"干子", L"乾子" },
    { L"干季", L"乾季" },
    { L"干完", L"幹完" },
    { L"干家", L"幹家" },
    { L"干将", L"幹將" },
    { L"干尸", L"乾屍" },
    { L"干屎橛", L"乾屎橛" },
    { L"干巴", L"乾巴" },
    { L"干干", L"乾乾" },
    { L"干干净净", L"乾乾淨淨" },
    { L"干式", L"乾式" },
    { L"干弟", L"乾弟" },
    { L"干当", L"幹當" },
    { L"干得", L"幹得" },
    { L"干急", L"乾急" },
    { L"干性", L"乾性" },
    { L"干性油", L"幹性油" },
    { L"干才", L"幹才" },
    { L"干打雷", L"乾打雷" },
    { L"干折", L"乾折" },
    { L"干掉", L"幹掉" },
    { L"干探", L"幹探" },
    { L"干撂台", L"乾撂台" },
    { L"干撇下", L"乾撇下" },
    { L"干擦", L"乾擦" },
    { L"干支剌", L"乾支剌" },
    { L"干支支", L"乾支支" },
    { L"干料", L"乾料" },
    { L"干旱", L"乾旱" },
    { L"干暖", L"乾暖" },
    { L"干材", L"乾材" },
    { L"干村沙", L"乾村沙" },
    { L"干杯", L"乾杯" },
    { L"干果", L"乾果" },
    { L"干枯", L"乾枯" },
    { L"干柴", L"乾柴" },
    { L"干校", L"幹校" },
    { L"干梅", L"乾梅" },
    { L"干死", L"乾死" },
    { L"干池", L"乾池" },
    { L"干沟", L"乾溝" },
    { L"干没", L"乾沒" },
    { L"干洗", L"乾洗" },
    { L"干活", L"幹活" },
    { L"干流", L"幹流" },
    { L"干济", L"幹濟" },
    { L"干涩", L"乾澀" },
    { L"干涸", L"乾涸" },
    { L"干渠", L"乾渠" },
    { L"干渴", L"乾渴" },
    { L"干湿", L"乾濕" },
    { L"干漆", L"乾漆" },
    { L"干灯盏", L"乾燈盞" },
    { L"干热", L"乾熱" },
    { L"干熬", L"乾熬" },
    { L"干熱", L"乾熱" },
    { L"干燥", L"乾燥" },
    { L"干父之蛊", L"幹父之蠱" },
    { L"干爸", L"乾爸" },
    { L"干爹", L"乾爹" },
    { L"干爽", L"乾爽" },
    { L"干片", L"乾片" },
    { L"干球温度", L"幹球溫度" },
    { L"干甚么", L"幹甚麼" },
    { L"干生受", L"乾生受" },
    { L"干生子", L"乾生子" },
    { L"干田", L"乾田" },
    { L"干电", L"乾電" },
    { L"干略", L"幹略" },
    { L"干疥", L"乾疥" },
    { L"干瘦", L"乾瘦" },
    { L"干瘪", L"乾癟" },
    { L"干瘾", L"乾癮" },
    { L"干癣", L"乾癬" },
    { L"干白儿", L"乾白兒" },
    { L"干的", L"乾的" },
    { L"干的停当", L"幹的停當" },
    { L"干眼", L"乾眼" },
    { L"干着", L"乾著" },
    { L"干着急", L"干著急" },
    { L"干瞪眼", L"乾瞪眼" },
    { L"干礼", L"乾禮" },
    { L"干稿", L"乾稿" },
    { L"干笑", L"乾笑" },
    { L"干等", L"乾等" },
    { L"干篾片", L"乾篾片" },
    { L"干粉", L"乾粉" },
    { L"干粮", L"乾糧" },
    { L"干糇", L"乾餱" },
    { L"干系", L"干係" },
    { L"干細胞", L"幹細胞" },
    { L"干纲", L"乾綱" },
    { L"干线", L"幹線" },
    { L"干练", L"幹練" },
    { L"干细胞", L"幹細胞" },
    { L"干结", L"乾結" },
    { L"干绷", L"乾繃" },
    { L"干缺", L"幹缺" },
    { L"干群关系", L"幹群關係" },
    { L"干耗", L"乾耗" },
    { L"干肉片", L"乾肉片" },
    { L"干股", L"乾股" },
    { L"干肥", L"乾肥" },
    { L"干脆", L"乾脆" },
    { L"干花", L"乾花" },
    { L"干苔", L"乾苔" },
    { L"干茨腊", L"乾茨臘" },
    { L"干茶钱", L"乾茶錢" },
    { L"干草", L"乾草" },
    { L"干菜", L"乾菜" },
    { L"干营生", L"幹營生" },
    { L"干落", L"乾落" },
    { L"干薪", L"乾薪" },
    { L"干虔", L"乾虔" },
    { L"干蛊", L"幹蠱" },
    { L"干血浆", L"乾血漿" },
    { L"干衣", L"乾衣" },
    { L"干裂", L"乾裂" },
    { L"干警", L"幹警" },
    { L"干贝", L"乾貝" },
    { L"干货", L"乾貨" },
    { L"干起来", L"幹起來" },
    { L"干路", L"幹路" },
    { L"干躁", L"乾躁" },
    { L"干这一行", L"幹這一行" },
    { L"干这种事", L"幹這種事" },
    { L"干逼", L"乾逼" },
    { L"干道", L"幹道" },
    { L"干部", L"幹部" },
    { L"干酪", L"乾酪" },
    { L"干酵母", L"乾酵母" },
    { L"干醋", L"乾醋" },
    { L"干重", L"乾重" },
    { L"干量", L"乾量" },
    { L"干阿奶", L"乾阿奶" },
    { L"干隆", L"乾隆" },
    { L"干雷", L"乾雷" },
    { L"干霍乱", L"乾霍亂" },
    { L"干面", L"乾麵" },
    { L"干革命", L"幹革命" },
    { L"干颡", L"乾顙" },
    { L"干饭", L"乾飯" },
    { L"干馆", L"乾館" },
    { L"干馏", L"乾餾" },
    { L"干鱼", L"乾魚" },
    { L"干鲜", L"乾鮮" },
    { L"平准", L"平準" },
    { L"平泉庄", L"平泉莊" },
    { L"年代里", L"年代裡" },
    { L"年历", L"年曆" },
    { L"年谷", L"年穀" },
    { L"年里", L"年裡" },
    { L"并", L"並" },
    { L"并一不二", L"併一不二" },
    { L"并为一体", L"併為一體" },
    { L"并为一家", L"併為一家" },
    { L"并产", L"併產" },
    { L"并入", L"併入" },
    { L"并兼", L"併兼" },
    { L"并到", L"併到" },
    { L"并力", L"并力" },
    { L"并发", L"併發" },
    { L"并叠", L"併疊" },
    { L"并合", L"併合" },
    { L"并名", L"併名" },
    { L"并吞", L"并吞" },
    { L"并吞下", L"併吞下" },
    { L"并存着", L"並存著" },
    { L"并州", L"并州" },
    { L"并当", L"併當" },
    { L"并拢", L"併攏" },
    { L"并日而食", L"并日而食" },
    { L"并曰入淀", L"並曰入澱" },
    { L"并案", L"併案" },
    { L"并流", L"併流" },
    { L"并火", L"併火" },
    { L"并科", L"併科" },
    { L"并线", L"併線" },
    { L"并网", L"併網" },
    { L"并肩子", L"併肩子" },
    { L"并行", L"并行" },
    { L"并购", L"併購" },
    { L"并迭", L"并迭" },
    { L"并除", L"併除" },
    { L"并骨", L"併骨" },
    { L"幸免", L"倖免" },
    { L"幸存", L"倖存" },
    { L"幸幸", L"倖幸" },
    { L"幸运胡", L"幸運鬍" },
    { L"广", L"廣" },
    { L"广征", L"廣徵" },
    { L"广舍", L"廣捨" },
    { L"广部", L"广部" },
    { L"庄上", L"莊上" },
    { L"庄严", L"莊嚴" },
    { L"庄主", L"莊主" },
    { L"庄农", L"莊農" },
    { L"庄员", L"莊員" },
    { L"庄周", L"莊周" },
    { L"庄园", L"莊園" },
    { L"庄士顿道", L"莊士頓道" },
    { L"庄子", L"莊子" },
    { L"庄客", L"莊客" },
    { L"庄家", L"莊家" },
    { L"庄户", L"莊戶" },
    { L"庄房", L"莊房" },
    { L"庄敬", L"莊敬" },
    { L"庄田", L"莊田" },
    { L"庄稼", L"莊稼" },
    { L"庄舄越吟", L"莊舄越吟" },
    { L"庄语", L"莊語" },
    { L"庄里", L"莊裡" },
    { L"庄重", L"莊重" },
    { L"庄院", L"莊院" },
    { L"庄骚", L"莊騷" },
    { L"庆", L"慶" },
    { L"庆历", L"慶曆" },
    { L"庆吊", L"慶弔" },
    { L"庐", L"廬" },
    { L"庑", L"廡" },
    { L"库", L"庫" },
    { L"应", L"應" },
    { L"应克制", L"應剋制" },
    { L"应征", L"應徵" },
    { L"应钟", L"應鐘" },
    { L"店里", L"店裡" },
    { L"庙", L"廟" },
    { L"庙里", L"廟裡" },
    { L"府干", L"府幹" },
    { L"庞", L"龐" },
    { L"废", L"廢" },
    { L"废后", L"廢后" },
    { L"座钟", L"座鐘" },
    { L"康庄", L"康莊" },
    { L"康采恩", L"康採恩" },
    { L"廢后", L"廢后" },
    { L"廪", L"廩" },
    { L"开", L"開" },
    { L"开吊", L"開弔" },
    { L"开哄", L"開鬨" },
    { L"开征", L"開徵" },
    { L"开药", L"開藥" },
    { L"开辟", L"開闢" },
    { L"开采", L"開採" },
    { L"异", L"異" },
    { L"弃", L"棄" },
    { L"弃舍", L"棄捨" },
    { L"弄丑", L"弄醜" },
    { L"弄干", L"弄乾" },
    { L"弄松", L"弄鬆" },
    { L"弄脏", L"弄髒" },
    { L"弄鬼吊猴", L"弄鬼弔猴" },
    { L"弑", L"弒" },
    { L"引斗", L"引鬥" },
    { L"弘历", L"弘曆" },
    { L"张", L"張" },
    { L"张三丰", L"張三丰" },
    { L"张勋", L"張勳" },
    { L"弥", L"彌" },
    { L"弥山遍野", L"瀰山遍野" },
    { L"弥弥", L"瀰瀰" },
    { L"弥漫", L"瀰漫" },
    { L"弥漫着", L"瀰漫著" },
    { L"弪", L"弳" },
    { L"弯", L"彎" },
    { L"張三丰", L"張三丰" },
    { L"弹", L"彈" },
    { L"弹子台", L"彈子檯" },
    { L"弹珠台", L"彈珠檯" },
    { L"弹药", L"彈藥" },
    { L"强", L"強" },
    { L"强占", L"強佔" },
    { L"强奸", L"強姦" },
    { L"强干", L"強幹" },
    { L"归", L"歸" },
    { L"归余", L"歸餘" },
    { L"归并", L"歸併" },
    { L"当", L"當" },
    { L"当准", L"當準" },
    { L"当啷", L"噹啷" },
    { L"当当", L"噹噹" },
    { L"当着", L"當著" },
    { L"录", L"錄" },
    { L"录制", L"錄製" },
    { L"录着", L"錄著" },
    { L"形单影只", L"形單影隻" },
    { L"形影相吊", L"形影相弔" },
    { L"彦", L"彥" },
    { L"彩带", L"綵帶" },
    { L"彩排", L"綵排" },
    { L"彩楼", L"綵樓" },
    { L"彩牌楼", L"綵牌樓" },
    { L"彩球", L"綵球" },
    { L"彩线", L"綵線" },
    { L"彩绸", L"綵綢" },
    { L"彩船", L"綵船" },
    { L"彩衣", L"綵衣" },
    { L"影后", L"影后" },
    { L"彻", L"徹" },
    { L"彼此克制", L"彼此剋制" },
    { L"往复", L"往複" },
    { L"往日無仇", L"往日無讎" },
    { L"往里", L"往裡" },
    { L"征人", L"徵人" },
    { L"征令", L"徵令" },
    { L"征信", L"徵信" },
    { L"征候", L"徵候" },
    { L"征兆", L"徵兆" },
    { L"征兵", L"徵兵" },
    { L"征到", L"徵到" },
    { L"征募", L"徵募" },
    { L"征占", L"徵佔" },
    { L"征友", L"徵友" },
    { L"征发", L"徵發" },
    { L"征召", L"徵召" },
    { L"征名责实", L"徵名責實" },
    { L"征吏", L"徵吏" },
    { L"征启", L"徵啟" },
    { L"征咎", L"徵咎" },
    { L"征圣", L"徵聖" },
    { L"征士", L"徵士" },
    { L"征婚", L"徵婚" },
    { L"征实", L"徵實" },
    { L"征庸", L"徵庸" },
    { L"征引", L"徵引" },
    { L"征得", L"徵得" },
    { L"征怪", L"徵怪" },
    { L"征才", L"徵才" },
    { L"征招", L"徵招" },
    { L"征收", L"徵收" },
    { L"征效", L"徵效" },
    { L"征文", L"徵文" },
    { L"征求", L"徵求" },
    { L"征状", L"徵狀" },
    { L"征用", L"徵用" },
    { L"征税", L"徵稅" },
    { L"征稿", L"徵稿" },
    { L"征答", L"徵答" },
    { L"征结", L"徵結" },
    { L"征聘", L"徵聘" },
    { L"征训", L"徵訓" },
    { L"征询", L"徵詢" },
    { L"征调", L"徵調" },
    { L"征象", L"徵象" },
    { L"征购", L"徵購" },
    { L"征车", L"徵車" },
    { L"征辟", L"徵辟" },
    { L"征迹", L"徵跡" },
    { L"征选", L"徵選" },
    { L"征逐", L"徵逐" },
    { L"征集", L"徵集" },
    { L"征风召雨", L"徵風召雨" },
    { L"征验", L"徵驗" },
    { L"径", L"徑" },
    { L"很丑", L"很醜" },
    { L"很凶", L"很兇" },
    { L"很干", L"很乾" },
    { L"律历志", L"律曆志" },
    { L"徐干", L"徐幹" },
    { L"徒托空言", L"徒託空言" },
    { L"徕", L"徠" },
    { L"得克制", L"得剋制" },
    { L"御侮", L"禦侮" },
    { L"御寇", L"禦寇" },
    { L"御寒", L"禦寒" },
    { L"御敌", L"禦敵" },
    { L"德占", L"德佔" },
    { L"心余", L"心餘" },
    { L"心愿", L"心愿" },
    { L"心系一", L"心繫一" },
    { L"心系万", L"心繫萬" },
    { L"心系东", L"心繫東" },
    { L"心系两", L"心繫兩" },
    { L"心系中", L"心繫中" },
    { L"心系乔", L"心繫乔" },
    { L"心系五", L"心繫五" },
    { L"心系京", L"心繫京" },
    { L"心系人", L"心繫人" },
    { L"心系他", L"心繫他" },
    { L"心系伊", L"心繫伊" },
    { L"心系众", L"心繫眾" },
    { L"心系传", L"心繫傳" },
    { L"心系何", L"心繫何" },
    { L"心系你", L"心繫你" },
    { L"心系健", L"心繫健" },
    { L"心系全", L"心繫全" },
    { L"心系兰", L"心繫蘭" },
    { L"心系农", L"心繫农" },
    { L"心系功", L"心繫功" },
    { L"心系动", L"心繫動" },
    { L"心系募", L"心繫募" },
    { L"心系北", L"心繫北" },
    { L"心系十", L"心繫十" },
    { L"心系千", L"心繫千" },
    { L"心系南", L"心繫南" },
    { L"心系台", L"心繫台" },
    { L"心系和", L"心繫和" },
    { L"心系哪", L"心繫哪" },
    { L"心系唐", L"心繫唐" },
    { L"心系嘱", L"心繫囑" },
    { L"心系四", L"心繫四" },
    { L"心系困", L"心繫困" },
    { L"心系国", L"心繫國" },
    { L"心系在", L"心繫在" },
    { L"心系地", L"心繫地" },
    { L"心系大", L"心繫大" },
    { L"心系天", L"心繫天" },
    { L"心系夫", L"心繫夫" },
    { L"心系奥", L"心繫奧" },
    { L"心系女", L"心繫女" },
    { L"心系她", L"心繫她" },
    { L"心系妇", L"心繫婦" },
    { L"心系妻", L"心繫妻" },
    { L"心系子", L"心繫子" },
    { L"心系它", L"心繫它" },
    { L"心系宣", L"心繫宣" },
    { L"心系家", L"心繫家" },
    { L"心系富", L"心繫富" },
    { L"心系小", L"心繫小" },
    { L"心系山", L"心繫山" },
    { L"心系川", L"心繫川" },
    { L"心系幼", L"心繫幼" },
    { L"心系广", L"心繫廣" },
    { L"心系彼", L"心繫彼" },
    { L"心系德", L"心繫德" },
    { L"心系您", L"心繫您" },
    { L"心系慈", L"心繫慈" },
    { L"心系我", L"心繫我" },
    { L"心系摩", L"心繫摩" },
    { L"心系故", L"心繫故" },
    { L"心系新", L"心繫新" },
    { L"心系日", L"心繫日" },
    { L"心系昌", L"心繫昌" },
    { L"心系晓", L"心繫曉" },
    { L"心系曼", L"心繫曼" },
    { L"心系林", L"心繫林" },
    { L"心系母", L"心繫母" },
    { L"心系民", L"心繫民" },
    { L"心系江", L"心繫江" },
    { L"心系汶", L"心繫汶" },
    { L"心系沈", L"心繫沈" },
    { L"心系沙", L"心繫沙" },
    { L"心系泰", L"心繫泰" },
    { L"心系浙", L"心繫浙" },
    { L"心系港", L"心繫港" },
    { L"心系湖", L"心繫湖" },
    { L"心系澳", L"心繫澳" },
    { L"心系灾", L"心繫災" },
    { L"心系父", L"心繫父" },
    { L"心系生", L"心繫生" },
    { L"心系病", L"心繫病" },
    { L"心系百", L"心繫百" },
    { L"心系的", L"心繫的" },
    { L"心系着", L"心繫著" },
    { L"心系社", L"心繫社" },
    { L"心系祖", L"心繫祖" },
    { L"心系神", L"心繫神" },
    { L"心系红", L"心繫紅" },
    { L"心系美", L"心繫美" },
    { L"心系群", L"心繫群" },
    { L"心系老", L"心繫老" },
    { L"心系舞", L"心繫舞" },
    { L"心系英", L"心繫英" },
    { L"心系茶", L"心繫茶" },
    { L"心系西", L"心繫西" },
    { L"心系贫", L"心繫貧" },
    { L"心系输", L"心繫輸" },
    { L"心系近", L"心繫近" },
    { L"心系远", L"心繫遠" },
    { L"心系选", L"心繫選" },
    { L"心系重", L"心繫重" },
    { L"心系长", L"心繫長" },
    { L"心系阮", L"心繫阮" },
    { L"心系震", L"心繫震" },
    { L"心系非", L"心繫非" },
    { L"心系风", L"心繫風" },
    { L"心系香", L"心繫香" },
    { L"心系高", L"心繫高" },
    { L"心系麦", L"心繫麥" },
    { L"心系黄", L"心繫黃" },
    { L"心荡", L"心蕩" },
    { L"心药", L"心藥" },
    { L"心里", L"心裡" },
    { L"心里面", L"心裏面" },
    { L"心长发短", L"心長髮短" },
    { L"忆", L"憶" },
    { L"忏", L"懺" },
    { L"志哀", L"誌哀" },
    { L"志喜", L"誌喜" },
    { L"志庆", L"誌慶" },
    { L"志异", L"誌異" },
    { L"忙并", L"忙併" },
    { L"忙里", L"忙裡" },
    { L"忙里偷闲", L"忙裡偷閒" },
    { L"忠仆", L"忠僕" },
    { L"忧", L"憂" },
    { L"忧郁", L"憂鬱" },
    { L"快克制", L"快剋制" },
    { L"快冲", L"快衝" },
    { L"快干", L"快乾" },
    { L"忾", L"愾" },
    { L"怀", L"懷" },
    { L"怀表", L"懷錶" },
    { L"怀里", L"懷裡" },
    { L"怀钟", L"懷鐘" },
    { L"态", L"態" },
    { L"怂", L"慫" },
    { L"怃", L"憮" },
    { L"怄", L"慪" },
    { L"怅", L"悵" },
    { L"怆", L"愴" },
    { L"怎么", L"怎麼" },
    { L"怎么着", L"怎麼著" },
    { L"怒发冲冠", L"怒髮衝冠" },
    { L"怜", L"憐" },
    { L"思如泉涌", L"思如泉湧" },
    { L"急冲而下", L"急衝而下" },
    { L"性征", L"性徵" },
    { L"性欲", L"性慾" },
    { L"怪里怪气", L"怪裡怪氣" },
    { L"怫郁", L"怫鬱" },
    { L"总", L"總" },
    { L"怼", L"懟" },
    { L"怿", L"懌" },
    { L"恂栗", L"恂慄" },
    { L"恋", L"戀" },
    { L"恋恋不舍", L"戀戀不捨" },
    { L"恒", L"恆" },
    { L"恒生指数", L"恒生指數" },
    { L"恒生股价指数", L"恒生股價指數" },
    { L"恒生银行", L"恒生銀行" },
    { L"恕乏价催", L"恕乏价催" },
    { L"息交绝游", L"息交絕遊" },
    { L"息谷", L"息穀" },
    { L"恰才", L"恰纔" },
    { L"恳", L"懇" },
    { L"恳托", L"懇託" },
    { L"恶", L"惡" },
    { L"恶心", L"噁心" },
    { L"恶斗", L"惡鬥" },
    { L"恶直丑正", L"惡直醜正" },
    { L"恸", L"慟" },
    { L"恹", L"懨" },
    { L"恺", L"愷" },
    { L"恻", L"惻" },
    { L"恼", L"惱" },
    { L"恽", L"惲" },
    { L"悍药", L"悍藥" },
    { L"悒郁", L"悒鬱" },
    { L"悠悠荡荡", L"悠悠蕩蕩" },
    { L"悠游", L"悠遊" },
    { L"悠荡", L"悠蕩" },
    { L"悦", L"悅" },
    { L"您克制", L"您剋制" },
    { L"悫", L"愨" },
    { L"悬", L"懸" },
    { L"悬梁", L"懸樑" },
    { L"悬臂梁", L"懸臂樑" },
    { L"悬钟", L"懸鐘" },
    { L"悭", L"慳" },
    { L"悯", L"憫" },
    { L"悲筑", L"悲筑" },
    { L"悲郁", L"悲鬱" },
    { L"悸栗", L"悸慄" },
    { L"情欲", L"情慾" },
    { L"惇朴", L"惇樸" },
    { L"惊", L"驚" },
    { L"惊赞", L"驚讚" },
    { L"惊钟", L"驚鐘" },
    { L"惧", L"懼" },
    { L"惨", L"慘" },
    { L"惩", L"懲" },
    { L"惫", L"憊" },
    { L"惬", L"愜" },
    { L"惭", L"慚" },
    { L"惮", L"憚" },
    { L"惯", L"慣" },
    { L"想克制", L"想剋制" },
    { L"惴栗", L"惴慄" },
    { L"愈合", L"癒合" },
    { L"意克制", L"意剋制" },
    { L"意占", L"意佔" },
    { L"意大利面", L"意大利麵" },
    { L"意面", L"意麵" },
    { L"感冒药", L"感冒藥" },
    { L"愠", L"慍" },
    { L"愤", L"憤" },
    { L"愦", L"憒" },
    { L"愿", L"願" },
    { L"愿朴", L"愿樸" },
    { L"愿而恭", L"愿而恭" },
    { L"慌里慌张", L"慌裡慌張" },
    { L"慑", L"懾" },
    { L"懈松", L"懈鬆" },
    { L"懑", L"懣" },
    { L"懒", L"懶" },
    { L"懔", L"懍" },
    { L"懔栗", L"懍慄" },
    { L"懿范", L"懿範" },
    { L"戆", L"戇" },
    { L"戋", L"戔" },
    { L"戏", L"戲" },
    { L"戏彩娱亲", L"戲綵娛親" },
    { L"戏里", L"戲裡" },
    { L"成药", L"成藥" },
    { L"我克制", L"我剋制" },
    { L"戗", L"戧" },
    { L"战", L"戰" },
    { L"战天斗地", L"戰天鬥地" },
    { L"战斗", L"戰鬥" },
    { L"战栗", L"戰慄" },
    { L"截发", L"截髮" },
    { L"戬", L"戩" },
    { L"戬谷", L"戩穀" },
    { L"戯", L"戱" },
    { L"戴发含齿", L"戴髮含齒" },
    { L"戴表", L"戴錶" },
    { L"户", L"戶" },
    { L"房里", L"房裡" },
    { L"所云", L"所云" },
    { L"所云云", L"所云云" },
    { L"所占", L"所佔" },
    { L"所托", L"所託" },
    { L"扁拟谷盗虫", L"扁擬穀盜蟲" },
    { L"手冢治虫", L"手塚治虫" },
    { L"手塚治虫", L"手塚治虫" },
    { L"手折", L"手摺" },
    { L"手松", L"手鬆" },
    { L"手表", L"手錶" },
    { L"手里", L"手裡" },
    { L"才克制", L"才剋制" },
    { L"才则", L"纔則" },
    { L"才干", L"才幹" },
    { L"才得两年", L"纔得兩年" },
    { L"才此", L"纔此" },
    { L"扎上", L"紮上" },
    { L"扎下", L"紮下" },
    { L"扎囮", L"紮囮" },
    { L"扎好", L"紮好" },
    { L"扎实", L"紮實" },
    { L"扎寨", L"紮寨" },
    { L"扎带子", L"紮帶子" },
    { L"扎成", L"紮成" },
    { L"扎根", L"紮根" },
    { L"扎紧", L"紮緊" },
    { L"扎脚", L"紮腳" },
    { L"扎营", L"紮營" },
    { L"扎裹", L"紮裹" },
    { L"扎诈", L"紮詐" },
    { L"扎起", L"紮起" },
    { L"扎铁", L"紮鐵" },
    { L"扑", L"撲" },
    { L"扑作教刑", L"扑作教刑" },
    { L"扑冬", L"撲鼕" },
    { L"扑冬冬", L"撲鼕鼕" },
    { L"扑打", L"扑打" },
    { L"扑挞", L"扑撻" },
    { L"打出吊入", L"打出弔入" },
    { L"打卡钟", L"打卡鐘" },
    { L"打吨", L"打吨" },
    { L"打干", L"打幹" },
    { L"打干哕", L"打乾噦" },
    { L"打并", L"打併" },
    { L"打拼", L"打拚" },
    { L"打斗", L"打鬥" },
    { L"打着钟", L"打著鐘" },
    { L"打谷", L"打穀" },
    { L"打路庄板", L"打路莊板" },
    { L"打钟", L"打鐘" },
    { L"托买", L"託買" },
    { L"托了", L"託了" },
    { L"托事", L"託事" },
    { L"托交", L"託交" },
    { L"托人", L"託人" },
    { L"托付", L"託付" },
    { L"托儿所", L"託兒所" },
    { L"托卖", L"託賣" },
    { L"托古讽今", L"託古諷今" },
    { L"托名", L"託名" },
    { L"托命", L"託命" },
    { L"托咎", L"託咎" },
    { L"托大", L"託大" },
    { L"托孤", L"託孤" },
    { L"托庇", L"託庇" },
    { L"托故", L"託故" },
    { L"托梦", L"託夢" },
    { L"托疾", L"託疾" },
    { L"托病", L"託病" },
    { L"托管", L"託管" },
    { L"托言", L"託言" },
    { L"托词", L"託詞" },
    { L"托身", L"託身" },
    { L"托辞", L"託辭" },
    { L"托过", L"託過" },
    { L"托运", L"託運" },
    { L"托附", L"託附" },
    { L"扛大梁", L"扛大樑" },
    { L"扞御", L"扞禦" },
    { L"执", L"執" },
    { L"扩", L"擴" },
    { L"扪", L"捫" },
    { L"扫", L"掃" },
    { L"扫荡", L"掃蕩" },
    { L"扬", L"揚" },
    { L"扯面", L"扯麵" },
    { L"扰", L"擾" },
    { L"扶余国", L"扶餘國" },
    { L"批复", L"批複" },
    { L"批斗", L"批鬥" },
    { L"批注", L"批註" },
    { L"承制", L"承製" },
    { L"抑郁", L"抑鬱" },
    { L"抓奸", L"抓姦" },
    { L"抓斗", L"抓鬥" },
    { L"抓药", L"抓藥" },
    { L"投药", L"投藥" },
    { L"抗御", L"抗禦" },
    { L"抗癌药", L"抗癌藥" },
    { L"抗药", L"抗藥" },
    { L"折冲", L"折衝" },
    { L"折叠", L"摺疊" },
    { L"折合", L"摺合" },
    { L"折奏", L"摺奏" },
    { L"折子", L"摺子" },
    { L"折尺", L"摺尺" },
    { L"折扇", L"摺扇" },
    { L"折梯", L"摺梯" },
    { L"折椅", L"摺椅" },
    { L"折痕", L"摺痕" },
    { L"折篷", L"摺篷" },
    { L"折纸", L"摺紙" },
    { L"折裙", L"摺裙" },
    { L"抚", L"撫" },
    { L"抛", L"拋" },
    { L"抟", L"摶" },
    { L"抠", L"摳" },
    { L"抡", L"掄" },
    { L"抢", L"搶" },
    { L"抢占", L"搶佔" },
    { L"护", L"護" },
    { L"护发", L"護髮" },
    { L"报", L"報" },
    { L"披发", L"披髮" },
    { L"披头散发", L"披頭散髮" },
    { L"披榛采兰", L"披榛採蘭" },
    { L"抱素怀朴", L"抱素懷樸" },
    { L"抵御", L"抵禦" },
    { L"抹干", L"抹乾" },
    { L"抽公签", L"抽公籤" },
    { L"抽签", L"抽籤" },
    { L"抿发", L"抿髮" },
    { L"拂钟无声", L"拂鐘無聲" },
    { L"担", L"擔" },
    { L"担仔面", L"擔仔麵" },
    { L"担担面", L"擔擔麵" },
    { L"担着", L"擔著" },
    { L"担负着", L"擔負著" },
    { L"拆伙", L"拆夥" },
    { L"拈须", L"拈鬚" },
    { L"拉克施尔德钟", L"拉克施爾德鐘" },
    { L"拉杆", L"拉杆" },
    { L"拉纤", L"拉縴" },
    { L"拉面", L"拉麵" },
    { L"拓朴", L"拓樸" },
    { L"拔发", L"拔髮" },
    { L"拔须", L"拔鬚" },
    { L"拗别", L"拗彆" },
    { L"拙朴", L"拙樸" },
    { L"拜托", L"拜託" },
    { L"拟", L"擬" },
    { L"拢", L"攏" },
    { L"拣", L"揀" },
    { L"拥", L"擁" },
    { L"拦", L"攔" },
    { L"拧", L"擰" },
    { L"拧干", L"擰乾" },
    { L"拨", L"撥" },
    { L"拨谷", L"撥穀" },
    { L"择", L"擇" },
    { L"括发", L"括髮" },
    { L"拭干", L"拭乾" },
    { L"拮据", L"拮据" },
    { L"拼却", L"拚卻" },
    { L"拼命", L"拚命" },
    { L"拼斗", L"拚鬥" },
    { L"拼死", L"拚死" },
    { L"拼生尽死", L"拚生盡死" },
    { L"拼绝", L"拚絕" },
    { L"拼老命", L"拚老命" },
    { L"拼舍", L"拚捨" },
    { L"拾沈", L"拾瀋" },
    { L"拿下表", L"拿下錶" },
    { L"拿下钟", L"拿下鐘" },
    { L"拿准", L"拿準" },
    { L"拿破仑", L"拿破崙" },
    { L"挂", L"掛" },
    { L"挂历", L"掛曆" },
    { L"挂号", L"挂號" },
    { L"挂名", L"挂名" },
    { L"挂图", L"挂圖" },
    { L"挂帅", L"挂帥" },
    { L"挂帘", L"掛帘" },
    { L"挂彩", L"挂彩" },
    { L"挂念", L"挂念" },
    { L"挂车", L"挂車" },
    { L"挂钟", L"掛鐘" },
    { L"挂钩", L"掛鈎" },
    { L"挂面", L"挂面" },
    { L"指手划脚", L"指手劃腳" },
    { L"挌斗", L"挌鬥" },
    { L"挑大梁", L"挑大樑" },
    { L"挑斗", L"挑鬥" },
    { L"挚", L"摯" },
    { L"挛", L"攣" },
    { L"挝", L"撾" },
    { L"挞", L"撻" },
    { L"挟", L"挾" },
    { L"挠", L"撓" },
    { L"挡", L"擋" },
    { L"挢", L"撟" },
    { L"挣", L"掙" },
    { L"挤", L"擠" },
    { L"挥", L"揮" },
    { L"挥杆", L"揮杆" },
    { L"振荡", L"振蕩" },
    { L"挽曲", L"輓曲" },
    { L"挽歌", L"輓歌" },
    { L"挽联", L"輓聯" },
    { L"挽聯", L"輓聯" },
    { L"挽詞", L"輓詞" },
    { L"挽詩", L"輓詩" },
    { L"挽词", L"輓詞" },
    { L"挽诗", L"輓詩" },
    { L"捆扎", L"捆紮" },
    { L"捉发", L"捉髮" },
    { L"捉奸", L"捉姦" },
    { L"捍御", L"捍禦" },
    { L"捏面人", L"捏麵人" },
    { L"捞", L"撈" },
    { L"捞干", L"撈乾" },
    { L"捞面", L"撈麵" },
    { L"损", L"損" },
    { L"捡", L"撿" },
    { L"换", L"換" },
    { L"换发", L"換髮" },
    { L"换只", L"換隻" },
    { L"换签", L"換籤" },
    { L"换药", L"換藥" },
    { L"捣", L"搗" },
    { L"捣鬼吊白", L"搗鬼弔白" },
    { L"据", L"據" },
    { L"据云", L"據云" },
    { L"据干而窥井底", L"據榦而窺井底" },
    { L"捵面", L"捵麵" },
    { L"捶炼", L"捶鍊" },
    { L"掌柜", L"掌柜" },
    { L"排骨面", L"排骨麵" },
    { L"掣签", L"掣籤" },
    { L"接着说", L"接著說" },
    { L"推情准理", L"推情準理" },
    { L"推托", L"推託" },
    { L"掳", L"擄" },
    { L"掴", L"摑" },
    { L"掷", L"擲" },
    { L"掸", L"撣" },
    { L"掺", L"摻" },
    { L"掼", L"摜" },
    { L"提子干", L"提子乾" },
    { L"提心吊胆", L"提心弔膽" },
    { L"握发", L"握髮" },
    { L"揩干", L"揩乾" },
    { L"揪发", L"揪髮" },
    { L"揪采", L"揪採" },
    { L"揪须", L"揪鬚" },
    { L"揭丑", L"揭醜" },
    { L"揽", L"攬" },
    { L"揿", L"撳" },
    { L"搀", L"攙" },
    { L"搁", L"擱" },
    { L"搂", L"摟" },
    { L"搅", L"攪" },
    { L"搋面", L"搋麵" },
    { L"搏斗", L"搏鬥" },
    { L"搤肮拊背", L"搤肮拊背" },
    { L"搬斗", L"搬鬥" },
    { L"搭伙", L"搭夥" },
    { L"搭干铺", L"搭乾鋪" },
    { L"携", L"攜" },
    { L"搽药", L"搽藥" },
    { L"摄", L"攝" },
    { L"摄制", L"攝製" },
    { L"摅", L"攄" },
    { L"摆", L"擺" },
    { L"摆钟", L"擺鐘" },
    { L"摇", L"搖" },
    { L"摇摇荡荡", L"搖搖蕩蕩" },
    { L"摇荡", L"搖蕩" },
    { L"摈", L"擯" },
    { L"摊", L"攤" },
    { L"摧坚获丑", L"摧堅獲醜" },
    { L"摭采", L"摭採" },
    { L"摸棱", L"摸稜" },
    { L"摸钟", L"摸鐘" },
    { L"撄", L"攖" },
    { L"撇吊", L"撇弔" },
    { L"撑", L"撐" },
    { L"撚须", L"撚鬚" },
    { L"撞球台", L"撞球檯" },
    { L"撞钟", L"撞鐘" },
    { L"撞阵冲军", L"撞陣衝軍" },
    { L"撤并", L"撤併" },
    { L"撩斗", L"撩鬥" },
    { L"撵", L"攆" },
    { L"撷", L"擷" },
    { L"撸", L"擼" },
    { L"撺", L"攛" },
    { L"擀面", L"擀麵" },
    { L"操作钟", L"操作鐘" },
    { L"擘划", L"擘劃" },
    { L"擞", L"擻" },
    { L"擢发", L"擢髮" },
    { L"擦干", L"擦乾" },
    { L"擦干净", L"擦乾淨" },
    { L"擦药", L"擦藥" },
    { L"攒", L"攢" },
    { L"支干", L"支幹" },
    { L"支杆", L"支杆" },
    { L"收获", L"收穫" },
    { L"改征", L"改徵" },
    { L"攻占", L"攻佔" },
    { L"放松", L"放鬆" },
    { L"放荡", L"放蕩" },
    { L"放蒙挣", L"放懞掙" },
    { L"故事里", L"故事裡" },
    { L"故云", L"故云" },
    { L"敌", L"敵" },
    { L"敌忾同仇", L"敵愾同讎" },
    { L"救药", L"救藥" },
    { L"教学钟", L"教學鐘" },
    { L"教范", L"教範" },
    { L"敛", L"斂" },
    { L"敢干", L"敢幹" },
    { L"散伙", L"散夥" },
    { L"散荡", L"散蕩" },
    { L"敦朴", L"敦樸" },
    { L"敬挽", L"敬輓" },
    { L"数", L"數" },
    { L"数与虏确", L"數與虜确" },
    { L"数字钟", L"數字鐘" },
    { L"数罪并罚", L"數罪併罰" },
    { L"敲扑", L"敲扑" },
    { L"敲钟", L"敲鐘" },
    { L"整发用品", L"整髮用品" },
    { L"整只", L"整隻" },
    { L"整庄", L"整莊" },
    { L"敷药", L"敷藥" },
    { L"文征明", L"文徵明" },
    { L"文思泉涌", L"文思泉湧" },
    { L"斋", L"齋" },
    { L"斓", L"斕" },
    { L"斗上", L"鬥上" },
    { L"斗不过", L"鬥不過" },
    { L"斗丽", L"鬥麗" },
    { L"斗了", L"鬥了" },
    { L"斗争", L"鬥爭" },
    { L"斗倒", L"鬥倒" },
    { L"斗分子", L"鬥分子" },
    { L"斗别气", L"鬥彆氣" },
    { L"斗力", L"鬥力" },
    { L"斗劲", L"鬥勁" },
    { L"斗叠", L"鬥疊" },
    { L"斗口", L"鬥口" },
    { L"斗叶儿", L"鬥葉兒" },
    { L"斗叶子", L"鬥葉子" },
    { L"斗合", L"鬥合" },
    { L"斗哄", L"鬥鬨" },
    { L"斗嘴", L"鬥嘴" },
    { L"斗地主", L"鬥地主" },
    { L"斗士", L"鬥士" },
    { L"斗头", L"鬥頭" },
    { L"斗富", L"鬥富" },
    { L"斗巧", L"鬥巧" },
    { L"斗幌子", L"鬥幌子" },
    { L"斗弄", L"鬥弄" },
    { L"斗引", L"鬥引" },
    { L"斗彩", L"鬥彩" },
    { L"斗心眼", L"鬥心眼" },
    { L"斗志", L"鬥志" },
    { L"斗成", L"鬥成" },
    { L"斗打", L"鬥打" },
    { L"斗批改", L"鬥批改" },
    { L"斗技", L"鬥技" },
    { L"斗文", L"鬥文" },
    { L"斗斗", L"鬥鬥" },
    { L"斗智", L"鬥智" },
    { L"斗暴", L"鬥暴" },
    { L"斗来斗去", L"鬥來鬥去" },
    { L"斗武", L"鬥武" },
    { L"斗殴", L"鬥毆" },
    { L"斗气", L"鬥氣" },
    { L"斗法", L"鬥法" },
    { L"斗牌", L"鬥牌" },
    { L"斗牙拌齿", L"鬥牙拌齒" },
    { L"斗牙斗齿", L"鬥牙鬥齒" },
    { L"斗牛", L"鬥牛" },
    { L"斗犀台", L"鬥犀臺" },
    { L"斗犬", L"鬥犬" },
    { L"斗狠", L"鬥狠" },
    { L"斗百草", L"鬥百草" },
    { L"斗眼", L"鬥眼" },
    { L"斗着", L"鬥著" },
    { L"斗私批修", L"鬥私批修" },
    { L"斗而铸兵", L"鬥而鑄兵" },
    { L"斗而铸锥", L"鬥而鑄錐" },
    { L"斗胜", L"鬥勝" },
    { L"斗脚", L"鬥腳" },
    { L"斗舰", L"鬥艦" },
    { L"斗艳", L"鬥豔" },
    { L"斗茶", L"鬥茶" },
    { L"斗草", L"鬥草" },
    { L"斗蟋蟀", L"鬥蟋蟀" },
    { L"斗话", L"鬥話" },
    { L"斗起", L"鬥起" },
    { L"斗趣", L"鬥趣" },
    { L"斗闲气", L"鬥閑氣" },
    { L"斗闷", L"鬥悶" },
    { L"斗雪红", L"鬥雪紅" },
    { L"斗风", L"鬥風" },
    { L"斗鱼", L"鬥魚" },
    { L"斗鸡", L"鬥雞" },
    { L"斗鸭", L"鬥鴨" },
    { L"斗鹌鹑", L"鬥鵪鶉" },
    { L"斩", L"斬" },
    { L"斫雕为朴", L"斫雕為樸" },
    { L"断", L"斷" },
    { L"断发", L"斷髮" },
    { L"新历", L"新曆" },
    { L"新庄", L"新莊" },
    { L"新扎", L"新紮" },
    { L"斲雕为朴", L"斲雕為樸" },
    { L"方便面", L"方便麵" },
    { L"方几", L"方几" },
    { L"方志", L"方誌" },
    { L"施舍", L"施捨" },
    { L"施药", L"施藥" },
    { L"旁征博引", L"旁徵博引" },
    { L"旁注", L"旁註" },
    { L"旅游", L"旅遊" },
    { L"旋回", L"旋迴" },
    { L"旋干转坤", L"旋乾轉坤" },
    { L"旋绕着", L"旋繞著" },
    { L"族里", L"族裡" },
    { L"旗杆", L"旗杆" },
    { L"无", L"無" },
    { L"无余", L"無餘" },
    { L"无征不信", L"無徵不信" },
    { L"无梁楼盖", L"無樑樓蓋" },
    { L"无法克制", L"無法剋制" },
    { L"无药可救", L"無藥可救" },
    { L"日占", L"日佔" },
    { L"日历", L"日曆" },
    { L"日子里", L"日子裡" },
    { L"日志", L"日誌" },
    { L"日晒", L"日晒" },
    { L"旧", L"舊" },
    { L"旧历", L"舊曆" },
    { L"旧游", L"舊遊" },
    { L"旧药", L"舊藥" },
    { L"旧表", L"舊錶" },
    { L"旧钟", L"舊鐘" },
    { L"旧钟表", L"舊鐘錶" },
    { L"旱干", L"旱乾" },
    { L"时", L"時" },
    { L"时钟", L"時鐘" },
    { L"时间里", L"時間裡" },
    { L"旷", L"曠" },
    { L"昆仑", L"崑崙" },
    { L"昆仑山", L"昆崙山" },
    { L"昆剧", L"崑劇" },
    { L"昆山", L"崑山" },
    { L"昆曲", L"崑曲" },
    { L"昆腔", L"崑腔" },
    { L"昆苏", L"崑蘇" },
    { L"昆调", L"崑調" },
    { L"明征", L"明徵" },
    { L"明目张胆", L"明目張胆" },
    { L"明窗净几", L"明窗淨几" },
    { L"明范", L"明範" },
    { L"明里", L"明裡" },
    { L"易克制", L"易剋制" },
    { L"昙", L"曇" },
    { L"星历", L"星曆" },
    { L"星辰表", L"星辰錶" },
    { L"春假里", L"春假裡" },
    { L"春天里", L"春天裡" },
    { L"春日里", L"春日裡" },
    { L"春游", L"春遊" },
    { L"春药", L"春藥" },
    { L"春香斗学", L"春香鬥學" },
    { L"昼", L"晝" },
    { L"显", L"顯" },
    { L"显示表", L"顯示錶" },
    { L"显示钟", L"顯示鐘" },
    { L"晃荡", L"晃蕩" },
    { L"晋", L"晉" },
    { L"晋升", L"晉陞" },
    { L"晒", L"曬" },
    { L"晒伤", L"晒傷" },
    { L"晒图", L"晒圖" },
    { L"晒干", L"晒乾" },
    { L"晒成", L"晒成" },
    { L"晒晒", L"晒晒" },
    { L"晒烟", L"晒煙" },
    { L"晒种", L"晒種" },
    { L"晒衣", L"晒衣" },
    { L"晒谷", L"曬穀" },
    { L"晒黑", L"晒黑" },
    { L"晓", L"曉" },
    { L"晔", L"曄" },
    { L"晕", L"暈" },
    { L"晕船药", L"暈船藥" },
    { L"晕车药", L"暈車藥" },
    { L"晖", L"暉" },
    { L"晚钟", L"晚鐘" },
    { L"晞发", L"晞髮" },
    { L"晨钟", L"晨鐘" },
    { L"普冬冬", L"普鼕鼕" },
    { L"景致", L"景緻" },
    { L"晾干", L"晾乾" },
    { L"暂", L"暫" },
    { L"暑假里", L"暑假裡" },
    { L"暗地里", L"暗地裡" },
    { L"暗斗", L"暗鬥" },
    { L"暗沟里", L"暗溝裡" },
    { L"暗里", L"暗裡" },
    { L"暧", L"曖" },
    { L"暴敛横征", L"暴斂橫徵" },
    { L"暴晒", L"暴晒" },
    { L"曝晒", L"曝晒" },
    { L"曰云", L"曰云" },
    { L"曲尘", L"麴塵" },
    { L"曲生", L"麴生" },
    { L"曲秀才", L"麴秀才" },
    { L"曲菌", L"麴菌" },
    { L"曲蘖", L"麴櫱" },
    { L"曲车", L"麴車" },
    { L"曲道士", L"麴道士" },
    { L"曲钱", L"麴錢" },
    { L"曲院", L"麴院" },
    { L"曲霉", L"麴黴" },
    { L"更仆难数", L"更僕難數" },
    { L"更签", L"更籤" },
    { L"更钟", L"更鐘" },
    { L"曾朴", L"曾樸" },
    { L"月历", L"月曆" },
    { L"有事之无范", L"有事之無範" },
    { L"有仆", L"有僕" },
    { L"有余", L"有餘" },
    { L"有准", L"有準" },
    { L"有发头陀寺", L"有髮頭陀寺" },
    { L"有只", L"有隻" },
    { L"有只采", L"有只採" },
    { L"有够赞", L"有夠讚" },
    { L"有征", L"有徵" },
    { L"有恒街", L"有恒街" },
    { L"有栖川", L"有栖川" },
    { L"有棱有角", L"有稜有角" },
    { L"服药", L"服藥" },
    { L"望后石", L"望后石" },
    { L"望着表", L"望著錶" },
    { L"望着钟", L"望著鐘" },
    { L"望着钟表", L"望著鐘錶" },
    { L"朝钟", L"朝鐘" },
    { L"木偶戏扎", L"木偶戲紮" },
    { L"木制", L"木製" },
    { L"木杆", L"木杆" },
    { L"木材干馏", L"木材乾餾" },
    { L"木梁", L"木樑" },
    { L"木钟", L"木鐘" },
    { L"未干", L"未乾" },
    { L"末药", L"末藥" },
    { L"本征", L"本徵" },
    { L"术", L"術" },
    { L"术赤", L"朮赤" },
    { L"朱仑街", L"朱崙街" },
    { L"朱唇皓齿", L"硃唇皓齒" },
    { L"朱庆余", L"朱慶餘" },
    { L"朱批", L"硃批" },
    { L"朱理安历", L"朱理安曆" },
    { L"朱砂", L"硃砂" },
    { L"朱笔", L"硃筆" },
    { L"朱红色", L"硃紅色" },
    { L"朱色", L"硃色" },
    { L"朱谕", L"硃諭" },
    { L"朴修斯", L"樸修斯" },
    { L"朴厚", L"樸厚" },
    { L"朴学", L"樸學" },
    { L"朴实", L"樸實" },
    { L"朴念仁", L"樸念仁" },
    { L"朴拙", L"樸拙" },
    { L"朴樕", L"樸樕" },
    { L"朴父", L"樸父" },
    { L"朴直", L"樸直" },
    { L"朴素", L"樸素" },
    { L"朴讷", L"樸訥" },
    { L"朴质", L"樸質" },
    { L"朴鄙", L"樸鄙" },
    { L"朴重", L"樸重" },
    { L"朴野", L"樸野" },
    { L"朴钝", L"樸鈍" },
    { L"朴陋", L"樸陋" },
    { L"朴马", L"樸馬" },
    { L"朴鲁", L"樸魯" },
    { L"机", L"機" },
    { L"机械表", L"機械錶" },
    { L"机械钟", L"機械鐘" },
    { L"机绣", L"機繡" },
    { L"杀", L"殺" },
    { L"杀虫药", L"殺蟲藥" },
    { L"杂", L"雜" },
    { L"杂合面儿", L"雜合麵兒" },
    { L"杂志", L"雜誌" },
    { L"杂面", L"雜麵" },
    { L"权", L"權" },
    { L"杆", L"桿" },
    { L"杆子", L"杆子" },
    { L"李连杰", L"李連杰" },
    { L"李連杰", L"李連杰" },
    { L"材干", L"材幹" },
    { L"村子里", L"村子裡" },
    { L"村庄", L"村莊" },
    { L"村里", L"村裡" },
    { L"杜老志道", L"杜老誌道" },
    { L"杞宋无征", L"杞宋無徵" },
    { L"束发", L"束髮" },
    { L"杠杆", L"槓桿" },
    { L"条", L"條" },
    { L"条干", L"條幹" },
    { L"来", L"來" },
    { L"来复", L"來複" },
    { L"杨", L"楊" },
    { L"杩", L"榪" },
    { L"杯干", L"杯乾" },
    { L"杯面", L"杯麵" },
    { L"杰", L"傑" },
    { L"杰伦", L"杰倫" },
    { L"杰特", L"杰特" },
    { L"松一口气", L"鬆一口氣" },
    { L"松了", L"鬆了" },
    { L"松些", L"鬆些" },
    { L"松元音", L"鬆元音" },
    { L"松动", L"鬆動" },
    { L"松劲", L"鬆勁" },
    { L"松口", L"鬆口" },
    { L"松喉", L"鬆喉" },
    { L"松土", L"鬆土" },
    { L"松宽", L"鬆寬" },
    { L"松开", L"鬆開" },
    { L"松弛", L"鬆弛" },
    { L"松快", L"鬆快" },
    { L"松懈", L"鬆懈" },
    { L"松手", L"鬆手" },
    { L"松掉", L"鬆掉" },
    { L"松散", L"鬆散" },
    { L"松松", L"鬆鬆" },
    { L"松柔", L"鬆柔" },
    { L"松气", L"鬆氣" },
    { L"松浮", L"鬆浮" },
    { L"松紧", L"鬆緊" },
    { L"松绑", L"鬆綁" },
    { L"松缓", L"鬆緩" },
    { L"松脆", L"鬆脆" },
    { L"松脱", L"鬆脫" },
    { L"松蛋", L"鬆蛋" },
    { L"松起", L"鬆起" },
    { L"松软", L"鬆軟" },
    { L"松通", L"鬆通" },
    { L"松饼", L"鬆餅" },
    { L"板着脸", L"板著臉" },
    { L"板荡", L"板蕩" },
    { L"极", L"極" },
    { L"构", L"構" },
    { L"林宏岳", L"林宏嶽" },
    { L"林钟", L"林鐘" },
    { L"果子干", L"果子乾" },
    { L"果干", L"果乾" },
    { L"枝不得大于干", L"枝不得大於榦" },
    { L"枝干", L"枝幹" },
    { L"枞", L"樅" },
    { L"枢", L"樞" },
    { L"枣", L"棗" },
    { L"枣庄", L"棗莊" },
    { L"枥", L"櫪" },
    { L"枨", L"棖" },
    { L"枪", L"槍" },
    { L"枫", L"楓" },
    { L"枭", L"梟" },
    { L"枯干", L"枯乾" },
    { L"架钟", L"架鐘" },
    { L"某只", L"某隻" },
    { L"染发", L"染髮" },
    { L"染殿后", L"染殿后" },
    { L"柜", L"櫃" },
    { L"柜上", L"柜上" },
    { L"柜台", L"櫃檯" },
    { L"柜子", L"柜子" },
    { L"柜柳", L"柜柳" },
    { L"柠", L"檸" },
    { L"柱梁", L"柱樑" },
    { L"柳诒征", L"柳詒徵" },
    { L"柽", L"檉" },
    { L"栀", L"梔" },
    { L"栅", L"柵" },
    { L"标", L"標" },
    { L"标准", L"標準" },
    { L"标志", L"標誌" },
    { L"标杆", L"標杆" },
    { L"标注", L"標註" },
    { L"标签", L"標籤" },
    { L"标致", L"標緻" },
    { L"栈", L"棧" },
    { L"栉", L"櫛" },
    { L"栉发工", L"櫛髮工" },
    { L"栊", L"櫳" },
    { L"栋", L"棟" },
    { L"栋梁", L"棟樑" },
    { L"栌", L"櫨" },
    { L"栎", L"櫟" },
    { L"栏", L"欄" },
    { L"栏杆", L"欄杆" },
    { L"树", L"樹" },
    { L"树干", L"樹榦" },
    { L"树梁", L"樹樑" },
    { L"栖", L"棲" },
    { L"栖栖皇皇", L"栖栖皇皇" },
    { L"栗冽", L"慄冽" },
    { L"栗栗", L"慄慄" },
    { L"校仇", L"校讎" },
    { L"校准", L"校準" },
    { L"样", L"樣" },
    { L"样范", L"樣範" },
    { L"格斗", L"格鬥" },
    { L"格范", L"格範" },
    { L"格里历", L"格里曆" },
    { L"格里高利历", L"格里高利曆" },
    { L"栾", L"欒" },
    { L"桂圆干", L"桂圓乾" },
    { L"桅杆", L"桅杆" },
    { L"桌几", L"桌几" },
    { L"桌历", L"桌曆" },
    { L"桑干", L"桑乾" },
    { L"桠", L"椏" },
    { L"桡", L"橈" },
    { L"桢", L"楨" },
    { L"桢干", L"楨幹" },
    { L"档", L"檔" },
    { L"桤", L"榿" },
    { L"桥", L"橋" },
    { L"桥梁", L"橋樑" },
    { L"桦", L"樺" },
    { L"桧", L"檜" },
    { L"桨", L"槳" },
    { L"桩", L"樁" },
    { L"梁上", L"樑上" },
    { L"梁柱", L"樑柱" },
    { L"梦", L"夢" },
    { L"梦游", L"夢遊" },
    { L"梦里", L"夢裡" },
    { L"梨干", L"梨乾" },
    { L"梯冲", L"梯衝" },
    { L"械斗", L"械鬥" },
    { L"械系", L"械繫" },
    { L"梼", L"檮" },
    { L"检", L"檢" },
    { L"棂", L"欞" },
    { L"棉制", L"棉製" },
    { L"棒子面", L"棒子麵" },
    { L"棫朴", L"棫樸" },
    { L"森林里", L"森林裡" },
    { L"棱体", L"稜體" },
    { L"棱台", L"稜台" },
    { L"棱子", L"稜子" },
    { L"棱层", L"稜層" },
    { L"棱柱", L"稜柱" },
    { L"棱棱", L"稜稜" },
    { L"棱登", L"稜登" },
    { L"棱等登", L"稜等登" },
    { L"棱线", L"稜線" },
    { L"棱缝", L"稜縫" },
    { L"棱角", L"稜角" },
    { L"棱锥", L"稜錐" },
    { L"棱镜", L"稜鏡" },
    { L"棺材里", L"棺材裡" },
    { L"椁", L"槨" },
    { L"植发", L"植髮" },
    { L"椟", L"櫝" },
    { L"椠", L"槧" },
    { L"椤", L"欏" },
    { L"椭", L"橢" },
    { L"椰枣干", L"椰棗乾" },
    { L"楚庄王", L"楚莊王" },
    { L"楚庄绝缨", L"楚莊絕纓" },
    { L"楚庄问鼎", L"楚莊問鼎" },
    { L"楼", L"樓" },
    { L"榄", L"欖" },
    { L"榇", L"櫬" },
    { L"榈", L"櫚" },
    { L"榉", L"櫸" },
    { L"榨干", L"榨乾" },
    { L"槛", L"檻" },
    { L"槟", L"檳" },
    { L"槠", L"櫧" },
    { L"模制", L"模製" },
    { L"模棱", L"模稜" },
    { L"模范", L"模範" },
    { L"横", L"橫" },
    { L"横冲", L"橫衝" },
    { L"横征暴敛", L"橫徵暴斂" },
    { L"横杆", L"橫杆" },
    { L"横梁", L"橫樑" },
    { L"樯", L"檣" },
    { L"樱", L"櫻" },
    { L"樵采", L"樵採" },
    { L"橥", L"櫫" },
    { L"橱", L"櫥" },
    { L"橹", L"櫓" },
    { L"橼", L"櫞" },
    { L"檩", L"檁" },
    { L"欢", L"歡" },
    { L"欤", L"歟" },
    { L"欧", L"歐" },
    { L"欧游", L"歐遊" },
    { L"欲令智昏", L"慾令智昏" },
    { L"欲壑难填", L"慾壑難填" },
    { L"欲念", L"慾念" },
    { L"欲望", L"慾望" },
    { L"欲海", L"慾海" },
    { L"欲火", L"慾火" },
    { L"欲障", L"慾障" },
    { L"欺蒙", L"欺矇" },
    { L"歌后", L"歌后" },
    { L"歌钟", L"歌鐘" },
    { L"止咳药", L"止咳藥" },
    { L"止痛药", L"止痛藥" },
    { L"止血药", L"止血藥" },
    { L"正在叱咤", L"正在叱咤" },
    { L"武后", L"武后" },
    { L"武斗", L"武鬥" },
    { L"歹斗", L"歹鬥" },
    { L"死里求生", L"死裡求生" },
    { L"死里逃生", L"死裡逃生" },
    { L"歼", L"殲" },
    { L"殁", L"歿" },
    { L"殇", L"殤" },
    { L"残", L"殘" },
    { L"残余", L"殘餘" },
    { L"残肴", L"殘肴" },
    { L"殒", L"殞" },
    { L"殓", L"殮" },
    { L"殖谷", L"殖穀" },
    { L"殚", L"殫" },
    { L"殡", L"殯" },
    { L"殴", L"毆" },
    { L"殴斗", L"毆鬥" },
    { L"殷师牛斗", L"殷師牛鬥" },
    { L"殿钟自鸣", L"殿鐘自鳴" },
    { L"毁", L"毀" },
    { L"毁钟为铎", L"毀鐘為鐸" },
    { L"毂", L"轂" },
    { L"母丑", L"母醜" },
    { L"母后", L"母后" },
    { L"母范", L"母範" },
    { L"每只", L"每隻" },
    { L"毒药", L"毒藥" },
    { L"比划", L"比劃" },
    { L"毕", L"畢" },
    { L"毙", L"斃" },
    { L"毛发", L"毛髮" },
    { L"毛坏", L"毛坏" },
    { L"毛姜", L"毛薑" },
    { L"毡", L"氈" },
    { L"毫厘", L"毫釐" },
    { L"毫发", L"毫髮" },
    { L"毵", L"毿" },
    { L"氇", L"氌" },
    { L"气", L"氣" },
    { L"气郁", L"氣鬱" },
    { L"氢", L"氫" },
    { L"氤郁", L"氤鬱" },
    { L"氩", L"氬" },
    { L"氲", L"氳" },
    { L"水准", L"水準" },
    { L"水来汤里去", L"水來湯裡去" },
    { L"水里", L"水裡" },
    { L"永历", L"永曆" },
    { L"永志不忘", L"永誌不忘" },
    { L"求知欲", L"求知慾" },
    { L"求签", L"求籤" },
    { L"汇", L"匯" },
    { L"汇刊", L"彙刊" },
    { L"汇报", L"彙報" },
    { L"汇整", L"彙整" },
    { L"汇算", L"彙算" },
    { L"汇纂", L"彙纂" },
    { L"汇编", L"彙編" },
    { L"汇辑", L"彙輯" },
    { L"汇集", L"彙集" },
    { L"汉", L"漢" },
    { L"汉弥登钟", L"漢彌登鐘" },
    { L"池里", L"池裡" },
    { L"污蔑", L"污衊" },
    { L"汤", L"湯" },
    { L"汤下面", L"湯下麵" },
    { L"汤团", L"湯糰" },
    { L"汤药", L"湯藥" },
    { L"汤面", L"湯麵" },
    { L"汹", L"洶" },
    { L"汹涌", L"洶湧" },
    { L"沈吉线", L"瀋吉線" },
    { L"沈山线", L"瀋山線" },
    { L"沈州", L"瀋州" },
    { L"沈水", L"瀋水" },
    { L"沈河", L"瀋河" },
    { L"沈海", L"瀋海" },
    { L"沈淀", L"沈澱" },
    { L"沈着", L"沈著" },
    { L"沈郁", L"沈鬱" },
    { L"沈阳", L"瀋陽" },
    { L"沉淀", L"沉澱" },
    { L"沉郁", L"沉鬱" },
    { L"沙里淘金", L"沙裡淘金" },
    { L"沟", L"溝" },
    { L"没", L"沒" },
    { L"没事干", L"沒事幹" },
    { L"没准", L"沒準" },
    { L"没干", L"沒幹" },
    { L"没干没净", L"沒乾沒淨" },
    { L"没折至", L"沒摺至" },
    { L"没梢干", L"沒梢幹" },
    { L"没药", L"沒藥" },
    { L"沣", L"灃" },
    { L"沤", L"漚" },
    { L"沤郁", L"漚鬱" },
    { L"沥", L"瀝" },
    { L"沦", L"淪" },
    { L"沧", L"滄" },
    { L"沩", L"溈" },
    { L"沪", L"滬" },
    { L"河岳", L"河嶽" },
    { L"河里", L"河裡" },
    { L"油斗", L"油鬥" },
    { L"油面", L"油麵" },
    { L"治愈", L"治癒" },
    { L"沿溯", L"沿泝" },
    { L"泄欲", L"洩慾" },
    { L"法占", L"法佔" },
    { L"泛游", L"泛遊" },
    { L"泞", L"濘" },
    { L"泡制", L"泡製" },
    { L"泡面", L"泡麵" },
    { L"波发藻", L"波髮藻" },
    { L"波棱菜", L"波稜菜" },
    { L"注上", L"註上" },
    { L"注云", L"注云" },
    { L"注册", L"註冊" },
    { L"注失", L"註失" },
    { L"注定", L"註定" },
    { L"注明", L"註明" },
    { L"注标", L"註標" },
    { L"注生娘娘", L"註生娘娘" },
    { L"注疏", L"註疏" },
    { L"注脚", L"註腳" },
    { L"注解", L"註解" },
    { L"注记", L"註記" },
    { L"注译", L"註譯" },
    { L"注销", L"註銷" },
    { L"泪", L"淚" },
    { L"泪如泉涌", L"淚如泉湧" },
    { L"泪干", L"淚乾" },
    { L"泱郁", L"泱鬱" },
    { L"泳气钟", L"泳氣鐘" },
    { L"泶", L"澩" },
    { L"泷", L"瀧" },
    { L"泸", L"瀘" },
    { L"泺", L"濼" },
    { L"泻", L"瀉" },
    { L"泻药", L"瀉藥" },
    { L"泼", L"潑" },
    { L"泽", L"澤" },
    { L"泽渗漓而下降", L"澤滲灕而下降" },
    { L"泾", L"涇" },
    { L"洁", L"潔" },
    { L"洄游", L"洄遊" },
    { L"洒", L"灑" },
    { L"洒家", L"洒家" },
    { L"洒扫", L"洒掃" },
    { L"洒水", L"洒水" },
    { L"洒洒", L"洒洒" },
    { L"洒涤", L"洒滌" },
    { L"洒淅", L"洒淅" },
    { L"洒濯", L"洒濯" },
    { L"洒然", L"洒然" },
    { L"洒脱", L"洒脫" },
    { L"洗发", L"洗髮" },
    { L"洗炼", L"洗鍊" },
    { L"洗练", L"洗鍊" },
    { L"洛钟东应", L"洛鐘東應" },
    { L"洪范", L"洪範" },
    { L"洪适", L"洪适" },
    { L"洪钟", L"洪鐘" },
    { L"洼", L"窪" },
    { L"流征", L"流徵" },
    { L"流荡", L"流蕩" },
    { L"浃", L"浹" },
    { L"浅", L"淺" },
    { L"浅淀", L"淺澱" },
    { L"浆", L"漿" },
    { L"浇", L"澆" },
    { L"浈", L"湞" },
    { L"浊", L"濁" },
    { L"测", L"測" },
    { L"浍", L"澮" },
    { L"济", L"濟" },
    { L"浏", L"瀏" },
    { L"浑", L"渾" },
    { L"浑个", L"渾箇" },
    { L"浑朴", L"渾樸" },
    { L"浒", L"滸" },
    { L"浓", L"濃" },
    { L"浓发", L"濃髮" },
    { L"浔", L"潯" },
    { L"浩浩荡荡", L"浩浩蕩蕩" },
    { L"浩荡", L"浩蕩" },
    { L"浪游", L"浪遊" },
    { L"浪琴表", L"浪琴錶" },
    { L"浪荡", L"浪蕩" },
    { L"浮松", L"浮鬆" },
    { L"浮荡", L"浮蕩" },
    { L"海上布雷", L"海上佈雷" },
    { L"海干", L"海乾" },
    { L"海湾布雷", L"海灣佈雷" },
    { L"涂", L"塗" },
    { L"涂善妮", L"涂善妮" },
    { L"涂坤", L"涂坤" },
    { L"涂壮勋", L"涂壯勳" },
    { L"涂壯勳", L"涂壯勳" },
    { L"涂天相", L"涂天相" },
    { L"涂姓", L"涂姓" },
    { L"涂序瑄", L"涂序瑄" },
    { L"涂敏恆", L"涂敏恆" },
    { L"涂敏恒", L"涂敏恆" },
    { L"涂泽民", L"涂澤民" },
    { L"涂澤民", L"涂澤民" },
    { L"涂着", L"塗著" },
    { L"涂绍煃", L"涂紹煃" },
    { L"涂羽卿", L"涂羽卿" },
    { L"涂药", L"塗藥" },
    { L"涂謹申", L"涂謹申" },
    { L"涂谨申", L"涂謹申" },
    { L"涂逢年", L"涂逢年" },
    { L"涂醒哲", L"涂醒哲" },
    { L"涂長望", L"涂長望" },
    { L"涂长望", L"涂長望" },
    { L"涂鴻欽", L"涂鴻欽" },
    { L"涂鸿钦", L"涂鴻欽" },
    { L"消炎药", L"消炎藥" },
    { L"消肿药", L"消腫藥" },
    { L"涌上", L"湧上" },
    { L"涌入", L"湧入" },
    { L"涌出", L"湧出" },
    { L"涌向", L"湧向" },
    { L"涌来", L"湧來" },
    { L"涌泉", L"湧泉" },
    { L"涌现", L"湧現" },
    { L"涌起", L"湧起" },
    { L"涌进", L"湧進" },
    { L"涛", L"濤" },
    { L"涝", L"澇" },
    { L"涞", L"淶" },
    { L"涟", L"漣" },
    { L"涠", L"潿" },
    { L"涡", L"渦" },
    { L"涣", L"渙" },
    { L"涤", L"滌" },
    { L"润", L"潤" },
    { L"涧", L"澗" },
    { L"涨", L"漲" },
    { L"涩", L"澀" },
    { L"液晶表", L"液晶錶" },
    { L"涳蒙", L"涳濛" },
    { L"涸干", L"涸乾" },
    { L"淀乃不耕之地", L"澱乃不耕之地" },
    { L"淀北片", L"澱北片" },
    { L"淀山", L"澱山" },
    { L"淀淀", L"澱澱" },
    { L"淀积", L"澱積" },
    { L"淀粉", L"澱粉" },
    { L"淀解物", L"澱解物" },
    { L"淀谓之滓", L"澱謂之滓" },
    { L"淋余土", L"淋餘土" },
    { L"淑范", L"淑範" },
    { L"淡朱", L"淡硃" },
    { L"淡蒙蒙", L"淡濛濛" },
    { L"淫欲", L"淫慾" },
    { L"淫荡", L"淫蕩" },
    { L"淬炼", L"淬鍊" },
    { L"深山何处钟", L"深山何處鐘" },
    { L"深渊里", L"深淵裡" },
    { L"淳于", L"淳于" },
    { L"淳朴", L"淳樸" },
    { L"清汤挂面", L"清湯掛麵" },
    { L"渊", L"淵" },
    { L"渊淳岳峙", L"淵淳嶽峙" },
    { L"渌", L"淥" },
    { L"渍", L"漬" },
    { L"渎", L"瀆" },
    { L"渐", L"漸" },
    { L"渑", L"澠" },
    { L"渔", L"漁" },
    { L"渖", L"瀋" },
    { L"渗", L"滲" },
    { L"渠冲", L"渠衝" },
    { L"温", L"溫" },
    { L"港制", L"港製" },
    { L"游丝", L"遊絲" },
    { L"游乐", L"遊樂" },
    { L"游了", L"遊了" },
    { L"游人", L"遊人" },
    { L"游仙", L"遊仙" },
    { L"游伴", L"遊伴" },
    { L"游侠", L"遊俠" },
    { L"游兴", L"遊興" },
    { L"游冶", L"遊冶" },
    { L"游刃有余", L"遊刃有餘" },
    { L"游动", L"遊動" },
    { L"游历", L"遊歷" },
    { L"游园", L"遊園" },
    { L"游子", L"遊子" },
    { L"游学", L"遊學" },
    { L"游客", L"遊客" },
    { L"游宦", L"遊宦" },
    { L"游山玩水", L"遊山玩水" },
    { L"游必有方", L"遊必有方" },
    { L"游憩", L"遊憩" },
    { L"游戏", L"遊戲" },
    { L"游手好闲", L"遊手好閒" },
    { L"游方", L"遊方" },
    { L"游星", L"遊星" },
    { L"游标卡尺", L"遊標卡尺" },
    { L"游民", L"遊民" },
    { L"游河", L"遊河" },
    { L"游猎", L"遊獵" },
    { L"游玩", L"遊玩" },
    { L"游目骋怀", L"遊目騁懷" },
    { L"游离", L"遊離" },
    { L"游程", L"遊程" },
    { L"游船", L"遊船" },
    { L"游艇", L"遊艇" },
    { L"游艺", L"遊藝" },
    { L"游荡", L"遊盪" },
    { L"游荡不归", L"遊蕩不歸" },
    { L"游行", L"遊行" },
    { L"游街", L"遊街" },
    { L"游览", L"遊覽" },
    { L"游记", L"遊記" },
    { L"游说", L"遊說" },
    { L"游资", L"遊資" },
    { L"游走", L"遊走" },
    { L"游踪", L"遊蹤" },
    { L"游逛", L"遊逛" },
    { L"游错", L"遊錯" },
    { L"游骑兵", L"遊騎兵" },
    { L"游魂", L"遊魂" },
    { L"湖里", L"湖裡" },
    { L"湘累", L"湘纍" },
    { L"湘绣", L"湘繡" },
    { L"湟潦生苹", L"湟潦生苹" },
    { L"湮郁", L"湮鬱" },
    { L"湾", L"灣" },
    { L"湿", L"濕" },
    { L"溃", L"潰" },
    { L"溅", L"濺" },
    { L"溆", L"漵" },
    { L"溟蒙", L"溟濛" },
    { L"溲面", L"溲麵" },
    { L"滃郁", L"滃鬱" },
    { L"滑借", L"滑藉" },
    { L"滗", L"潷" },
    { L"滚", L"滾" },
    { L"滞", L"滯" },
    { L"滠", L"灄" },
    { L"满", L"滿" },
    { L"满头洋发", L"滿頭洋髮" },
    { L"满拼自尽", L"滿拚自盡" },
    { L"滢", L"瀅" },
    { L"滤", L"濾" },
    { L"滥", L"濫" },
    { L"滦", L"灤" },
    { L"滨", L"濱" },
    { L"滩", L"灘" },
    { L"滩涂", L"灘涂" },
    { L"漂荡", L"漂蕩" },
    { L"漓水", L"灕水" },
    { L"漓江", L"灕江" },
    { L"漓湘", L"灕湘" },
    { L"漓然", L"灕然" },
    { L"漕挽", L"漕輓" },
    { L"漤", L"灠" },
    { L"漫游", L"漫遊" },
    { L"潆", L"瀠" },
    { L"潇", L"瀟" },
    { L"潇洒", L"瀟洒" },
    { L"潋", L"瀲" },
    { L"潍", L"濰" },
    { L"潜", L"潛" },
    { L"潜意识里", L"潛意識裡" },
    { L"潜水表", L"潛水錶" },
    { L"潜水钟", L"潛水鐘" },
    { L"潭里", L"潭裡" },
    { L"潮涌", L"潮湧" },
    { L"潴", L"瀦" },
    { L"澒蒙", L"澒濛" },
    { L"澜", L"瀾" },
    { L"澹台", L"澹臺" },
    { L"澹荡", L"澹蕩" },
    { L"激荡", L"激蕩" },
    { L"濑", L"瀨" },
    { L"濒", L"瀕" },
    { L"灌药", L"灌藥" },
    { L"灏", L"灝" },
    { L"火并", L"火併" },
    { L"火拼", L"火拚" },
    { L"火签", L"火籤" },
    { L"火箭布雷", L"火箭佈雷" },
    { L"火药", L"火藥" },
    { L"灭", L"滅" },
    { L"灯", L"燈" },
    { L"灰蒙", L"灰濛" },
    { L"灰蒙蒙", L"灰濛濛" },
    { L"灵", L"靈" },
    { L"灵药", L"靈藥" },
    { L"灾", L"災" },
    { L"灿", L"燦" },
    { L"炀", L"煬" },
    { L"炆面", L"炆麵" },
    { L"炉", L"爐" },
    { L"炒面", L"炒麵" },
    { L"炖", L"燉" },
    { L"炖药", L"燉藥" },
    { L"炜", L"煒" },
    { L"炝", L"熗" },
    { L"炮制", L"炮製" },
    { L"炸药", L"炸藥" },
    { L"炸酱面", L"炸醬麵" },
    { L"点", L"點" },
    { L"点半钟", L"點半鐘" },
    { L"点多钟", L"點多鐘" },
    { L"点里", L"點裡" },
    { L"点钟", L"點鐘" },
    { L"炼", L"煉" },
    { L"炼冶", L"鍊冶" },
    { L"炼制", L"煉製" },
    { L"炼句", L"鍊句" },
    { L"炼字", L"鍊字" },
    { L"炼师", L"鍊師" },
    { L"炼度", L"鍊度" },
    { L"炼形", L"鍊形" },
    { L"炼气", L"鍊氣" },
    { L"炼汞", L"鍊汞" },
    { L"炼石", L"鍊石" },
    { L"炼药", L"煉藥" },
    { L"炼贫", L"鍊貧" },
    { L"炼金术", L"鍊金術" },
    { L"炼钢", L"鍊鋼" },
    { L"炽", L"熾" },
    { L"烁", L"爍" },
    { L"烂", L"爛" },
    { L"烃", L"烴" },
    { L"烘制", L"烘製" },
    { L"烘干", L"烘乾" },
    { L"烛", L"燭" },
    { L"烟", L"煙" },
    { L"烟卷", L"煙捲" },
    { L"烤干", L"烤乾" },
    { L"烤晒", L"烤晒" },
    { L"烦", L"煩" },
    { L"烧", L"燒" },
    { L"烧干", L"燒乾" },
    { L"烨", L"燁" },
    { L"烩", L"燴" },
    { L"烫", L"燙" },
    { L"烫一个发", L"燙一個髮" },
    { L"烫一次发", L"燙一次髮" },
    { L"烫个发", L"燙個髮" },
    { L"烫发", L"燙髮" },
    { L"烫完发", L"燙完髮" },
    { L"烫次发", L"燙次髮" },
    { L"烫面", L"燙麵" },
    { L"烬", L"燼" },
    { L"烬余", L"燼餘" },
    { L"热", L"熱" },
    { L"焕", L"煥" },
    { L"焖", L"燜" },
    { L"焘", L"燾" },
    { L"焙干", L"焙乾" },
    { L"無言不仇", L"無言不讎" },
    { L"煎药", L"煎藥" },
    { L"煎面", L"煎麵" },
    { L"照入签", L"照入籤" },
    { L"照准", L"照準" },
    { L"照占", L"照佔" },
    { L"煨干", L"煨乾" },
    { L"煮面", L"煮麵" },
    { L"熬药", L"熬藥" },
    { L"燎发", L"燎髮" },
    { L"燕几", L"燕几" },
    { L"燕游", L"燕遊" },
    { L"爰定祥历", L"爰定祥厤" },
    { L"爱", L"愛" },
    { L"爱困", L"愛睏" },
    { L"爷", L"爺" },
    { L"爽荡", L"爽蕩" },
    { L"片言只语", L"片言隻語" },
    { L"牍", L"牘" },
    { L"牙签", L"牙籤" },
    { L"牛只", L"牛隻" },
    { L"牛肉面", L"牛肉麵" },
    { L"牦", L"氂" },
    { L"物欲", L"物慾" },
    { L"牵", L"牽" },
    { L"牵一发", L"牽一髮" },
    { L"牵挂", L"牽挂" },
    { L"牵系", L"牽繫" },
    { L"特别致", L"特别致" },
    { L"特制", L"特製" },
    { L"特征", L"特徵" },
    { L"特效药", L"特效藥" },
    { L"牺", L"犧" },
    { L"犊", L"犢" },
    { L"状", L"狀" },
    { L"犷", L"獷" },
    { L"犹", L"猶" },
    { L"犹如表", L"猶如錶" },
    { L"犹如钟", L"猶如鐘" },
    { L"狂占", L"狂佔" },
    { L"狂并潮", L"狂併潮" },
    { L"狈", L"狽" },
    { L"狐借虎威", L"狐藉虎威" },
    { L"狞", L"獰" },
    { L"独", L"獨" },
    { L"独占", L"獨佔" },
    { L"独辟蹊径", L"獨闢蹊徑" },
    { L"狭", L"狹" },
    { L"狮", L"獅" },
    { L"狯", L"獪" },
    { L"狰", L"猙" },
    { L"狱", L"獄" },
    { L"狱里", L"獄裡" },
    { L"狲", L"猻" },
    { L"猃", L"獫" },
    { L"猎", L"獵" },
    { L"猕", L"獼" },
    { L"猛冲", L"猛衝" },
    { L"猡", L"玀" },
    { L"猪", L"豬" },
    { L"猫", L"貓" },
    { L"猬", L"蝟" },
    { L"献", L"獻" },
    { L"献丑", L"獻醜" },
    { L"獭", L"獺" },
    { L"玉历", L"玉曆" },
    { L"王余鱼", L"王餘魚" },
    { L"王侯后", L"王侯后" },
    { L"王后", L"王后" },
    { L"王庄", L"王莊" },
    { L"玑", L"璣" },
    { L"玛", L"瑪" },
    { L"玮", L"瑋" },
    { L"环", L"環" },
    { L"环游", L"環遊" },
    { L"现", L"現" },
    { L"玺", L"璽" },
    { L"珍肴异馔", L"珍肴異饌" },
    { L"珐", L"琺" },
    { L"珑", L"瓏" },
    { L"班里", L"班裡" },
    { L"珲", L"琿" },
    { L"球杆", L"球杆" },
    { L"理一个发", L"理一個髮" },
    { L"理一次发", L"理一次髮" },
    { L"理个发", L"理個髮" },
    { L"理发", L"理髮" },
    { L"理完发", L"理完髮" },
    { L"理次发", L"理次髮" },
    { L"琏", L"璉" },
    { L"琐", L"瑣" },
    { L"琴钟", L"琴鐘" },
    { L"琼", L"瓊" },
    { L"瑞征", L"瑞徵" },
    { L"瑶", L"瑤" },
    { L"瑶签", L"瑤籤" },
    { L"瑷", L"璦" },
    { L"璎", L"瓔" },
    { L"瓒", L"瓚" },
    { L"瓮安", L"甕安" },
    { L"瓯", L"甌" },
    { L"甚么", L"甚麼" },
    { L"甜水面", L"甜水麵" },
    { L"甜面酱", L"甜麵醬" },
    { L"生力面", L"生力麵" },
    { L"生发", L"生髮" },
    { L"生姜", L"生薑" },
    { L"生物钟", L"生物鐘" },
    { L"生锈", L"生鏽" },
    { L"用药", L"用藥" },
    { L"甩发", L"甩髮" },
    { L"田庄", L"田莊" },
    { L"田谷", L"田穀" },
    { L"田里", L"田裡" },
    { L"由表及里", L"由表及裡" },
    { L"电", L"電" },
    { L"电冲", L"電衝" },
    { L"电子表", L"電子錶" },
    { L"电子钟", L"電子鐘" },
    { L"电杆", L"電杆" },
    { L"电线杆", L"電線杆" },
    { L"电表", L"電錶" },
    { L"电钟", L"電鐘" },
    { L"男仆", L"男僕" },
    { L"男用表", L"男用錶" },
    { L"画", L"畫" },
    { L"画着", L"畫著" },
    { L"畅", L"暢" },
    { L"畅游", L"暢遊" },
    { L"留发", L"留髮" },
    { L"畴", L"疇" },
    { L"疏松", L"疏鬆" },
    { L"疑凶", L"疑兇" },
    { L"疑系", L"疑係" },
    { L"疖", L"癤" },
    { L"疗", L"療" },
    { L"疟", L"瘧" },
    { L"疠", L"癘" },
    { L"疡", L"瘍" },
    { L"疬", L"癧" },
    { L"疮", L"瘡" },
    { L"疯", L"瘋" },
    { L"疱", L"皰" },
    { L"疲困", L"疲睏" },
    { L"疴", L"痾" },
    { L"病余", L"病餘" },
    { L"病征", L"病徵" },
    { L"病愈", L"病癒" },
    { L"症候", L"癥候" },
    { L"症状", L"癥狀" },
    { L"症结", L"癥結" },
    { L"痈", L"癰" },
    { L"痉", L"痙" },
    { L"痊愈", L"痊癒" },
    { L"痒", L"癢" },
    { L"痒疹", L"痒疹" },
    { L"痒痒", L"痒痒" },
    { L"痕迹", L"痕迹" },
    { L"痨", L"癆" },
    { L"痪", L"瘓" },
    { L"痫", L"癇" },
    { L"瘅", L"癉" },
    { L"瘗", L"瘞" },
    { L"瘘", L"瘺" },
    { L"瘪", L"癟" },
    { L"瘫", L"癱" },
    { L"瘾", L"癮" },
    { L"瘿", L"癭" },
    { L"癞", L"癩" },
    { L"癣", L"癬" },
    { L"癫", L"癲" },
    { L"白兔擣药", L"白兔擣藥" },
    { L"白净面皮", L"白淨面皮" },
    { L"白发", L"白髮" },
    { L"白干", L"白乾" },
    { L"白术", L"白朮" },
    { L"白朴", L"白樸" },
    { L"白粉面", L"白粉麵" },
    { L"白胡", L"白鬍" },
    { L"白里透红", L"白裡透紅" },
    { L"白霉", L"白黴" },
    { L"百余", L"百餘" },
    { L"百只", L"百隻" },
    { L"百扎", L"百紮" },
    { L"百拙千丑", L"百拙千醜" },
    { L"百炼", L"百鍊" },
    { L"百科里", L"百科裡" },
    { L"百花历", L"百花曆" },
    { L"百药之长", L"百藥之長" },
    { L"百谷", L"百穀" },
    { L"的克制", L"的剋制" },
    { L"的钟", L"的鐘" },
    { L"的钟表", L"的鐘錶" },
    { L"皆准", L"皆準" },
    { L"皆可作淀", L"皆可作澱" },
    { L"皇历", L"皇曆" },
    { L"皇后", L"皇后" },
    { L"皇庄", L"皇莊" },
    { L"皇极历", L"皇極曆" },
    { L"皑", L"皚" },
    { L"皓发", L"皓髮" },
    { L"皮制", L"皮製" },
    { L"皮松", L"皮鬆" },
    { L"皮里春秋", L"皮裡春秋" },
    { L"皮里阳秋", L"皮裡陽秋" },
    { L"皱", L"皺" },
    { L"皱别", L"皺彆" },
    { L"皱折", L"皺摺" },
    { L"皲", L"皸" },
    { L"盆吊", L"盆弔" },
    { L"盈余", L"盈餘" },
    { L"盏", L"盞" },
    { L"盐", L"鹽" },
    { L"盐余", L"鹽餘" },
    { L"盐卤", L"鹽滷" },
    { L"盐打怎么咸", L"鹽打怎麼鹹" },
    { L"监", L"監" },
    { L"监制", L"監製" },
    { L"盒里", L"盒裡" },
    { L"盖", L"蓋" },
    { L"盗", L"盜" },
    { L"盗采", L"盜採" },
    { L"盗钟", L"盜鐘" },
    { L"盘", L"盤" },
    { L"盘回", L"盤迴" },
    { L"盘里", L"盤裡" },
    { L"盛赞", L"盛讚" },
    { L"盲干", L"盲幹" },
    { L"直冲", L"直衝" },
    { L"直接参与", L"直接參与" },
    { L"相克", L"相剋" },
    { L"相冲", L"相衝" },
    { L"相并", L"相併" },
    { L"相斗", L"相鬥" },
    { L"看下表", L"看下錶" },
    { L"看下钟", L"看下鐘" },
    { L"看准", L"看準" },
    { L"看着表", L"看著錶" },
    { L"看着钟", L"看著鐘" },
    { L"看着钟表", L"看著鐘錶" },
    { L"看表", L"看錶" },
    { L"看钟", L"看鐘" },
    { L"真个", L"真箇" },
    { L"真凶", L"真兇" },
    { L"眦", L"眥" },
    { L"眼帘", L"眼帘" },
    { L"眼干", L"眼乾" },
    { L"眼眶里", L"眼眶裡" },
    { L"眼睛里", L"眼睛裡" },
    { L"眼药", L"眼藥" },
    { L"眼里", L"眼裡" },
    { L"着书立说", L"著書立說" },
    { L"着儿", L"著兒" },
    { L"着克制", L"著剋制" },
    { L"着录", L"著錄" },
    { L"着色软体", L"著色軟體" },
    { L"着重指出", L"著重指出" },
    { L"睁", L"睜" },
    { L"睐", L"睞" },
    { L"睑", L"瞼" },
    { L"睡游病", L"睡遊病" },
    { L"睡着了", L"睡著了" },
    { L"瞄准", L"瞄準" },
    { L"瞅下表", L"瞅下錶" },
    { L"瞅下钟", L"瞅下鐘" },
    { L"瞒", L"瞞" },
    { L"瞧着表", L"瞧著錶" },
    { L"瞧着钟", L"瞧著鐘" },
    { L"瞧着钟表", L"瞧著鐘錶" },
    { L"瞩", L"矚" },
    { L"瞩托", L"矚託" },
    { L"瞳蒙", L"瞳矇" },
    { L"矜庄", L"矜莊" },
    { L"矫", L"矯" },
    { L"短几", L"短几" },
    { L"短发", L"短髮" },
    { L"矮几", L"矮几" },
    { L"石几", L"石几" },
    { L"石梁", L"石樑" },
    { L"石英表", L"石英錶" },
    { L"石英钟", L"石英鐘" },
    { L"石莼", L"石蓴" },
    { L"石钟乳", L"石鐘乳" },
    { L"矶", L"磯" },
    { L"矾", L"礬" },
    { L"矿", L"礦" },
    { L"砀", L"碭" },
    { L"码", L"碼" },
    { L"码表", L"碼錶" },
    { L"研制", L"研製" },
    { L"砖", L"磚" },
    { L"砗", L"硨" },
    { L"砚", L"硯" },
    { L"砰当", L"砰噹" },
    { L"砺", L"礪" },
    { L"砻", L"礱" },
    { L"砻谷机", L"礱穀機" },
    { L"砾", L"礫" },
    { L"础", L"礎" },
    { L"硕", L"碩" },
    { L"硖", L"硤" },
    { L"硗", L"磽" },
    { L"硗确", L"磽确" },
    { L"硬干", L"硬幹" },
    { L"确", L"確" },
    { L"确瘠", L"确瘠" },
    { L"碍", L"礙" },
    { L"碑志", L"碑誌" },
    { L"碛", L"磧" },
    { L"碜", L"磣" },
    { L"碰钟", L"碰鐘" },
    { L"碱", L"鹼" },
    { L"磁制", L"磁製" },
    { L"磨制", L"磨製" },
    { L"磨炼", L"磨鍊" },
    { L"磬钟", L"磬鐘" },
    { L"示范", L"示範" },
    { L"礼", L"禮" },
    { L"礼赞", L"禮讚" },
    { L"社里", L"社裡" },
    { L"祝发", L"祝髮" },
    { L"祝赞", L"祝讚" },
    { L"神游", L"神遊" },
    { L"神雕", L"神鵰" },
    { L"祢", L"禰" },
    { L"票庄", L"票莊" },
    { L"祭吊", L"祭弔" },
    { L"祯", L"禎" },
    { L"祷", L"禱" },
    { L"祸", L"禍" },
    { L"禀", L"稟" },
    { L"禁欲", L"禁慾" },
    { L"禁药", L"禁藥" },
    { L"禄", L"祿" },
    { L"禅", L"禪" },
    { L"离", L"離" },
    { L"禾谷", L"禾穀" },
    { L"秀发", L"秀髮" },
    { L"私下里", L"私下裡" },
    { L"私斗", L"私鬥" },
    { L"私欲", L"私慾" },
    { L"秃", L"禿" },
    { L"秃发", L"禿髮" },
    { L"秃妃之发", L"禿妃之髮" },
    { L"秆", L"稈" },
    { L"秋假里", L"秋假裡" },
    { L"秋千", L"鞦韆" },
    { L"秋发", L"秋髮" },
    { L"秋天里", L"秋天裡" },
    { L"秋日里", L"秋日裡" },
    { L"秋游", L"秋遊" },
    { L"秋阴入井干", L"秋陰入井幹" },
    { L"种", L"種" },
    { L"种师中", L"种師中" },
    { L"种师道", L"种師道" },
    { L"种放", L"种放" },
    { L"种谷", L"種穀" },
    { L"科范", L"科範" },
    { L"秒表", L"秒錶" },
    { L"秒钟", L"秒鐘" },
    { L"积", L"積" },
    { L"积极参与", L"積极參与" },
    { L"积极参加", L"積极參加" },
    { L"积淀", L"積澱" },
    { L"积谷", L"積穀" },
    { L"积谷防饥", L"積穀防饑" },
    { L"积郁", L"積鬱" },
    { L"称", L"稱" },
    { L"称赞", L"稱讚" },
    { L"秽", L"穢" },
    { L"稀松", L"稀鬆" },
    { L"稆", L"穭" },
    { L"税", L"稅" },
    { L"稣", L"穌" },
    { L"稳", L"穩" },
    { L"稳占", L"穩佔" },
    { L"稳扎", L"穩紮" },
    { L"稻谷", L"稻穀" },
    { L"稽征", L"稽徵" },
    { L"穆罕默德历", L"穆罕默德曆" },
    { L"穑", L"穡" },
    { L"穗帏飘井干", L"繐幃飄井幹" },
    { L"穷", L"窮" },
    { L"穷发", L"窮髮" },
    { L"穷追不舍", L"窮追不捨" },
    { L"空中布雷", L"空中佈雷" },
    { L"空余", L"空餘" },
    { L"空投布雷", L"空投佈雷" },
    { L"空荡", L"空蕩" },
    { L"空荡荡", L"空蕩蕩" },
    { L"空蒙", L"空濛" },
    { L"空钟", L"空鐘" },
    { L"窃", L"竊" },
    { L"窃钟掩耳", L"竊鐘掩耳" },
    { L"窍", L"竅" },
    { L"窑", L"窯" },
    { L"窒欲", L"窒慾" },
    { L"窗台", L"窗檯" },
    { L"窗帘", L"窗帘" },
    { L"窗明几亮", L"窗明几亮" },
    { L"窗明几净", L"窗明几淨" },
    { L"窜", L"竄" },
    { L"窝", L"窩" },
    { L"窝里", L"窩裡" },
    { L"窥", L"窺" },
    { L"窦", L"竇" },
    { L"窭", L"窶" },
    { L"立范", L"立範" },
    { L"竖", L"豎" },
    { L"竖着", L"豎著" },
    { L"站干岸儿", L"站乾岸兒" },
    { L"竞", L"競" },
    { L"竞斗", L"競鬥" },
    { L"童仆", L"童僕" },
    { L"端庄", L"端莊" },
    { L"竹几", L"竹几" },
    { L"竹林之游", L"竹林之遊" },
    { L"竹签", L"竹籤" },
    { L"笃", L"篤" },
    { L"笋", L"筍" },
    { L"笋干", L"筍乾" },
    { L"笑里藏刀", L"笑裡藏刀" },
    { L"笔", L"筆" },
    { L"笔划", L"筆劃" },
    { L"笔秃墨干", L"筆禿墨乾" },
    { L"笕", L"筧" },
    { L"笺", L"箋" },
    { L"笼", L"籠" },
    { L"笾", L"籩" },
    { L"筑", L"築" },
    { L"筑前", L"筑前" },
    { L"筑北", L"筑北" },
    { L"筑后", L"筑後" },
    { L"筑州", L"筑州" },
    { L"筑後", L"筑後" },
    { L"筑波", L"筑波" },
    { L"筑紫", L"筑紫" },
    { L"筑肥", L"筑肥" },
    { L"筑西", L"筑西" },
    { L"筑邦", L"筑邦" },
    { L"筑阳", L"筑陽" },
    { L"筑陽", L"筑陽" },
    { L"答复", L"答覆" },
    { L"策划", L"策劃" },
    { L"筚", L"篳" },
    { L"筛", L"篩" },
    { L"筝", L"箏" },
    { L"筵几", L"筵几" },
    { L"筹", L"籌" },
    { L"筹划", L"籌劃" },
    { L"签", L"簽" },
    { L"签押", L"籤押" },
    { L"签条", L"籤條" },
    { L"签着", L"簽著" },
    { L"签诗", L"籤詩" },
    { L"简", L"簡" },
    { L"简并", L"簡併" },
    { L"简朴", L"簡樸" },
    { L"算准", L"算準" },
    { L"算历", L"算曆" },
    { L"算发", L"算髮" },
    { L"管干", L"管幹" },
    { L"箦", L"簀" },
    { L"箧", L"篋" },
    { L"箨", L"籜" },
    { L"箩", L"籮" },
    { L"箪", L"簞" },
    { L"箫", L"簫" },
    { L"篑", L"簣" },
    { L"篓", L"簍" },
    { L"篮", L"籃" },
    { L"篱", L"籬" },
    { L"簖", L"籪" },
    { L"簸荡", L"簸蕩" },
    { L"籁", L"籟" },
    { L"米谷", L"米穀" },
    { L"籴", L"糴" },
    { L"类", L"類" },
    { L"籼", L"秈" },
    { L"粉拳绣腿", L"粉拳繡腿" },
    { L"粉签子", L"粉籤子" },
    { L"粗制", L"粗製" },
    { L"粜", L"糶" },
    { L"粝", L"糲" },
    { L"粤", L"粵" },
    { L"粪", L"糞" },
    { L"粪秽蔑面", L"糞穢衊面" },
    { L"粮", L"糧" },
    { L"精准", L"精準" },
    { L"精制", L"精製" },
    { L"精干", L"精幹" },
    { L"精松", L"精鬆" },
    { L"精炼", L"精鍊" },
    { L"精致", L"精緻" },
    { L"精辟", L"精闢" },
    { L"糁", L"糝" },
    { L"糇", L"餱" },
    { L"糊里糊涂", L"糊裡糊塗" },
    { L"糕干", L"糕乾" },
    { L"系上", L"繫上" },
    { L"系世", L"繫世" },
    { L"系为", L"係為" },
    { L"系于", L"繫於" },
    { L"系于一发", L"繫於一髮" },
    { L"系列里", L"系列裡" },
    { L"系到", L"繫到" },
    { L"系囚", L"繫囚" },
    { L"系心", L"繫心" },
    { L"系念", L"繫念" },
    { L"系怀", L"繫懷" },
    { L"系恋", L"繫戀" },
    { L"系数", L"係數" },
    { L"系着", L"系著" },
    { L"系紧", L"繫緊" },
    { L"系累", L"繫纍" },
    { L"系结", L"繫結" },
    { L"系绳", L"繫繩" },
    { L"系辞", L"繫辭" },
    { L"系里", L"系裡" },
    { L"系风捕影", L"繫風捕影" },
    { L"素发", L"素髮" },
    { L"素朴", L"素樸" },
    { L"素面", L"素麵" },
    { L"索面", L"索麵" },
    { L"紧", L"緊" },
    { L"紧绷", L"緊繃" },
    { L"紧绷着", L"緊繃著" },
    { L"紧绷绷", L"緊繃繃" },
    { L"紧致", L"緊緻" },
    { L"紧追不舍", L"緊追不捨" },
    { L"紫姜", L"紫薑" },
    { L"累囚", L"纍囚" },
    { L"累堆", L"纍堆" },
    { L"累瓦结绳", L"纍瓦結繩" },
    { L"累绁", L"纍紲" },
    { L"累臣", L"纍臣" },
    { L"絷", L"縶" },
    { L"綑扎", L"綑紮" },
    { L"經有云", L"經有云" },
    { L"緝凶", L"緝兇" },
    { L"繁复", L"繁複" },
    { L"繁钟", L"繁鐘" },
    { L"纠", L"糾" },
    { L"纡", L"紆" },
    { L"纡余", L"紆餘" },
    { L"纡回", L"紆迴" },
    { L"纡郁", L"紆鬱" },
    { L"红", L"紅" },
    { L"红发", L"紅髮" },
    { L"红绳系足", L"紅繩繫足" },
    { L"红钟", L"紅鐘" },
    { L"纣", L"紂" },
    { L"纤", L"纖" },
    { L"纤夫", L"縴夫" },
    { L"纤手", L"縴手" },
    { L"纥", L"紇" },
    { L"约", L"約" },
    { L"约占", L"約佔" },
    { L"级", L"級" },
    { L"纨", L"紈" },
    { L"纩", L"纊" },
    { L"纪", L"紀" },
    { L"纪历", L"紀曆" },
    { L"纫", L"紉" },
    { L"纬", L"緯" },
    { L"纭", L"紜" },
    { L"纯", L"純" },
    { L"纯朴", L"純樸" },
    { L"纰", L"紕" },
    { L"纱", L"紗" },
    { L"纲", L"綱" },
    { L"纳", L"納" },
    { L"纳征", L"納徵" },
    { L"纵", L"縱" },
    { L"纵欲", L"縱慾" },
    { L"纶", L"綸" },
    { L"纷", L"紛" },
    { L"纸", L"紙" },
    { L"纸扎", L"紙紮" },
    { L"纹", L"紋" },
    { L"纺", L"紡" },
    { L"纽", L"紐" },
    { L"纾", L"紓" },
    { L"线", L"線" },
    { L"绀", L"紺" },
    { L"绁", L"紲" },
    { L"绂", L"紱" },
    { L"练", L"練" },
    { L"组", L"組" },
    { L"组里", L"組裡" },
    { L"绅", L"紳" },
    { L"细", L"細" },
    { L"细不容发", L"細不容髮" },
    { L"细如发", L"細如髮" },
    { L"细炼", L"細鍊" },
    { L"细致", L"細緻" },
    { L"织", L"織" },
    { L"终", L"終" },
    { L"绉", L"縐" },
    { L"绊", L"絆" },
    { L"绋", L"紼" },
    { L"绌", L"絀" },
    { L"绍", L"紹" },
    { L"绎", L"繹" },
    { L"经", L"經" },
    { L"经有云", L"經有云" },
    { L"绐", L"紿" },
    { L"绑", L"綁" },
    { L"绑扎", L"綁紮" },
    { L"绒", L"絨" },
    { L"结", L"結" },
    { L"结伙", L"結夥" },
    { L"结伴同游", L"結伴同遊" },
    { L"结余", L"結餘" },
    { L"结发", L"結髮" },
    { L"结彩", L"結綵" },
    { L"结扎", L"結紮" },
    { L"绕", L"繞" },
    { L"绕梁", L"繞樑" },
    { L"绗", L"絎" },
    { L"绘", L"繪" },
    { L"绘制", L"繪製" },
    { L"给", L"給" },
    { L"绚", L"絢" },
    { L"绛", L"絳" },
    { L"络", L"絡" },
    { L"络腮胡", L"絡腮鬍" },
    { L"绝", L"絕" },
    { L"绞", L"絞" },
    { L"绞干", L"絞乾" },
    { L"统", L"統" },
    { L"绠", L"綆" },
    { L"绡", L"綃" },
    { L"绢", L"絹" },
    { L"绣", L"綉" },
    { L"绣像", L"繡像" },
    { L"绣口", L"繡口" },
    { L"绣得", L"繡得" },
    { L"绣户", L"繡戶" },
    { L"绣房", L"繡房" },
    { L"绣毯", L"繡毯" },
    { L"绣球", L"繡球" },
    { L"绣的", L"繡的" },
    { L"绣花", L"繡花" },
    { L"绣衣", L"繡衣" },
    { L"绣起", L"繡起" },
    { L"绣阁", L"繡閣" },
    { L"绣鞋", L"繡鞋" },
    { L"绥", L"綏" },
    { L"绦", L"絛" },
    { L"继", L"繼" },
    { L"绨", L"綈" },
    { L"绩", L"績" },
    { L"绪", L"緒" },
    { L"绪余", L"緒餘" },
    { L"绫", L"綾" },
    { L"续", L"續" },
    { L"绮", L"綺" },
    { L"绯", L"緋" },
    { L"绰", L"綽" },
    { L"绲", L"緄" },
    { L"绳", L"繩" },
    { L"维", L"維" },
    { L"维系", L"維繫" },
    { L"绵", L"綿" },
    { L"绶", L"綬" },
    { L"绷住", L"繃住" },
    { L"绷子", L"繃子" },
    { L"绷带", L"繃帶" },
    { L"绷开", L"繃開" },
    { L"绷扒吊拷", L"繃扒弔拷" },
    { L"绷着", L"繃著" },
    { L"绷紧", L"繃緊" },
    { L"绷脸", L"繃臉" },
    { L"绸", L"綢" },
    { L"绸缎庄", L"綢緞莊" },
    { L"绺", L"綹" },
    { L"绻", L"綣" },
    { L"综", L"綜" },
    { L"绽", L"綻" },
    { L"绾", L"綰" },
    { L"绾发", L"綰髮" },
    { L"绿", L"綠" },
    { L"绿发", L"綠髮" },
    { L"缀", L"綴" },
    { L"缁", L"緇" },
    { L"缂", L"緙" },
    { L"缃", L"緗" },
    { L"缄", L"緘" },
    { L"缅", L"緬" },
    { L"缆", L"纜" },
    { L"缇", L"緹" },
    { L"缈", L"緲" },
    { L"缉", L"緝" },
    { L"缉凶", L"緝兇" },
    { L"缋", L"繢" },
    { L"缌", L"緦" },
    { L"缍", L"綞" },
    { L"缎", L"緞" },
    { L"缏", L"緶" },
    { L"缑", L"緱" },
    { L"缒", L"縋" },
    { L"缓", L"緩" },
    { L"缓冲", L"緩衝" },
    { L"缓征", L"緩徵" },
    { L"缔", L"締" },
    { L"缕", L"縷" },
    { L"编", L"編" },
    { L"编制", L"編製" },
    { L"编发", L"編髮" },
    { L"编采", L"編採" },
    { L"编钟", L"編鐘" },
    { L"缗", L"緡" },
    { L"缘", L"緣" },
    { L"缙", L"縉" },
    { L"缚", L"縛" },
    { L"缛", L"縟" },
    { L"缜", L"縝" },
    { L"缜致", L"縝緻" },
    { L"缝", L"縫" },
    { L"缝制", L"縫製" },
    { L"缝里", L"縫裡" },
    { L"缟", L"縞" },
    { L"缠", L"纏" },
    { L"缠斗", L"纏鬥" },
    { L"缡", L"縭" },
    { L"缢", L"縊" },
    { L"缣", L"縑" },
    { L"缤", L"繽" },
    { L"缥", L"縹" },
    { L"缦", L"縵" },
    { L"缧", L"縲" },
    { L"缨", L"纓" },
    { L"缩", L"縮" },
    { L"缩栗", L"縮慄" },
    { L"缪", L"繆" },
    { L"缫", L"繅" },
    { L"缬", L"纈" },
    { L"缭", L"繚" },
    { L"缮", L"繕" },
    { L"缯", L"繒" },
    { L"缰", L"韁" },
    { L"缱", L"繾" },
    { L"缲", L"繰" },
    { L"缳", L"繯" },
    { L"缴", L"繳" },
    { L"缵", L"纘" },
    { L"罂", L"罌" },
    { L"网", L"網" },
    { L"网志", L"網誌" },
    { L"网里", L"網裡" },
    { L"罗", L"羅" },
    { L"罚", L"罰" },
    { L"罢", L"罷" },
    { L"置言成范", L"置言成範" },
    { L"罴", L"羆" },
    { L"羁", L"羈" },
    { L"羁系", L"羈繫" },
    { L"美丑", L"美醜" },
    { L"美仑", L"美崙" },
    { L"美制", L"美製" },
    { L"美占", L"美佔" },
    { L"美发", L"美髮" },
    { L"羟", L"羥" },
    { L"羡", L"羨" },
    { L"羡余", L"羨餘" },
    { L"群丑", L"群醜" },
    { L"翕辟", L"翕闢" },
    { L"翘", L"翹" },
    { L"翱游", L"翱遊" },
    { L"翻松", L"翻鬆" },
    { L"翻涌", L"翻湧" },
    { L"老仆", L"老僕" },
    { L"老姜", L"老薑" },
    { L"老干", L"老乾" },
    { L"老干部", L"老幹部" },
    { L"老庄", L"老莊" },
    { L"老板", L"老闆" },
    { L"老爷钟", L"老爺鐘" },
    { L"老蒙", L"老懞" },
    { L"考征", L"考徵" },
    { L"而克制", L"而剋制" },
    { L"耍斗", L"耍鬥" },
    { L"耕佣", L"耕傭" },
    { L"耕获", L"耕穫" },
    { L"耧", L"耬" },
    { L"耳余", L"耳餘" },
    { L"耸", L"聳" },
    { L"耻", L"恥" },
    { L"聂", L"聶" },
    { L"聋", L"聾" },
    { L"职", L"職" },
    { L"聍", L"聹" },
    { L"联", L"聯" },
    { L"联系", L"聯繫" },
    { L"聘雇", L"聘僱" },
    { L"聩", L"聵" },
    { L"聪", L"聰" },
    { L"肃", L"肅" },
    { L"肉丝面", L"肉絲麵" },
    { L"肉干", L"肉乾" },
    { L"肉松", L"肉鬆" },
    { L"肉欲", L"肉慾" },
    { L"肉羹面", L"肉羹麵" },
    { L"肚里", L"肚裡" },
    { L"肝郁", L"肝鬱" },
    { L"肠", L"腸" },
    { L"股栗", L"股慄" },
    { L"肤", L"膚" },
    { L"肤发", L"膚髮" },
    { L"肥筑方言", L"肥筑方言" },
    { L"肮", L"骯" },
    { L"肮肮脏脏", L"骯骯髒髒" },
    { L"肮脏", L"骯髒" },
    { L"肴", L"餚" },
    { L"肴馔", L"肴饌" },
    { L"肾", L"腎" },
    { L"肿", L"腫" },
    { L"胀", L"脹" },
    { L"胁", L"脅" },
    { L"胃药", L"胃藥" },
    { L"胃里", L"胃裡" },
    { L"胆", L"膽" },
    { L"背地里", L"背地裡" },
    { L"胎发", L"胎髮" },
    { L"胜", L"勝" },
    { L"胜肽", L"胜肽" },
    { L"胜键", L"胜鍵" },
    { L"胡云", L"胡云" },
    { L"胡同", L"衚衕" },
    { L"胡子", L"鬍子" },
    { L"胡朴安", L"胡樸安" },
    { L"胡梢", L"鬍梢" },
    { L"胡渣", L"鬍渣" },
    { L"胡里胡涂", L"胡裡胡塗" },
    { L"胡须", L"鬍鬚" },
    { L"胡髭", L"鬍髭" },
    { L"胡髯", L"鬍髯" },
    { L"胧", L"朧" },
    { L"胪", L"臚" },
    { L"胫", L"脛" },
    { L"胶", L"膠" },
    { L"胶卷", L"膠捲" },
    { L"能克制", L"能剋制" },
    { L"能干", L"能幹" },
    { L"脉", L"脈" },
    { L"脉冲", L"脈衝" },
    { L"脊梁", L"脊樑" },
    { L"脍", L"膾" },
    { L"脏", L"臟" },
    { L"脏东西", L"髒東西" },
    { L"脏乱", L"髒亂" },
    { L"脏了", L"髒了" },
    { L"脏兮兮", L"髒兮兮" },
    { L"脏发", L"髒髮" },
    { L"脏字", L"髒字" },
    { L"脏得", L"髒得" },
    { L"脏心", L"髒心" },
    { L"脏水", L"髒水" },
    { L"脏的", L"髒的" },
    { L"脏词", L"髒詞" },
    { L"脏话", L"髒話" },
    { L"脏钱", L"髒錢" },
    { L"脐", L"臍" },
    { L"脑", L"腦" },
    { L"脑子里", L"腦子裡" },
    { L"脑干", L"腦幹" },
    { L"脓", L"膿" },
    { L"脔", L"臠" },
    { L"脚", L"腳" },
    { L"脚注", L"腳註" },
    { L"脚炼", L"腳鍊" },
    { L"脱", L"脫" },
    { L"脱发", L"脫髮" },
    { L"脱谷机", L"脫穀機" },
    { L"脶", L"腡" },
    { L"脸", L"臉" },
    { L"腊", L"臘" },
    { L"腊之以为饵", L"腊之以為餌" },
    { L"腊味", L"腊味" },
    { L"腊毒", L"腊毒" },
    { L"腊笔", L"腊筆" },
    { L"腐余", L"腐餘" },
    { L"腐干", L"腐乾" },
    { L"腕表", L"腕錶" },
    { L"腭", L"齶" },
    { L"腰里", L"腰裡" },
    { L"腻", L"膩" },
    { L"腼", L"靦" },
    { L"腽", L"膃" },
    { L"腾", L"騰" },
    { L"腾冲", L"騰衝" },
    { L"膏药", L"膏藥" },
    { L"膑", L"臏" },
    { L"膨松", L"膨鬆" },
    { L"臣仆", L"臣僕" },
    { L"臧谷亡羊", L"臧穀亡羊" },
    { L"自制", L"自製" },
    { L"自觉自愿", L"自覺自愿" },
    { L"致密", L"緻密" },
    { L"舂谷", L"舂穀" },
    { L"舆", L"輿" },
    { L"舌干唇焦", L"舌乾唇焦" },
    { L"舍不得", L"捨不得" },
    { L"舍出", L"捨出" },
    { L"舍去", L"捨去" },
    { L"舍命", L"捨命" },
    { L"舍堕", L"捨墮" },
    { L"舍安就危", L"捨安就危" },
    { L"舍实", L"捨實" },
    { L"舍己为人", L"捨己為人" },
    { L"舍己为公", L"捨己為公" },
    { L"舍己为国", L"捨己為國" },
    { L"舍己从人", L"捨己從人" },
    { L"舍己救人", L"捨己救人" },
    { L"舍弃", L"捨棄" },
    { L"舍得", L"捨得" },
    { L"舍我其谁", L"捨我其誰" },
    { L"舍本逐末", L"捨本逐末" },
    { L"舍死忘生", L"捨死忘生" },
    { L"舍生", L"捨生" },
    { L"舍短取长", L"捨短取長" },
    { L"舍身", L"捨身" },
    { L"舍车保帅", L"捨車保帥" },
    { L"舍近求远", L"捨近求遠" },
    { L"舒卷", L"舒捲" },
    { L"舣", L"艤" },
    { L"航海历", L"航海曆" },
    { L"舰", L"艦" },
    { L"舰只", L"艦隻" },
    { L"舱", L"艙" },
    { L"船只", L"船隻" },
    { L"船钟", L"船鐘" },
    { L"舻", L"艫" },
    { L"良药", L"良藥" },
    { L"艰", L"艱" },
    { L"色欲", L"色慾" },
    { L"艳", L"艷" },
    { L"艳后", L"艷后" },
    { L"艷后", L"艷后" },
    { L"艸木丰丰", L"艸木丰丰" },
    { L"艺", L"藝" },
    { L"节", L"節" },
    { L"节余", L"節餘" },
    { L"节欲", L"節慾" },
    { L"芈", L"羋" },
    { L"芍药", L"芍藥" },
    { L"芗", L"薌" },
    { L"芜", L"蕪" },
    { L"芦", L"蘆" },
    { L"花卷", L"花捲" },
    { L"花哄", L"花鬨" },
    { L"花庵词选", L"花菴詞選" },
    { L"花拳绣腿", L"花拳繡腿" },
    { L"花盆里", L"花盆裡" },
    { L"花药", L"花藥" },
    { L"花钟", L"花鐘" },
    { L"花马吊嘴", L"花馬弔嘴" },
    { L"苁", L"蓯" },
    { L"苇", L"葦" },
    { L"苈", L"藶" },
    { L"苋", L"莧" },
    { L"苌", L"萇" },
    { L"苍", L"蒼" },
    { L"苍发", L"蒼髮" },
    { L"苍术", L"蒼朮" },
    { L"苍郁", L"蒼鬱" },
    { L"苎", L"苧" },
    { L"苏", L"蘇" },
    { L"苏昆", L"蘇崑" },
    { L"苑里", L"苑裡" },
    { L"苦干", L"苦幹" },
    { L"苦斗", L"苦鬥" },
    { L"苦药", L"苦藥" },
    { L"苦里", L"苦裡" },
    { L"苧", L"薴" },
    { L"英占", L"英佔" },
    { L"苹", L"蘋" },
    { L"苹萦", L"苹縈" },
    { L"茂都淀", L"茂都澱" },
    { L"范例", L"範例" },
    { L"范围", L"範圍" },
    { L"范字", L"範字" },
    { L"范式", L"範式" },
    { L"范性形变", L"範性形變" },
    { L"范文", L"範文" },
    { L"范本", L"範本" },
    { L"范畴", L"範疇" },
    { L"范金", L"範金" },
    { L"茎", L"莖" },
    { L"茎干", L"莖幹" },
    { L"茏", L"蘢" },
    { L"茑", L"蔦" },
    { L"茔", L"塋" },
    { L"茕", L"煢" },
    { L"茧", L"繭" },
    { L"茶余", L"茶餘" },
    { L"茶几", L"茶几" },
    { L"茶庄", L"茶莊" },
    { L"茶面", L"茶麵" },
    { L"荆", L"荊" },
    { L"草丛里", L"草叢裡" },
    { L"草广", L"草广" },
    { L"草荐", L"草荐" },
    { L"草药", L"草藥" },
    { L"荐", L"薦" },
    { L"荐居", L"荐居" },
    { L"荐臻", L"荐臻" },
    { L"荐饥", L"荐饑" },
    { L"荚", L"莢" },
    { L"荛", L"蕘" },
    { L"荜", L"蓽" },
    { L"荞", L"蕎" },
    { L"荞麦面", L"蕎麥麵" },
    { L"荟", L"薈" },
    { L"荠", L"薺" },
    { L"荡", L"盪" },
    { L"荡产", L"蕩產" },
    { L"荡女", L"蕩女" },
    { L"荡妇", L"蕩婦" },
    { L"荡寇", L"蕩寇" },
    { L"荡平", L"蕩平" },
    { L"荡来荡去", L"蕩來蕩去" },
    { L"荡气回肠", L"蕩氣迴腸" },
    { L"荡涤", L"蕩滌" },
    { L"荡漾", L"蕩漾" },
    { L"荡然", L"蕩然" },
    { L"荡舟", L"蕩舟" },
    { L"荡船", L"蕩船" },
    { L"荡荡", L"蕩蕩" },
    { L"荣", L"榮" },
    { L"荤", L"葷" },
    { L"荥", L"滎" },
    { L"荦", L"犖" },
    { L"荦确", L"犖确" },
    { L"荧", L"熒" },
    { L"荧郁", L"熒鬱" },
    { L"荨", L"蕁" },
    { L"荩", L"藎" },
    { L"荪", L"蓀" },
    { L"荫", L"蔭" },
    { L"荭", L"葒" },
    { L"药", L"葯" },
    { L"药专", L"藥專" },
    { L"药丸", L"藥丸" },
    { L"药典", L"藥典" },
    { L"药到命除", L"藥到命除" },
    { L"药到病除", L"藥到病除" },
    { L"药剂", L"藥劑" },
    { L"药力", L"藥力" },
    { L"药包", L"藥包" },
    { L"药医学系", L"藥醫學系" },
    { L"药单", L"藥單" },
    { L"药厂", L"藥廠" },
    { L"药名", L"藥名" },
    { L"药味", L"藥味" },
    { L"药品", L"藥品" },
    { L"药商", L"藥商" },
    { L"药头", L"藥頭" },
    { L"药婆", L"藥婆" },
    { L"药学", L"藥學" },
    { L"药害", L"藥害" },
    { L"药局", L"藥局" },
    { L"药师", L"藥師" },
    { L"药店", L"藥店" },
    { L"药引", L"藥引" },
    { L"药性", L"藥性" },
    { L"药房", L"藥房" },
    { L"药效", L"藥效" },
    { L"药方", L"藥方" },
    { L"药材", L"藥材" },
    { L"药检局", L"藥檢局" },
    { L"药棉", L"藥棉" },
    { L"药水", L"藥水" },
    { L"药油", L"藥油" },
    { L"药液", L"藥液" },
    { L"药渣", L"藥渣" },
    { L"药片", L"藥片" },
    { L"药物", L"藥物" },
    { L"药王", L"藥王" },
    { L"药理", L"藥理" },
    { L"药瓶", L"藥瓶" },
    { L"药用", L"藥用" },
    { L"药皂", L"藥皂" },
    { L"药盒", L"藥盒" },
    { L"药石", L"藥石" },
    { L"药科", L"藥科" },
    { L"药签", L"藥籤" },
    { L"药箱", L"藥箱" },
    { L"药粉", L"藥粉" },
    { L"药糖", L"藥糖" },
    { L"药线", L"藥線" },
    { L"药罐", L"藥罐" },
    { L"药膏", L"藥膏" },
    { L"药舖", L"藥舖" },
    { L"药茶", L"藥茶" },
    { L"药草", L"藥草" },
    { L"药行", L"藥行" },
    { L"药贩", L"藥販" },
    { L"药费", L"藥費" },
    { L"药酒", L"藥酒" },
    { L"药量", L"藥量" },
    { L"药针", L"藥針" },
    { L"药铺", L"藥鋪" },
    { L"药面儿", L"藥麵兒" },
    { L"药饵", L"藥餌" },
    { L"荷花淀", L"荷花澱" },
    { L"莅", L"蒞" },
    { L"莱", L"萊" },
    { L"莲", L"蓮" },
    { L"莳", L"蒔" },
    { L"莴", L"萵" },
    { L"莶", L"薟" },
    { L"获", L"獲" },
    { L"获匪其丑", L"獲匪其醜" },
    { L"莸", L"蕕" },
    { L"莹", L"瑩" },
    { L"莺", L"鶯" },
    { L"莽荡", L"莽蕩" },
    { L"菜干", L"菜乾" },
    { L"菜肴", L"菜肴" },
    { L"菠棱菜", L"菠稜菜" },
    { L"菠萝干", L"菠蘿乾" },
    { L"萝", L"蘿" },
    { L"萝卜", L"蘿蔔" },
    { L"萝卜干", L"蘿蔔乾" },
    { L"萤", L"螢" },
    { L"营", L"營" },
    { L"营干", L"營幹" },
    { L"萦", L"縈" },
    { L"萦回", L"縈迴" },
    { L"萧", L"蕭" },
    { L"萧参", L"蕭蔘" },
    { L"萨", L"薩" },
    { L"落发", L"落髮" },
    { L"落腮胡", L"落腮鬍" },
    { L"葡占", L"葡佔" },
    { L"葡萄干", L"葡萄乾" },
    { L"董氏封发", L"董氏封髮" },
    { L"葱", L"蔥" },
    { L"葱郁", L"蔥鬱" },
    { L"蒇", L"蕆" },
    { L"蒉", L"蕢" },
    { L"蒋", L"蔣" },
    { L"蒌", L"蔞" },
    { L"蒙事", L"矇事" },
    { L"蒙头转", L"矇頭轉" },
    { L"蒙庄", L"蒙莊" },
    { L"蒙懂", L"懞懂" },
    { L"蒙昧无知", L"矇昧無知" },
    { L"蒙松雨", L"濛鬆雨" },
    { L"蒙汗药", L"蒙汗藥" },
    { L"蒙汜", L"濛汜" },
    { L"蒙混", L"矇混" },
    { L"蒙直", L"懞直" },
    { L"蒙着", L"矇著" },
    { L"蒙瞍", L"矇瞍" },
    { L"蒙聩", L"矇聵" },
    { L"蒙胧", L"朦朧" },
    { L"蒙蒙懂懂", L"懞懞懂懂" },
    { L"蒙蒙细雨", L"濛濛細雨" },
    { L"蒙雾", L"濛霧" },
    { L"蒙骗", L"矇騙" },
    { L"蒙鸿", L"濛鴻" },
    { L"蒜发", L"蒜髮" },
    { L"蓄发", L"蓄髮" },
    { L"蓄胡", L"蓄鬍" },
    { L"蓄须", L"蓄鬚" },
    { L"蓊郁", L"蓊鬱" },
    { L"蓝", L"藍" },
    { L"蓝淀", L"藍澱" },
    { L"蓟", L"薊" },
    { L"蓠", L"蘺" },
    { L"蓣", L"蕷" },
    { L"蓥", L"鎣" },
    { L"蓦", L"驀" },
    { L"蓬发", L"蓬髮" },
    { L"蓬松", L"蓬鬆" },
    { L"蓬蓬松松", L"蓬蓬鬆鬆" },
    { L"蔂", L"虆" },
    { L"蔷", L"薔" },
    { L"蔹", L"蘞" },
    { L"蔺", L"藺" },
    { L"蔼", L"藹" },
    { L"蕲", L"蘄" },
    { L"蕴", L"蘊" },
    { L"蕴含着", L"蘊含著" },
    { L"蕴涵着", L"蘊涵著" },
    { L"薄干", L"薄幹" },
    { L"薄幸", L"薄倖" },
    { L"薙发", L"薙髮" },
    { L"薝卜", L"薝蔔" },
    { L"薮", L"藪" },
    { L"藏历", L"藏曆" },
    { L"藏蒙歌儿", L"藏矇歌兒" },
    { L"藓", L"蘚" },
    { L"藤制", L"藤製" },
    { L"蘖", L"櫱" },
    { L"虎斗", L"虎鬥" },
    { L"虎须", L"虎鬚" },
    { L"虏", L"虜" },
    { L"虑", L"慮" },
    { L"虚", L"虛" },
    { L"虫", L"蟲" },
    { L"虫部", L"虫部" },
    { L"虬", L"虯" },
    { L"虮", L"蟣" },
    { L"虮蝨相吊", L"蟣蝨相弔" },
    { L"虽", L"雖" },
    { L"虾", L"蝦" },
    { L"虿", L"蠆" },
    { L"蚀", L"蝕" },
    { L"蚁", L"蟻" },
    { L"蚁后", L"蟻后" },
    { L"蚂", L"螞" },
    { L"蚊动牛斗", L"蚊動牛鬥" },
    { L"蚕", L"蠶" },
    { L"蚬", L"蜆" },
    { L"蛇发女妖", L"蛇髮女妖" },
    { L"蛊", L"蠱" },
    { L"蛎", L"蠣" },
    { L"蛏", L"蟶" },
    { L"蛏干", L"蟶乾" },
    { L"蛔虫药", L"蛔蟲藥" },
    { L"蛮", L"蠻" },
    { L"蛮干", L"蠻幹" },
    { L"蛰", L"蟄" },
    { L"蛱", L"蛺" },
    { L"蛲", L"蟯" },
    { L"蛳", L"螄" },
    { L"蛴", L"蠐" },
    { L"蜂准", L"蜂準" },
    { L"蜂后", L"蜂后" },
    { L"蜂涌", L"蜂湧" },
    { L"蜕", L"蛻" },
    { L"蜗", L"蝸" },
    { L"蜜里调油", L"蜜裡調油" },
    { L"蜡", L"蠟" },
    { L"蜡月", L"蜡月" },
    { L"蜡祭", L"蜡祭" },
    { L"蝇", L"蠅" },
    { L"蝈", L"蟈" },
    { L"蝉", L"蟬" },
    { L"蝎", L"蠍" },
    { L"蝎蝎螫螫", L"蝎蝎螫螫" },
    { L"蝎谮", L"蝎譖" },
    { L"蝼", L"螻" },
    { L"蝾", L"蠑" },
    { L"蟻后", L"蟻后" },
    { L"蠁干", L"蠁幹" },
    { L"血余", L"血餘" },
    { L"血拼", L"血拚" },
    { L"衅", L"釁" },
    { L"衅钟", L"釁鐘" },
    { L"行事历", L"行事曆" },
    { L"行凶", L"行兇" },
    { L"衔", L"銜" },
    { L"衣绣昼行", L"衣繡晝行" },
    { L"补", L"補" },
    { L"补注", L"補註" },
    { L"补药", L"補藥" },
    { L"补血药", L"補血藥" },
    { L"表停", L"錶停" },
    { L"表冠", L"錶冠" },
    { L"表厂", L"錶廠" },
    { L"表壳", L"錶殼" },
    { L"表带", L"錶帶" },
    { L"表店", L"錶店" },
    { L"表征", L"表徵" },
    { L"表快", L"錶快" },
    { L"表慢", L"錶慢" },
    { L"表板", L"錶板" },
    { L"表王", L"錶王" },
    { L"表的历史", L"錶的歷史" },
    { L"表的嘀嗒", L"錶的嘀嗒" },
    { L"表盘", L"錶盤" },
    { L"表蒙子", L"錶蒙子" },
    { L"表行", L"錶行" },
    { L"表转", L"錶轉" },
    { L"表速", L"錶速" },
    { L"表里", L"表裡" },
    { L"表针", L"錶針" },
    { L"表链", L"錶鏈" },
    { L"衬", L"襯" },
    { L"衬里", L"襯裡" },
    { L"衮", L"袞" },
    { L"袄", L"襖" },
    { L"袅", L"裊" },
    { L"袋表", L"袋錶" },
    { L"袋里", L"袋裡" },
    { L"袖里", L"袖裡" },
    { L"袜", L"襪" },
    { L"被发佯狂", L"被髮佯狂" },
    { L"被发入山", L"被髮入山" },
    { L"被发左衽", L"被髮左衽" },
    { L"被发缨冠", L"被髮纓冠" },
    { L"被发阳狂", L"被髮陽狂" },
    { L"被复", L"被複" },
    { L"被里", L"被裡" },
    { L"袭", L"襲" },
    { L"裁制", L"裁製" },
    { L"裁并", L"裁併" },
    { L"装", L"裝" },
    { L"装折", L"裝摺" },
    { L"裆", L"襠" },
    { L"裢", L"褳" },
    { L"裣", L"襝" },
    { L"裤", L"褲" },
    { L"褒赞", L"褒讚" },
    { L"褛", L"褸" },
    { L"褴", L"襤" },
    { L"西占", L"西佔" },
    { L"西历", L"西曆" },
    { L"西周钟", L"西周鐘" },
    { L"西岳", L"西嶽" },
    { L"西晒", L"西晒" },
    { L"西游", L"西遊" },
    { L"西药", L"西藥" },
    { L"要么", L"要麼" },
    { L"要克制", L"要剋制" },
    { L"要冲", L"要衝" },
    { L"要占", L"要佔" },
    { L"覆盖着", L"覆蓋著" },
    { L"覆着", L"覆著" },
    { L"见", L"見" },
    { L"见棱见角", L"見稜見角" },
    { L"见素抱朴", L"見素抱樸" },
    { L"观", L"觀" },
    { L"观采", L"觀採" },
    { L"规", L"規" },
    { L"规划", L"規劃" },
    { L"规范", L"規範" },
    { L"觅", L"覓" },
    { L"视", L"視" },
    { L"觇", L"覘" },
    { L"览", L"覽" },
    { L"觉", L"覺" },
    { L"觊", L"覬" },
    { L"觋", L"覡" },
    { L"觌", L"覿" },
    { L"觎", L"覦" },
    { L"觏", L"覯" },
    { L"觐", L"覲" },
    { L"觑", L"覷" },
    { L"角落里", L"角落裡" },
    { L"觚棱", L"觚稜" },
    { L"觞", L"觴" },
    { L"解发佯狂", L"解髮佯狂" },
    { L"解痛药", L"解痛藥" },
    { L"解药", L"解藥" },
    { L"解雇", L"解僱" },
    { L"触", L"觸" },
    { L"触须", L"觸鬚" },
    { L"觯", L"觶" },
    { L"言云", L"言云" },
    { L"言大而夸", L"言大而夸" },
    { L"言辩而确", L"言辯而确" },
    { L"詩云", L"詩云" },
    { L"誉", L"譽" },
    { L"誊", L"謄" },
    { L"語有云", L"語有云" },
    { L"謷丑", L"謷醜" },
    { L"警世钟", L"警世鐘" },
    { L"警报钟", L"警報鐘" },
    { L"警示钟", L"警示鐘" },
    { L"警钟", L"警鐘" },
    { L"计", L"計" },
    { L"计划", L"計劃" },
    { L"计时表", L"計時錶" },
    { L"订", L"訂" },
    { L"订制", L"訂製" },
    { L"讣", L"訃" },
    { L"认", L"認" },
    { L"认准", L"認準" },
    { L"讥", L"譏" },
    { L"讦", L"訐" },
    { L"讧", L"訌" },
    { L"讨", L"討" },
    { L"让", L"讓" },
    { L"讪", L"訕" },
    { L"讫", L"訖" },
    { L"训", L"訓" },
    { L"议", L"議" },
    { L"讯", L"訊" },
    { L"记", L"記" },
    { L"讲", L"講" },
    { L"讳", L"諱" },
    { L"讴", L"謳" },
    { L"讵", L"詎" },
    { L"讶", L"訝" },
    { L"讷", L"訥" },
    { L"许", L"許" },
    { L"许愿起经", L"許愿起經" },
    { L"讹", L"訛" },
    { L"论", L"論" },
    { L"讼", L"訟" },
    { L"讽", L"諷" },
    { L"设", L"設" },
    { L"访", L"訪" },
    { L"诀", L"訣" },
    { L"证", L"證" },
    { L"诂", L"詁" },
    { L"诃", L"訶" },
    { L"评", L"評" },
    { L"评注", L"評註" },
    { L"诅", L"詛" },
    { L"识", L"識" },
    { L"诈", L"詐" },
    { L"诉", L"訴" },
    { L"诊", L"診" },
    { L"诋", L"詆" },
    { L"诌", L"謅" },
    { L"词", L"詞" },
    { L"词余", L"詞餘" },
    { L"词干", L"詞幹" },
    { L"词汇", L"詞彙" },
    { L"诎", L"詘" },
    { L"诏", L"詔" },
    { L"译", L"譯" },
    { L"译注", L"譯註" },
    { L"诒", L"詒" },
    { L"诓", L"誆" },
    { L"诔", L"誄" },
    { L"诔赞", L"誄讚" },
    { L"试", L"試" },
    { L"试制", L"試製" },
    { L"试药", L"試藥" },
    { L"诖", L"詿" },
    { L"诗", L"詩" },
    { L"诗云", L"詩云" },
    { L"诗余", L"詩餘" },
    { L"诗赞", L"詩讚" },
    { L"诗钟", L"詩鐘" },
    { L"诘", L"詰" },
    { L"诙", L"詼" },
    { L"诚", L"誠" },
    { L"诚征", L"誠徵" },
    { L"诚朴", L"誠樸" },
    { L"诛", L"誅" },
    { L"诜", L"詵" },
    { L"话", L"話" },
    { L"话里有话", L"話裡有話" },
    { L"诞", L"誕" },
    { L"诟", L"詬" },
    { L"诠", L"詮" },
    { L"诡", L"詭" },
    { L"询", L"詢" },
    { L"诣", L"詣" },
    { L"诤", L"諍" },
    { L"该", L"該" },
    { L"该钟", L"該鐘" },
    { L"详", L"詳" },
    { L"详征博引", L"詳徵博引" },
    { L"详注", L"詳註" },
    { L"诧", L"詫" },
    { L"诨", L"諢" },
    { L"诩", L"詡" },
    { L"诫", L"誡" },
    { L"诬", L"誣" },
    { L"诬蔑", L"誣衊" },
    { L"语", L"語" },
    { L"语云", L"語云" },
    { L"语有云", L"語有云" },
    { L"语汇", L"語彙" },
    { L"诮", L"誚" },
    { L"误", L"誤" },
    { L"诰", L"誥" },
    { L"诱", L"誘" },
    { L"诱奸", L"誘姦" },
    { L"诲", L"誨" },
    { L"诳", L"誑" },
    { L"说", L"說" },
    { L"说着", L"說著" },
    { L"诵", L"誦" },
    { L"诶", L"誒" },
    { L"请", L"請" },
    { L"请君入瓮", L"請君入甕" },
    { L"请托", L"請託" },
    { L"诸", L"諸" },
    { L"诸余", L"諸餘" },
    { L"诹", L"諏" },
    { L"诺", L"諾" },
    { L"读", L"讀" },
    { L"诼", L"諑" },
    { L"诽", L"誹" },
    { L"课", L"課" },
    { L"课余", L"課餘" },
    { L"课征", L"課徵" },
    { L"诿", L"諉" },
    { L"谀", L"諛" },
    { L"谁", L"誰" },
    { L"谁干的", L"誰幹的" },
    { L"谂", L"諗" },
    { L"调", L"調" },
    { L"调准", L"調準" },
    { L"调制", L"調製" },
    { L"调表", L"調錶" },
    { L"谄", L"諂" },
    { L"谅", L"諒" },
    { L"谆", L"諄" },
    { L"谇", L"誶" },
    { L"谈", L"談" },
    { L"谈征", L"談徵" },
    { L"谊", L"誼" },
    { L"谋", L"謀" },
    { L"谋干", L"謀幹" },
    { L"谌", L"諶" },
    { L"谍", L"諜" },
    { L"谎", L"謊" },
    { L"谏", L"諫" },
    { L"谐", L"諧" },
    { L"谑", L"謔" },
    { L"谒", L"謁" },
    { L"谓", L"謂" },
    { L"谔", L"諤" },
    { L"谕", L"諭" },
    { L"谖", L"諼" },
    { L"谗", L"讒" },
    { L"谘", L"諮" },
    { L"谙", L"諳" },
    { L"谚", L"諺" },
    { L"谛", L"諦" },
    { L"谜", L"謎" },
    { L"谝", L"諞" },
    { L"谟", L"謨" },
    { L"谠", L"讜" },
    { L"谡", L"謖" },
    { L"谢", L"謝" },
    { L"谣", L"謠" },
    { L"谤", L"謗" },
    { L"谥", L"謚" },
    { L"谦", L"謙" },
    { L"谧", L"謐" },
    { L"谨", L"謹" },
    { L"谩", L"謾" },
    { L"谪", L"謫" },
    { L"谫", L"譾" },
    { L"谬", L"謬" },
    { L"谬赞", L"謬讚" },
    { L"谬采虚声", L"謬採虛聲" },
    { L"谭", L"譚" },
    { L"谮", L"譖" },
    { L"谯", L"譙" },
    { L"谰", L"讕" },
    { L"谱", L"譜" },
    { L"谲", L"譎" },
    { L"谳", L"讞" },
    { L"谴", L"譴" },
    { L"谵", L"譫" },
    { L"谶", L"讖" },
    { L"谷人", L"穀人" },
    { L"谷仓", L"穀倉" },
    { L"谷保家商", L"穀保家商" },
    { L"谷圭", L"穀圭" },
    { L"谷场", L"穀場" },
    { L"谷壳", L"穀殼" },
    { L"谷子", L"穀子" },
    { L"谷日", L"穀日" },
    { L"谷旦", L"穀旦" },
    { L"谷梁", L"穀梁" },
    { L"谷物", L"穀物" },
    { L"谷皮", L"穀皮" },
    { L"谷神", L"穀神" },
    { L"谷米", L"穀米" },
    { L"谷类", L"穀類" },
    { L"谷粒", L"穀粒" },
    { L"谷舱", L"穀艙" },
    { L"谷苗", L"穀苗" },
    { L"谷草", L"穀草" },
    { L"谷谷", L"穀穀" },
    { L"谷贱伤农", L"穀賤傷農" },
    { L"谷贵饿农", L"穀貴餓農" },
    { L"谷道", L"穀道" },
    { L"谷雨", L"穀雨" },
    { L"谷食", L"穀食" },
    { L"豆干", L"豆乾" },
    { L"象征", L"象徵" },
    { L"象征着", L"象徵著" },
    { L"買凶", L"買兇" },
    { L"賈后", L"賈后" },
    { L"賢后", L"賢后" },
    { L"賸余", L"賸餘" },
    { L"贝", L"貝" },
    { L"贞", L"貞" },
    { L"负", L"負" },
    { L"负债累累", L"負債纍纍" },
    { L"贡", L"貢" },
    { L"财", L"財" },
    { L"责", L"責" },
    { L"贤", L"賢" },
    { L"贤后", L"賢后" },
    { L"败", L"敗" },
    { L"账", L"賬" },
    { L"货", L"貨" },
    { L"质", L"質" },
    { L"质朴", L"質樸" },
    { L"贩", L"販" },
    { L"贪", L"貪" },
    { L"贪欲", L"貪慾" },
    { L"贫", L"貧" },
    { L"贬", L"貶" },
    { L"购", L"購" },
    { L"购买欲", L"購買慾" },
    { L"购并", L"購併" },
    { L"贮", L"貯" },
    { L"贯", L"貫" },
    { L"贰", L"貳" },
    { L"贱", L"賤" },
    { L"贲", L"賁" },
    { L"贳", L"貰" },
    { L"贴", L"貼" },
    { L"贵", L"貴" },
    { L"贵价", L"貴价" },
    { L"贵干", L"貴幹" },
    { L"贵征", L"貴徵" },
    { L"贶", L"貺" },
    { L"贷", L"貸" },
    { L"贸", L"貿" },
    { L"费", L"費" },
    { L"费占", L"費佔" },
    { L"贺", L"賀" },
    { L"贻", L"貽" },
    { L"贻范", L"貽範" },
    { L"贼", L"賊" },
    { L"贽", L"贄" },
    { L"贾", L"賈" },
    { L"贾后", L"賈后" },
    { L"贿", L"賄" },
    { L"赀", L"貲" },
    { L"赁", L"賃" },
    { L"赂", L"賂" },
    { L"赃", L"贓" },
    { L"资", L"資" },
    { L"赅", L"賅" },
    { L"赆", L"贐" },
    { L"赇", L"賕" },
    { L"赈", L"賑" },
    { L"赈饥", L"賑饑" },
    { L"赉", L"賚" },
    { L"赊", L"賒" },
    { L"赋", L"賦" },
    { L"赌", L"賭" },
    { L"赌台", L"賭檯" },
    { L"赌斗", L"賭鬥" },
    { L"赍", L"齎" },
    { L"赎", L"贖" },
    { L"赏", L"賞" },
    { L"赏赞", L"賞讚" },
    { L"赐", L"賜" },
    { L"赓", L"賡" },
    { L"赔", L"賠" },
    { L"赕", L"賧" },
    { L"赖", L"賴" },
    { L"赘", L"贅" },
    { L"赙", L"賻" },
    { L"赚", L"賺" },
    { L"赛", L"賽" },
    { L"赜", L"賾" },
    { L"赝", L"贗" },
    { L"赞", L"贊" },
    { L"赞不绝口", L"讚不絕口" },
    { L"赞乐", L"讚樂" },
    { L"赞佩", L"讚佩" },
    { L"赞叹", L"讚歎" },
    { L"赞叹不已", L"讚嘆不已" },
    { L"赞呗", L"讚唄" },
    { L"赞扬", L"讚揚" },
    { L"赞歌", L"讚歌" },
    { L"赞美", L"讚美" },
    { L"赞羡", L"讚羨" },
    { L"赞誉", L"讚譽" },
    { L"赞许", L"讚許" },
    { L"赞词", L"讚詞" },
    { L"赞赏", L"讚賞" },
    { L"赞辞", L"讚辭" },
    { L"赞颂", L"讚頌" },
    { L"赠", L"贈" },
    { L"赡", L"贍" },
    { L"赢", L"贏" },
    { L"赢余", L"贏餘" },
    { L"赣", L"贛" },
    { L"赤术", L"赤朮" },
    { L"赤绳系足", L"赤繩繫足" },
    { L"赵", L"趙" },
    { L"赵庄", L"趙莊" },
    { L"赵治勋", L"趙治勳" },
    { L"赶", L"趕" },
    { L"赶制", L"趕製" },
    { L"赶面棍", L"趕麵棍" },
    { L"起哄", L"起鬨" },
    { L"起复", L"起複" },
    { L"超级杯", L"超級盃" },
    { L"趋", L"趨" },
    { L"趱", L"趲" },
    { L"趱干", L"趲幹" },
    { L"趸", L"躉" },
    { L"跃", L"躍" },
    { L"跄", L"蹌" },
    { L"跌扑", L"跌扑" },
    { L"跌荡", L"跌蕩" },
    { L"跞", L"躒" },
    { L"路签", L"路籤" },
    { L"跳梁小丑", L"跳樑小丑" },
    { L"跳荡", L"跳蕩" },
    { L"跳表", L"跳錶" },
    { L"践", L"踐" },
    { L"跷", L"蹺" },
    { L"跸", L"蹕" },
    { L"跹", L"躚" },
    { L"跻", L"躋" },
    { L"踊", L"踴" },
    { L"踌", L"躊" },
    { L"踪", L"蹤" },
    { L"踬", L"躓" },
    { L"踯", L"躑" },
    { L"蹑", L"躡" },
    { L"蹒", L"蹣" },
    { L"蹰", L"躕" },
    { L"蹿", L"躥" },
    { L"躁郁", L"躁鬱" },
    { L"躏", L"躪" },
    { L"躜", L"躦" },
    { L"躯", L"軀" },
    { L"躯干", L"軀幹" },
    { L"车", L"車" },
    { L"车库里", L"車庫裡" },
    { L"车站里", L"車站裡" },
    { L"车里", L"車裡" },
    { L"轧", L"軋" },
    { L"轨", L"軌" },
    { L"轨范", L"軌範" },
    { L"轩", L"軒" },
    { L"轩辟", L"軒闢" },
    { L"轫", L"軔" },
    { L"转", L"轉" },
    { L"转台", L"轉檯" },
    { L"转托", L"轉託" },
    { L"转斗千里", L"轉鬥千里" },
    { L"轭", L"軛" },
    { L"轮", L"輪" },
    { L"轮回", L"輪迴" },
    { L"轮奸", L"輪姦" },
    { L"软", L"軟" },
    { L"轰", L"轟" },
    { L"轲", L"軻" },
    { L"轳", L"轤" },
    { L"轴", L"軸" },
    { L"轵", L"軹" },
    { L"轶", L"軼" },
    { L"轸", L"軫" },
    { L"轹", L"轢" },
    { L"轺", L"軺" },
    { L"轻", L"輕" },
    { L"轻松", L"輕鬆" },
    { L"轻轻松松", L"輕輕鬆鬆" },
    { L"轼", L"軾" },
    { L"载", L"載" },
    { L"轾", L"輊" },
    { L"轿", L"轎" },
    { L"辁", L"輇" },
    { L"辂", L"輅" },
    { L"较", L"較" },
    { L"辄", L"輒" },
    { L"辅", L"輔" },
    { L"辆", L"輛" },
    { L"辇", L"輦" },
    { L"辈", L"輩" },
    { L"辉", L"輝" },
    { L"辊", L"輥" },
    { L"辋", L"輞" },
    { L"辍", L"輟" },
    { L"辎", L"輜" },
    { L"辏", L"輳" },
    { L"辐", L"輻" },
    { L"辑", L"輯" },
    { L"输", L"輸" },
    { L"辔", L"轡" },
    { L"辕", L"轅" },
    { L"辖", L"轄" },
    { L"辗", L"輾" },
    { L"辘", L"轆" },
    { L"辙", L"轍" },
    { L"辚", L"轔" },
    { L"辞", L"辭" },
    { L"辞汇", L"辭彙" },
    { L"辟为", L"闢為" },
    { L"辟佛", L"闢佛" },
    { L"辟作", L"闢作" },
    { L"辟划", L"闢劃" },
    { L"辟土", L"闢土" },
    { L"辟地", L"闢地" },
    { L"辟室", L"闢室" },
    { L"辟建", L"闢建" },
    { L"辟田", L"闢田" },
    { L"辟筑", L"闢築" },
    { L"辟谣", L"闢謠" },
    { L"辟谷", L"辟穀" },
    { L"辟辟", L"闢辟" },
    { L"辟邪以律", L"闢邪以律" },
    { L"辩", L"辯" },
    { L"辩斗", L"辯鬥" },
    { L"辫", L"辮" },
    { L"辫发", L"辮髮" },
    { L"边", L"邊" },
    { L"辽", L"遼" },
    { L"辽沈", L"遼瀋" },
    { L"达", L"達" },
    { L"迁", L"遷" },
    { L"迂回", L"迂迴" },
    { L"过", L"過" },
    { L"过杆", L"過杆" },
    { L"过水面", L"過水麵" },
    { L"迈", L"邁" },
    { L"运", L"運" },
    { L"近日無仇", L"近日無讎" },
    { L"近日里", L"近日裡" },
    { L"返朴", L"返樸" },
    { L"还", L"還" },
    { L"还冲", L"還衝" },
    { L"还占", L"還佔" },
    { L"还采", L"還採" },
    { L"这", L"這" },
    { L"这么", L"這麼" },
    { L"这么着", L"這麼著" },
    { L"这伙人", L"這夥人" },
    { L"这只", L"這隻" },
    { L"这只采", L"這只採" },
    { L"这里", L"這裡" },
    { L"这钟", L"這鐘" },
    { L"进", L"進" },
    { L"进占", L"進佔" },
    { L"远", L"遠" },
    { L"远县才至", L"遠縣纔至" },
    { L"远游", L"遠遊" },
    { L"违", L"違" },
    { L"连", L"連" },
    { L"连三并四", L"連三併四" },
    { L"连占", L"連佔" },
    { L"连庄", L"連莊" },
    { L"连系", L"連繫" },
    { L"连采", L"連採" },
    { L"迟", L"遲" },
    { L"迥然回异", L"迥然迴異" },
    { L"迩", L"邇" },
    { L"迳", L"逕" },
    { L"迷幻药", L"迷幻藥" },
    { L"迷药", L"迷藥" },
    { L"迷蒙", L"迷濛" },
    { L"迷魂药", L"迷魂藥" },
    { L"迹", L"跡" },
    { L"追凶", L"追兇" },
    { L"退伙", L"退夥" },
    { L"退烧药", L"退燒藥" },
    { L"适", L"適" },
    { L"逆钟", L"逆鐘" },
    { L"选", L"選" },
    { L"逊", L"遜" },
    { L"逋发", L"逋髮" },
    { L"逍遥游", L"逍遙遊" },
    { L"透辟", L"透闢" },
    { L"递", L"遞" },
    { L"递回", L"遞迴" },
    { L"通历", L"通曆" },
    { L"通奸", L"通姦" },
    { L"通庄", L"通莊" },
    { L"通心面", L"通心麵" },
    { L"逞凶斗狠", L"逞兇鬥狠" },
    { L"逞凶鬥狠", L"逞兇鬥狠" },
    { L"造钟", L"造鐘" },
    { L"造钟表", L"造鐘錶" },
    { L"逦", L"邐" },
    { L"逻", L"邏" },
    { L"逼并", L"逼併" },
    { L"道范", L"道範" },
    { L"遗", L"遺" },
    { L"遗传钟", L"遺傳鐘" },
    { L"遗范", L"遺範" },
    { L"遗迹", L"遺迹" },
    { L"遥", L"遙" },
    { L"遨游", L"遨遊" },
    { L"遮丑", L"遮醜" },
    { L"避孕药", L"避孕藥" },
    { L"邀天之幸", L"邀天之倖" },
    { L"邋里邋遢", L"邋裡邋遢" },
    { L"邓", L"鄧" },
    { L"邝", L"鄺" },
    { L"那么", L"那麼" },
    { L"那么着", L"那麼著" },
    { L"那卷", L"那捲" },
    { L"那只", L"那隻" },
    { L"那里", L"那裡" },
    { L"邬", L"鄔" },
    { L"邮", L"郵" },
    { L"邹", L"鄒" },
    { L"邺", L"鄴" },
    { L"邻", L"鄰" },
    { L"郁伊", L"鬱伊" },
    { L"郁勃", L"鬱勃" },
    { L"郁卒", L"鬱卒" },
    { L"郁南", L"鬱南" },
    { L"郁垒", L"鬱壘" },
    { L"郁堙不偶", L"鬱堙不偶" },
    { L"郁塞", L"鬱塞" },
    { L"郁律", L"鬱律" },
    { L"郁悒", L"鬱悒" },
    { L"郁愤", L"鬱憤" },
    { L"郁抑", L"鬱抑" },
    { L"郁挹", L"鬱挹" },
    { L"郁朴", L"郁樸" },
    { L"郁林", L"鬱林" },
    { L"郁气", L"鬱氣" },
    { L"郁江", L"鬱江" },
    { L"郁沉沉", L"鬱沉沉" },
    { L"郁泱", L"鬱泱" },
    { L"郁火", L"鬱火" },
    { L"郁热", L"鬱熱" },
    { L"郁燠", L"鬱燠" },
    { L"郁症", L"鬱症" },
    { L"郁积", L"鬱積" },
    { L"郁纡", L"鬱紆" },
    { L"郁结", L"鬱結" },
    { L"郁蒸", L"鬱蒸" },
    { L"郁蓊", L"鬱蓊" },
    { L"郁血", L"鬱血" },
    { L"郁邑", L"鬱邑" },
    { L"郁郁", L"鬱郁" },
    { L"郁郁不乐", L"鬱鬱不樂" },
    { L"郁郁不平", L"鬱鬱不平" },
    { L"郁郁寡欢", L"鬱鬱寡歡" },
    { L"郁郁而终", L"鬱鬱而終" },
    { L"郁郁葱葱", L"鬱鬱蔥蔥" },
    { L"郁金", L"鬱金" },
    { L"郁闭", L"鬱閉" },
    { L"郁闷", L"鬱悶" },
    { L"郁陶", L"鬱陶" },
    { L"郁黑", L"鬱黑" },
    { L"郊游", L"郊遊" },
    { L"郏", L"郟" },
    { L"郐", L"鄶" },
    { L"郑", L"鄭" },
    { L"郑凯云", L"鄭凱云" },
    { L"郑庄公", L"鄭莊公" },
    { L"郓", L"鄆" },
    { L"郘钟", L"郘鐘" },
    { L"郦", L"酈" },
    { L"郧", L"鄖" },
    { L"郸", L"鄲" },
    { L"鄭凱云", L"鄭凱云" },
    { L"配制", L"配製" },
    { L"配水干管", L"配水幹管" },
    { L"配药", L"配藥" },
    { L"酒坛", L"酒罈" },
    { L"酒帘", L"酒帘" },
    { L"酒曲", L"酒麴" },
    { L"酒肴", L"酒肴" },
    { L"酒药", L"酒藥" },
    { L"酝", L"醞" },
    { L"酝酿着", L"醞釀著" },
    { L"酥松", L"酥鬆" },
    { L"酱", L"醬" },
    { L"酽", L"釅" },
    { L"酾", L"釃" },
    { L"酿", L"釀" },
    { L"酿制", L"釀製" },
    { L"醇朴", L"醇樸" },
    { L"醋坛", L"醋罈" },
    { L"采下", L"採下" },
    { L"采为", L"採為" },
    { L"采买", L"採買" },
    { L"采伐", L"採伐" },
    { L"采住", L"採住" },
    { L"采信", L"採信" },
    { L"采光", L"採光" },
    { L"采到", L"採到" },
    { L"采制", L"採制" },
    { L"采办", L"採辦" },
    { L"采区", L"採區" },
    { L"采去", L"採去" },
    { L"采取", L"採取" },
    { L"采回", L"採回" },
    { L"采在", L"採在" },
    { L"采好", L"採好" },
    { L"采录", L"採錄" },
    { L"采得", L"採得" },
    { L"采择", L"採擇" },
    { L"采拾", L"採拾" },
    { L"采挖", L"採挖" },
    { L"采掘", L"採掘" },
    { L"采摘", L"採摘" },
    { L"采摭", L"採摭" },
    { L"采撷", L"採擷" },
    { L"采收", L"採收" },
    { L"采料", L"採料" },
    { L"采暖", L"採暖" },
    { L"采树种", L"採樹種" },
    { L"采样", L"採樣" },
    { L"采桑", L"採桑" },
    { L"采樵人", L"採樵人" },
    { L"采气", L"採氣" },
    { L"采油", L"採油" },
    { L"采煤", L"採煤" },
    { L"采猎", L"採獵" },
    { L"采珠", L"採珠" },
    { L"采生折割", L"採生折割" },
    { L"采用", L"採用" },
    { L"采的", L"採的" },
    { L"采盐", L"採鹽" },
    { L"采石", L"採石" },
    { L"采矿", L"採礦" },
    { L"采砂场", L"採砂場" },
    { L"采种", L"採種" },
    { L"采空区", L"採空區" },
    { L"采空采穗", L"採空採穗" },
    { L"采納", L"採納" },
    { L"采纳", L"採納" },
    { L"采给", L"採給" },
    { L"采花", L"採花" },
    { L"采芹人", L"採芹人" },
    { L"采茶", L"採茶" },
    { L"采药", L"採藥" },
    { L"采莲", L"採蓮" },
    { L"采获", L"採獲" },
    { L"采菊", L"採菊" },
    { L"采薇", L"採薇" },
    { L"采薪", L"採薪" },
    { L"采行", L"採行" },
    { L"采补", L"採補" },
    { L"采访", L"採訪" },
    { L"采证", L"採證" },
    { L"采购", L"採購" },
    { L"采过", L"採過" },
    { L"采运", L"採運" },
    { L"采选", L"採選" },
    { L"采金", L"採金" },
    { L"采铁", L"採鐵" },
    { L"采集", L"採集" },
    { L"采风", L"採風" },
    { L"采食", L"採食" },
    { L"釉药", L"釉藥" },
    { L"释", L"釋" },
    { L"里勾外连", L"裡勾外連" },
    { L"里外", L"裡外" },
    { L"里头", L"裡頭" },
    { L"里层", L"裡層" },
    { L"里屋", L"裡屋" },
    { L"里布", L"裡布" },
    { L"里带", L"裡帶" },
    { L"里应外合", L"裡應外合" },
    { L"里弦", L"裡弦" },
    { L"里手", L"裏手" },
    { L"里海", L"裏海" },
    { L"里程表", L"里程錶" },
    { L"里脊", L"裡脊" },
    { L"里衣", L"裡衣" },
    { L"里边", L"裡邊" },
    { L"里通外国", L"裡通外國" },
    { L"里通外敌", L"裡通外敵" },
    { L"里间", L"裡間" },
    { L"里面", L"裡面" },
    { L"重划", L"重劃" },
    { L"重制", L"重製" },
    { L"重复", L"重複" },
    { L"重托", L"重託" },
    { L"重折", L"重摺" },
    { L"重游", L"重遊" },
    { L"重罗面", L"重羅麵" },
    { L"重锤", L"重鎚" },
    { L"野姜", L"野薑" },
    { L"野游", L"野遊" },
    { L"金仑溪", L"金崙溪" },
    { L"金发", L"金髮" },
    { L"金范", L"金範" },
    { L"金表", L"金錶" },
    { L"金装玉里", L"金裝玉裡" },
    { L"金钟", L"金鐘" },
    { L"金马仑道", L"金馬崙道" },
    { L"鉴", L"鑒" },
    { L"銮", L"鑾" },
    { L"錾", L"鏨" },
    { L"鎭", L"鎮" },
    { L"钆", L"釓" },
    { L"钇", L"釔" },
    { L"针", L"針" },
    { L"钉", L"釘" },
    { L"钉锤", L"釘鎚" },
    { L"钊", L"釗" },
    { L"钋", L"釙" },
    { L"钌", L"釕" },
    { L"钍", L"釷" },
    { L"钏", L"釧" },
    { L"钐", L"釤" },
    { L"钒", L"釩" },
    { L"钓", L"釣" },
    { L"钔", L"鍆" },
    { L"钕", L"釹" },
    { L"钗", L"釵" },
    { L"钙", L"鈣" },
    { L"钛", L"鈦" },
    { L"钜", L"鉅" },
    { L"钝", L"鈍" },
    { L"钞", L"鈔" },
    { L"钟", L"鍾" },
    { L"钟上", L"鐘上" },
    { L"钟下", L"鐘下" },
    { L"钟不", L"鐘不" },
    { L"钟乳洞", L"鐘乳洞" },
    { L"钟乳石", L"鐘乳石" },
    { L"钟体", L"鐘體" },
    { L"钟停", L"鐘停" },
    { L"钟关", L"鐘關" },
    { L"钟匠", L"鐘匠" },
    { L"钟发音", L"鐘發音" },
    { L"钟口", L"鐘口" },
    { L"钟响", L"鐘響" },
    { L"钟在寺里", L"鐘在寺裡" },
    { L"钟塔", L"鐘塔" },
    { L"钟壁", L"鐘壁" },
    { L"钟声", L"鐘聲" },
    { L"钟太", L"鐘太" },
    { L"钟头", L"鐘頭" },
    { L"钟好", L"鐘好" },
    { L"钟山", L"鐘山" },
    { L"钟左右", L"鐘左右" },
    { L"钟差", L"鐘差" },
    { L"钟座", L"鐘座" },
    { L"钟形", L"鐘形" },
    { L"钟律", L"鐘律" },
    { L"钟快", L"鐘快" },
    { L"钟意", L"鐘意" },
    { L"钟慢", L"鐘慢" },
    { L"钟摆", L"鐘擺" },
    { L"钟敲", L"鐘敲" },
    { L"钟有", L"鐘有" },
    { L"钟楼", L"鐘樓" },
    { L"钟模", L"鐘模" },
    { L"钟没", L"鐘沒" },
    { L"钟漏", L"鐘漏" },
    { L"钟点", L"鐘點" },
    { L"钟王", L"鐘王" },
    { L"钟琴", L"鐘琴" },
    { L"钟的", L"鐘的" },
    { L"钟盘", L"鐘盤" },
    { L"钟相", L"鐘相" },
    { L"钟磬", L"鐘磬" },
    { L"钟纽", L"鐘紐" },
    { L"钟罩", L"鐘罩" },
    { L"钟腰", L"鐘腰" },
    { L"钟螺", L"鐘螺" },
    { L"钟行", L"鐘行" },
    { L"钟表", L"鐘錶" },
    { L"钟表面", L"鐘表面" },
    { L"钟被", L"鐘被" },
    { L"钟调", L"鐘調" },
    { L"钟身", L"鐘身" },
    { L"钟速", L"鐘速" },
    { L"钟陈列", L"鐘陳列" },
    { L"钟面", L"鐘面" },
    { L"钟顶", L"鐘頂" },
    { L"钟鸣", L"鐘鳴" },
    { L"钟鼎", L"鐘鼎" },
    { L"钟鼓", L"鐘鼓" },
    { L"钠", L"鈉" },
    { L"钡", L"鋇" },
    { L"钢", L"鋼" },
    { L"钢制", L"鋼製" },
    { L"钢梁", L"鋼樑" },
    { L"钣", L"鈑" },
    { L"钤", L"鈐" },
    { L"钥", L"鑰" },
    { L"钦", L"欽" },
    { L"钧", L"鈞" },
    { L"钨", L"鎢" },
    { L"钩", L"鉤" },
    { L"钩心斗角", L"鈎心鬥角" },
    { L"钪", L"鈧" },
    { L"钫", L"鈁" },
    { L"钬", L"鈥" },
    { L"钭", L"鈄" },
    { L"钮", L"鈕" },
    { L"钯", L"鈀" },
    { L"钰", L"鈺" },
    { L"钱", L"錢" },
    { L"钱庄", L"錢莊" },
    { L"钱范", L"錢範" },
    { L"钱谷", L"錢穀" },
    { L"钲", L"鉦" },
    { L"钳", L"鉗" },
    { L"钴", L"鈷" },
    { L"钵", L"缽" },
    { L"钶", L"鈳" },
    { L"钸", L"鈽" },
    { L"钹", L"鈸" },
    { L"钺", L"鉞" },
    { L"钻", L"鑽" },
    { L"钼", L"鉬" },
    { L"钽", L"鉭" },
    { L"钾", L"鉀" },
    { L"钿", L"鈿" },
    { L"铀", L"鈾" },
    { L"铁", L"鐵" },
    { L"铁杆", L"鐵杆" },
    { L"铁钟", L"鐵鐘" },
    { L"铁锈", L"鐵鏽" },
    { L"铁锤", L"鐵鎚" },
    { L"铂", L"鉑" },
    { L"铃", L"鈴" },
    { L"铄", L"鑠" },
    { L"铅", L"鉛" },
    { L"铆", L"鉚" },
    { L"铈", L"鈰" },
    { L"铉", L"鉉" },
    { L"铊", L"鉈" },
    { L"铋", L"鉍" },
    { L"铌", L"鈮" },
    { L"铍", L"鈹" },
    { L"铎", L"鐸" },
    { L"铐", L"銬" },
    { L"铑", L"銠" },
    { L"铒", L"鉺" },
    { L"铕", L"銪" },
    { L"铖", L"鋮" },
    { L"铗", L"鋏" },
    { L"铙", L"鐃" },
    { L"铛", L"鐺" },
    { L"铜", L"銅" },
    { L"铜制", L"銅製" },
    { L"铜范", L"銅範" },
    { L"铜钟", L"銅鐘" },
    { L"铝", L"鋁" },
    { L"铝制", L"鋁製" },
    { L"铟", L"銦" },
    { L"铠", L"鎧" },
    { L"铡", L"鍘" },
    { L"铢", L"銖" },
    { L"铣", L"銑" },
    { L"铤", L"鋌" },
    { L"铥", L"銩" },
    { L"铧", L"鏵" },
    { L"铨", L"銓" },
    { L"铩", L"鎩" },
    { L"铪", L"鉿" },
    { L"铫", L"銚" },
    { L"铬", L"鉻" },
    { L"铭", L"銘" },
    { L"铮", L"錚" },
    { L"铯", L"銫" },
    { L"铯钟", L"銫鐘" },
    { L"铰", L"鉸" },
    { L"铱", L"銥" },
    { L"铲", L"鏟" },
    { L"铲出", L"剷出" },
    { L"铲刈", L"剷刈" },
    { L"铲头", L"剷頭" },
    { L"铲平", L"剷平" },
    { L"铲除", L"剷除" },
    { L"铳", L"銃" },
    { L"铴", L"鐋" },
    { L"铵", L"銨" },
    { L"银", L"銀" },
    { L"银发", L"銀髮" },
    { L"银朱", L"銀硃" },
    { L"铷", L"銣" },
    { L"铸", L"鑄" },
    { L"铸钟", L"鑄鐘" },
    { L"铹", L"鐒" },
    { L"铺", L"鋪" },
    { L"铺锦列绣", L"鋪錦列繡" },
    { L"铼", L"錸" },
    { L"铽", L"鋱" },
    { L"链", L"鏈" },
    { L"铿", L"鏗" },
    { L"销", L"銷" },
    { L"锁", L"鎖" },
    { L"锂", L"鋰" },
    { L"锄", L"鋤" },
    { L"锅", L"鍋" },
    { L"锅庄", L"鍋莊" },
    { L"锆", L"鋯" },
    { L"锇", L"鋨" },
    { L"锈", L"銹" },
    { L"锈病", L"鏽病" },
    { L"锈菌", L"鏽菌" },
    { L"锈蚀", L"鏽蝕" },
    { L"锉", L"銼" },
    { L"锊", L"鋝" },
    { L"锋", L"鋒" },
    { L"锌", L"鋅" },
    { L"锐", L"銳" },
    { L"锑", L"銻" },
    { L"锒", L"鋃" },
    { L"锓", L"鋟" },
    { L"锔", L"鋦" },
    { L"锕", L"錒" },
    { L"锖", L"錆" },
    { L"锗", L"鍺" },
    { L"错", L"錯" },
    { L"锚", L"錨" },
    { L"锛", L"錛" },
    { L"锞", L"錁" },
    { L"锟", L"錕" },
    { L"锡", L"錫" },
    { L"锢", L"錮" },
    { L"锣", L"鑼" },
    { L"锤", L"錘" },
    { L"锤儿", L"鎚兒" },
    { L"锤头", L"鎚頭" },
    { L"锤子", L"鎚子" },
    { L"锤炼", L"錘鍊" },
    { L"锥", L"錐" },
    { L"锦", L"錦" },
    { L"锦绣", L"錦繡" },
    { L"锨", L"杴" },
    { L"锩", L"錈" },
    { L"锬", L"錟" },
    { L"锭", L"錠" },
    { L"键", L"鍵" },
    { L"锯", L"鋸" },
    { L"锰", L"錳" },
    { L"锱", L"錙" },
    { L"锲", L"鍥" },
    { L"锲而不舍", L"鍥而不捨" },
    { L"锴", L"鍇" },
    { L"锵", L"鏘" },
    { L"锶", L"鍶" },
    { L"锷", L"鍔" },
    { L"锸", L"鍤" },
    { L"锹", L"鍬" },
    { L"锺", L"鍾" },
    { L"锻", L"鍛" },
    { L"锻炼出", L"鍛鍊出" },
    { L"锼", L"鎪" },
    { L"锾", L"鍰" },
    { L"镀", L"鍍" },
    { L"镁", L"鎂" },
    { L"镂", L"鏤" },
    { L"镄", L"鐨" },
    { L"镆", L"鏌" },
    { L"镇", L"鎮" },
    { L"镉", L"鎘" },
    { L"镊", L"鑷" },
    { L"镌", L"鐫" },
    { L"镍", L"鎳" },
    { L"镏", L"鎦" },
    { L"镐", L"鎬" },
    { L"镑", L"鎊" },
    { L"镒", L"鎰" },
    { L"镓", L"鎵" },
    { L"镔", L"鑌" },
    { L"镖", L"鏢" },
    { L"镗", L"鏜" },
    { L"镘", L"鏝" },
    { L"镙", L"鏍" },
    { L"镛", L"鏞" },
    { L"镜", L"鏡" },
    { L"镝", L"鏑" },
    { L"镞", L"鏃" },
    { L"镟", L"鏇" },
    { L"镡", L"鐔" },
    { L"镢", L"钁" },
    { L"镣", L"鐐" },
    { L"镤", L"鏷" },
    { L"镦", L"鐓" },
    { L"镧", L"鑭" },
    { L"镨", L"鐠" },
    { L"镪", L"鏹" },
    { L"镫", L"鐙" },
    { L"镬", L"鑊" },
    { L"镭", L"鐳" },
    { L"镯", L"鐲" },
    { L"镰", L"鐮" },
    { L"镰仓", L"鎌倉" },
    { L"镱", L"鐿" },
    { L"镳", L"鑣" },
    { L"镶", L"鑲" },
    { L"长", L"長" },
    { L"长几", L"長几" },
    { L"长历", L"長曆" },
    { L"长生药", L"長生藥" },
    { L"长胡", L"長鬍" },
    { L"门", L"門" },
    { L"门吊儿", L"門弔兒" },
    { L"门帘", L"門帘" },
    { L"门里", L"門裡" },
    { L"闩", L"閂" },
    { L"闪", L"閃" },
    { L"闫", L"閆" },
    { L"闭", L"閉" },
    { L"问", L"問" },
    { L"闯", L"闖" },
    { L"闯炼", L"闖鍊" },
    { L"闯荡", L"闖蕩" },
    { L"闰", L"閏" },
    { L"闱", L"闈" },
    { L"闲", L"閑" },
    { L"闲情逸致", L"閒情逸緻" },
    { L"闲游", L"閒遊" },
    { L"闲荡", L"閒蕩" },
    { L"闳", L"閎" },
    { L"间", L"間" },
    { L"间不容发", L"間不容髮" },
    { L"闵", L"閔" },
    { L"闵采尔", L"閔採爾" },
    { L"闶", L"閌" },
    { L"闷", L"悶" },
    { L"闷着头儿干", L"悶著頭兒幹" },
    { L"闸", L"閘" },
    { L"闹", L"鬧" },
    { L"闹着玩儿", L"鬧著玩兒" },
    { L"闹表", L"鬧錶" },
    { L"闹钟", L"鬧鐘" },
    { L"闺", L"閨" },
    { L"闺范", L"閨範" },
    { L"闻", L"聞" },
    { L"闼", L"闥" },
    { L"闽", L"閩" },
    { L"闾", L"閭" },
    { L"阀", L"閥" },
    { L"阁", L"閣" },
    { L"阂", L"閡" },
    { L"阃", L"閫" },
    { L"阃范", L"閫範" },
    { L"阄", L"鬮" },
    { L"阅", L"閱" },
    { L"阆", L"閬" },
    { L"阈", L"閾" },
    { L"阉", L"閹" },
    { L"阊", L"閶" },
    { L"阋", L"鬩" },
    { L"阌", L"閿" },
    { L"阍", L"閽" },
    { L"阎", L"閻" },
    { L"阏", L"閼" },
    { L"阐", L"闡" },
    { L"阑", L"闌" },
    { L"阒", L"闃" },
    { L"阔", L"闊" },
    { L"阕", L"闋" },
    { L"阖", L"闔" },
    { L"阗", L"闐" },
    { L"阙", L"闕" },
    { L"阚", L"闞" },
    { L"队", L"隊" },
    { L"防台", L"防颱" },
    { L"防御", L"防禦" },
    { L"防晒", L"防晒" },
    { L"防水表", L"防水錶" },
    { L"防范", L"防範" },
    { L"防锈", L"防鏽" },
    { L"阳", L"陽" },
    { L"阳历", L"陽曆" },
    { L"阳春面", L"陽春麵" },
    { L"阴", L"陰" },
    { L"阴历", L"陰曆" },
    { L"阴干", L"陰乾" },
    { L"阴沟里翻船", L"陰溝裡翻船" },
    { L"阴郁", L"陰鬱" },
    { L"阵", L"陣" },
    { L"阶", L"階" },
    { L"阿呆", L"阿獃" },
    { L"附注", L"附註" },
    { L"际", L"際" },
    { L"陆", L"陸" },
    { L"陆游", L"陸遊" },
    { L"陇", L"隴" },
    { L"陈", L"陳" },
    { L"陈炼", L"陳鍊" },
    { L"陉", L"陘" },
    { L"降压药", L"降壓藥" },
    { L"陕", L"陝" },
    { L"除臭药", L"除臭藥" },
    { L"陧", L"隉" },
    { L"陨", L"隕" },
    { L"险", L"險" },
    { L"陪吊", L"陪弔" },
    { L"隆准", L"隆準" },
    { L"随", L"隨" },
    { L"隐", L"隱" },
    { L"隐几", L"隱几" },
    { L"隐占", L"隱佔" },
    { L"隶", L"隸" },
    { L"隽", L"雋" },
    { L"难", L"難" },
    { L"难舍", L"難捨" },
    { L"雅致", L"雅緻" },
    { L"雅范", L"雅範" },
    { L"集游法", L"集遊法" },
    { L"雇主", L"僱主" },
    { L"雇人", L"僱人" },
    { L"雇佣", L"僱傭" },
    { L"雇农", L"僱農" },
    { L"雇到", L"僱到" },
    { L"雇员", L"僱員" },
    { L"雇工", L"僱工" },
    { L"雇用", L"僱用" },
    { L"雏", L"雛" },
    { L"雕心雁爪", L"鵰心雁爪" },
    { L"雕悍", L"鵰悍" },
    { L"雕梁画栋", L"雕樑畫棟" },
    { L"雕翎", L"鵰翎" },
    { L"雕鹗", L"鵰鶚" },
    { L"雠", L"讎" },
    { L"雪窗萤几", L"雪窗螢几" },
    { L"雪里", L"雪裡" },
    { L"雳", L"靂" },
    { L"零余", L"零餘" },
    { L"零只", L"零隻" },
    { L"雾", L"霧" },
    { L"雾里", L"霧裡" },
    { L"霁", L"霽" },
    { L"霁范", L"霽範" },
    { L"震栗", L"震慄" },
    { L"震荡", L"震蕩" },
    { L"霉毒", L"黴毒" },
    { L"霉素", L"黴素" },
    { L"霉菌", L"黴菌" },
    { L"霉黑", L"黴黑" },
    { L"霉黧", L"黴黧" },
    { L"霭", L"靄" },
    { L"露丑", L"露醜" },
    { L"霸占", L"霸佔" },
    { L"青山一发", L"青山一髮" },
    { L"青苹", L"青苹" },
    { L"青霉", L"青黴" },
    { L"靓", L"靚" },
    { L"静", L"靜" },
    { L"非占不可", L"非佔不可" },
    { L"面临着", L"面臨著" },
    { L"面人儿", L"麵人兒" },
    { L"面价", L"麵價" },
    { L"面包", L"麵包" },
    { L"面包扎", L"面包紮" },
    { L"面包着", L"面包著" },
    { L"面厂", L"麵廠" },
    { L"面团", L"麵糰" },
    { L"面坊", L"麵坊" },
    { L"面坯儿", L"麵坯兒" },
    { L"面塑", L"麵塑" },
    { L"面店", L"麵店" },
    { L"面摊", L"麵攤" },
    { L"面朝着", L"面朝著" },
    { L"面杖", L"麵杖" },
    { L"面条", L"麵條" },
    { L"面汤", L"麵湯" },
    { L"面浆", L"麵漿" },
    { L"面灰", L"麵灰" },
    { L"面疙瘩", L"麵疙瘩" },
    { L"面皮", L"麵皮" },
    { L"面码儿", L"麵碼兒" },
    { L"面筋", L"麵筋" },
    { L"面粉", L"麵粉" },
    { L"面糊", L"麵糊" },
    { L"面线", L"麵線" },
    { L"面缸", L"麵缸" },
    { L"面茶", L"麵茶" },
    { L"面食", L"麵食" },
    { L"面食面", L"面食麵" },
    { L"面饺", L"麵餃" },
    { L"面饼", L"麵餅" },
    { L"面馆", L"麵館" },
    { L"靥", L"靨" },
    { L"鞋里", L"鞋裡" },
    { L"鞑", L"韃" },
    { L"鞣制", L"鞣製" },
    { L"鞭辟入里", L"鞭辟入裡" },
    { L"鞯", L"韉" },
    { L"鞲", L"韝" },
    { L"韦", L"韋" },
    { L"韦庄", L"韋莊" },
    { L"韧", L"韌" },
    { L"韩", L"韓" },
    { L"韩制", L"韓製" },
    { L"韩国制", L"韓國製" },
    { L"韪", L"韙" },
    { L"韫", L"韞" },
    { L"韬", L"韜" },
    { L"音准", L"音準" },
    { L"音声如钟", L"音聲如鐘" },
    { L"韵", L"韻" },
    { L"页", L"頁" },
    { L"顶", L"頂" },
    { L"顷", L"頃" },
    { L"顸", L"頇" },
    { L"项", L"項" },
    { L"项庄", L"項莊" },
    { L"顺", L"順" },
    { L"顺钟向", L"順鐘向" },
    { L"须", L"須" },
    { L"须发", L"鬚髮" },
    { L"须根", L"鬚根" },
    { L"须毛", L"鬚毛" },
    { L"须生", L"鬚生" },
    { L"须眉", L"鬚眉" },
    { L"须胡", L"鬚鬍" },
    { L"须须", L"鬚鬚" },
    { L"须鲨", L"鬚鯊" },
    { L"须鲸", L"鬚鯨" },
    { L"顼", L"頊" },
    { L"顽", L"頑" },
    { L"顾", L"顧" },
    { L"顿", L"頓" },
    { L"颀", L"頎" },
    { L"颁", L"頒" },
    { L"颂", L"頌" },
    { L"颂系", L"頌繫" },
    { L"颂赞", L"頌讚" },
    { L"颃", L"頏" },
    { L"预", L"預" },
    { L"预制", L"預製" },
    { L"颅", L"顱" },
    { L"领", L"領" },
    { L"领域里", L"領域裡" },
    { L"领袖欲", L"領袖慾" },
    { L"颇", L"頗" },
    { L"颈", L"頸" },
    { L"颉", L"頡" },
    { L"颊", L"頰" },
    { L"颊须", L"頰鬚" },
    { L"颌", L"頜" },
    { L"颍", L"潁" },
    { L"颏", L"頦" },
    { L"颐", L"頤" },
    { L"频", L"頻" },
    { L"颓", L"頹" },
    { L"颔", L"頷" },
    { L"颖", L"穎" },
    { L"颗", L"顆" },
    { L"题", L"題" },
    { L"题签", L"題籤" },
    { L"颚", L"顎" },
    { L"颛", L"顓" },
    { L"颜", L"顏" },
    { L"颜范", L"顏範" },
    { L"额", L"額" },
    { L"额征", L"額徵" },
    { L"额我略历", L"額我略曆" },
    { L"颞", L"顳" },
    { L"颟", L"顢" },
    { L"颠", L"顛" },
    { L"颠干倒坤", L"顛乾倒坤" },
    { L"颡", L"顙" },
    { L"颢", L"顥" },
    { L"颤", L"顫" },
    { L"颤栗", L"顫慄" },
    { L"颦", L"顰" },
    { L"颧", L"顴" },
    { L"风", L"風" },
    { L"风卷残云", L"風捲殘雲" },
    { L"风后", L"風后" },
    { L"风土志", L"風土誌" },
    { L"风干", L"風乾" },
    { L"风物志", L"風物誌" },
    { L"风范", L"風範" },
    { L"风起云涌", L"風起雲湧" },
    { L"风里", L"風裡" },
    { L"飑", L"颮" },
    { L"飒", L"颯" },
    { L"飓", L"颶" },
    { L"飕", L"颼" },
    { L"飘", L"飄" },
    { L"飘游", L"飄遊" },
    { L"飘荡", L"飄蕩" },
    { L"飘飘荡荡", L"飄飄蕩蕩" },
    { L"飙", L"飆" },
    { L"飞", L"飛" },
    { L"飞刍挽粟", L"飛芻輓粟" },
    { L"飞扎", L"飛紮" },
    { L"飞行钟", L"飛行鐘" },
    { L"食欲", L"食慾" },
    { L"食野之苹", L"食野之苹" },
    { L"食面", L"食麵" },
    { L"飨", L"饗" },
    { L"餍", L"饜" },
    { L"饥", L"飢" },
    { L"饥寒", L"饑寒" },
    { L"饥民", L"饑民" },
    { L"饥渴", L"饑渴" },
    { L"饥溺", L"饑溺" },
    { L"饥荒", L"饑荒" },
    { L"饥饱", L"饑飽" },
    { L"饥馑", L"饑饉" },
    { L"饧", L"餳" },
    { L"饨", L"飩" },
    { L"饩", L"餼" },
    { L"饪", L"飪" },
    { L"饫", L"飫" },
    { L"饬", L"飭" },
    { L"饭", L"飯" },
    { L"饭后钟", L"飯後鐘" },
    { L"饭团", L"飯糰" },
    { L"饭庄", L"飯莊" },
    { L"饮", L"飲" },
    { L"饯", L"餞" },
    { L"饰", L"飾" },
    { L"饱", L"飽" },
    { L"饲", L"飼" },
    { L"饲喂", L"飼餵" },
    { L"饴", L"飴" },
    { L"饵", L"餌" },
    { L"饶", L"饒" },
    { L"饷", L"餉" },
    { L"饺", L"餃" },
    { L"饼", L"餅" },
    { L"饼干", L"餅乾" },
    { L"饽", L"餑" },
    { L"饿", L"餓" },
    { L"馀", L"餘" },
    { L"馁", L"餒" },
    { L"馄", L"餛" },
    { L"馄饨面", L"餛飩麵" },
    { L"馅", L"餡" },
    { L"馆", L"館" },
    { L"馆谷", L"館穀" },
    { L"馆里", L"館裡" },
    { L"馈", L"饋" },
    { L"馊", L"餿" },
    { L"馋", L"饞" },
    { L"馍", L"饃" },
    { L"馏", L"餾" },
    { L"馐", L"饈" },
    { L"馑", L"饉" },
    { L"馒", L"饅" },
    { L"馔", L"饌" },
    { L"首只", L"首隻" },
    { L"首当其冲", L"首當其衝" },
    { L"香干", L"香乾" },
    { L"马", L"馬" },
    { L"马干", L"馬乾" },
    { L"马杆", L"馬杆" },
    { L"马表", L"馬錶" },
    { L"驭", L"馭" },
    { L"驮", L"馱" },
    { L"驯", L"馴" },
    { L"驰", L"馳" },
    { L"驱", L"驅" },
    { L"驳", L"駁" },
    { L"驴", L"驢" },
    { L"驵", L"駔" },
    { L"驶", L"駛" },
    { L"驷", L"駟" },
    { L"驸", L"駙" },
    { L"驹", L"駒" },
    { L"驺", L"騶" },
    { L"驻", L"駐" },
    { L"驻扎", L"駐紮" },
    { L"驼", L"駝" },
    { L"驽", L"駑" },
    { L"驾", L"駕" },
    { L"驿", L"驛" },
    { L"骀", L"駘" },
    { L"骀荡", L"駘蕩" },
    { L"骁", L"驍" },
    { L"骂", L"罵" },
    { L"骂着", L"罵著" },
    { L"骄", L"驕" },
    { L"骅", L"驊" },
    { L"骆", L"駱" },
    { L"骇", L"駭" },
    { L"骈", L"駢" },
    { L"骊", L"驪" },
    { L"骋", L"騁" },
    { L"验", L"驗" },
    { L"骏", L"駿" },
    { L"骐", L"騏" },
    { L"骑", L"騎" },
    { L"骒", L"騍" },
    { L"骓", L"騅" },
    { L"骖", L"驂" },
    { L"骗", L"騙" },
    { L"骘", L"騭" },
    { L"骚", L"騷" },
    { L"骛", L"騖" },
    { L"骜", L"驁" },
    { L"骝", L"騮" },
    { L"骞", L"騫" },
    { L"骟", L"騸" },
    { L"骠", L"驃" },
    { L"骡", L"騾" },
    { L"骢", L"驄" },
    { L"骣", L"驏" },
    { L"骤", L"驟" },
    { L"骥", L"驥" },
    { L"骧", L"驤" },
    { L"骨坛", L"骨罈" },
    { L"骨子里", L"骨子裡" },
    { L"骨干", L"骨幹" },
    { L"骨灰坛", L"骨灰罈" },
    { L"髅", L"髏" },
    { L"髋", L"髖" },
    { L"髌", L"髕" },
    { L"高几", L"高几" },
    { L"高干", L"高幹" },
    { L"高清愿", L"高清愿" },
    { L"髡发", L"髡髮" },
    { L"髭胡", L"髭鬍" },
    { L"髭须", L"髭鬚" },
    { L"髯胡", L"髯鬍" },
    { L"髼松", L"髼鬆" },
    { L"鬅松", L"鬅鬆" },
    { L"鬈发", L"鬈髮" },
    { L"鬒发", L"鬒髮" },
    { L"鬓", L"鬢" },
    { L"鬓发", L"鬢髮" },
    { L"魂牵梦系", L"魂牽夢繫" },
    { L"魇", L"魘" },
    { L"魉", L"魎" },
    { L"魏征", L"魏徵" },
    { L"魔表", L"魔錶" },
    { L"鱼", L"魚" },
    { L"鱼干", L"魚乾" },
    { L"鱼松", L"魚鬆" },
    { L"鱿", L"魷" },
    { L"鲁", L"魯" },
    { L"鲂", L"魴" },
    { L"鲆", L"鮃" },
    { L"鲇", L"鯰" },
    { L"鲈", L"鱸" },
    { L"鲋", L"鮒" },
    { L"鲍", L"鮑" },
    { L"鲎", L"鱟" },
    { L"鲐", L"鮐" },
    { L"鲑", L"鮭" },
    { L"鲒", L"鮚" },
    { L"鲔", L"鮪" },
    { L"鲕", L"鮞" },
    { L"鲚", L"鱭" },
    { L"鲛", L"鮫" },
    { L"鲜", L"鮮" },
    { L"鲞", L"鯗" },
    { L"鲟", L"鱘" },
    { L"鲠", L"鯁" },
    { L"鲡", L"鱺" },
    { L"鲢", L"鰱" },
    { L"鲣", L"鰹" },
    { L"鲤", L"鯉" },
    { L"鲥", L"鰣" },
    { L"鲦", L"鰷" },
    { L"鲧", L"鯀" },
    { L"鲨", L"鯊" },
    { L"鲩", L"鯇" },
    { L"鲫", L"鯽" },
    { L"鲭", L"鯖" },
    { L"鲮", L"鯪" },
    { L"鲰", L"鯫" },
    { L"鲱", L"鯡" },
    { L"鲲", L"鯤" },
    { L"鲳", L"鯧" },
    { L"鲵", L"鯢" },
    { L"鲶", L"鯰" },
    { L"鲷", L"鯛" },
    { L"鲸", L"鯨" },
    { L"鲸须", L"鯨鬚" },
    { L"鲻", L"鯔" },
    { L"鲽", L"鰈" },
    { L"鳃", L"鰓" },
    { L"鳄", L"鱷" },
    { L"鳅", L"鰍" },
    { L"鳆", L"鰒" },
    { L"鳇", L"鰉" },
    { L"鳌", L"鰲" },
    { L"鳍", L"鰭" },
    { L"鳎", L"鰨" },
    { L"鳏", L"鰥" },
    { L"鳐", L"鰩" },
    { L"鳓", L"鰳" },
    { L"鳔", L"鰾" },
    { L"鳕", L"鱈" },
    { L"鳖", L"鱉" },
    { L"鳗", L"鰻" },
    { L"鳜", L"鱖" },
    { L"鳝", L"鱔" },
    { L"鳞", L"鱗" },
    { L"鳟", L"鱒" },
    { L"鳢", L"鱧" },
    { L"鸟", L"鳥" },
    { L"鸠", L"鳩" },
    { L"鸠占鹊巢", L"鳩佔鵲巢" },
    { L"鸡", L"雞" },
    { L"鸡丝面", L"雞絲麵" },
    { L"鸡争鹅斗", L"雞爭鵝鬥" },
    { L"鸡只", L"雞隻" },
    { L"鸡吵鹅斗", L"雞吵鵝鬥" },
    { L"鸡奸", L"雞姦" },
    { L"鸡腿面", L"雞腿麵" },
    { L"鸡蛋里挑骨头", L"雞蛋裡挑骨頭" },
    { L"鸢", L"鳶" },
    { L"鸣", L"鳴" },
    { L"鸣钟", L"鳴鐘" },
    { L"鸥", L"鷗" },
    { L"鸦", L"鴉" },
    { L"鸨", L"鴇" },
    { L"鸩", L"鴆" },
    { L"鸪", L"鴣" },
    { L"鸫", L"鶇" },
    { L"鸬", L"鸕" },
    { L"鸭", L"鴨" },
    { L"鸯", L"鴦" },
    { L"鸱", L"鴟" },
    { L"鸲", L"鴝" },
    { L"鸳", L"鴛" },
    { L"鸵", L"鴕" },
    { L"鸶", L"鷥" },
    { L"鸷", L"鷙" },
    { L"鸸", L"鴯" },
    { L"鸹", L"鴰" },
    { L"鸺", L"鵂" },
    { L"鸽", L"鴿" },
    { L"鸾", L"鸞" },
    { L"鸿", L"鴻" },
    { L"鸿案相庄", L"鴻案相莊" },
    { L"鸿篇巨制", L"鴻篇巨製" },
    { L"鸿范", L"鴻範" },
    { L"鹁", L"鵓" },
    { L"鹂", L"鸝" },
    { L"鹃", L"鵑" },
    { L"鹄", L"鵠" },
    { L"鹄发", L"鵠髮" },
    { L"鹅", L"鵝" },
    { L"鹅准", L"鵝準" },
    { L"鹆", L"鵒" },
    { L"鹇", L"鷳" },
    { L"鹈", L"鵜" },
    { L"鹉", L"鵡" },
    { L"鹊", L"鵲" },
    { L"鹌", L"鵪" },
    { L"鹎", L"鵯" },
    { L"鹏", L"鵬" },
    { L"鹑", L"鶉" },
    { L"鹕", L"鶘" },
    { L"鹗", L"鶚" },
    { L"鹘", L"鶻" },
    { L"鹚", L"鶿" },
    { L"鹜", L"鶩" },
    { L"鹞", L"鷂" },
    { L"鹣", L"鶼" },
    { L"鹤", L"鶴" },
    { L"鹤发", L"鶴髮" },
    { L"鹤吊", L"鶴弔" },
    { L"鹦", L"鸚" },
    { L"鹧", L"鷓" },
    { L"鹨", L"鷚" },
    { L"鹩", L"鷯" },
    { L"鹪", L"鷦" },
    { L"鹫", L"鷲" },
    { L"鹬", L"鷸" },
    { L"鹭", L"鷺" },
    { L"鹰", L"鷹" },
    { L"鹰雕", L"鹰鵰" },
    { L"鹳", L"鸛" },
    { L"鹾", L"鹺" },
    { L"麦", L"麥" },
    { L"麸", L"麩" },
    { L"麻药", L"麻藥" },
    { L"麻酱面", L"麻醬麵" },
    { L"麻醉药", L"麻醉藥" },
    { L"黃鈺筑", L"黃鈺筑" },
    { L"黄", L"黃" },
    { L"黄历", L"黃曆" },
    { L"黄发", L"黃髮" },
    { L"黄干黑瘦", L"黃乾黑瘦" },
    { L"黄曲毒素", L"黃麴毒素" },
    { L"黄钟", L"黃鐘" },
    { L"黄钰筑", L"黃鈺筑" },
    { L"黉", L"黌" },
    { L"黑发", L"黑髮" },
    { L"黩", L"黷" },
    { L"黪", L"黲" },
    { L"黾", L"黽" },
    { L"鼋", L"黿" },
    { L"鼍", L"鼉" },
    { L"鼓里", L"鼓裡" },
    { L"鼗", L"鞀" },
    { L"鼠曲草", L"鼠麴草" },
    { L"鼠药", L"鼠藥" },
    { L"鼹", L"鼴" },
    { L"鼻准", L"鼻準" },
    { L"鼻梁", L"鼻樑" },
    { L"齄", L"齇" },
    { L"齐", L"齊" },
    { L"齐庄", L"齊莊" },
    { L"齐王舍牛", L"齊王捨牛" },
    { L"齑", L"齏" },
    { L"齿", L"齒" },
    { L"齿危发秀", L"齒危髮秀" },
    { L"齿发", L"齒髮" },
    { L"龀", L"齔" },
    { L"龃", L"齟" },
    { L"龄", L"齡" },
    { L"龅", L"齙" },
    { L"龆", L"齠" },
    { L"龇", L"齜" },
    { L"龈", L"齦" },
    { L"龉", L"齬" },
    { L"龊", L"齪" },
    { L"龋", L"齲" },
    { L"龌", L"齷" },
    { L"龙", L"龍" },
    { L"龙卷", L"龍捲" },
    { L"龙斗虎伤", L"龍鬥虎傷" },
    { L"龙须", L"龍鬚" },
    { L"龚", L"龔" },
    { L"龛", L"龕" },
    { L"龟", L"龜" },
};
#define SIMP_TO_TRAD_MAX_LEN (6)
